Require Import POtype.
Require Import Compare_dec.
Require Import NatUtil.
Require Omega.

Set Implicit Arguments.


Module POnat <: POtype.

  Definition A := nat.
  
  Definition LT a b := (a < b).
  Definition compareDec := lt_eq_lt_dec.

  Lemma eqNotLT : forall a b, a = b -> a < b -> False.
  Proof.
    intros; omega.
  Qed.

  Lemma LTNotEq : forall a b, a < b -> a = b -> False.
  Proof.
    intros; omega.
  Qed.

  Lemma LTNotGT : forall a b, a < b -> b < a -> False.
  Proof.
    intros; omega.
  Qed.

  Lemma LTtrans : forall a b c, a < b -> b < c -> a < c.
  Proof.
    intros; omega.
  Qed.

  Definition eqDec := natEqDec.

End POnat.


Module OneTypeNat <: OneType.
  Definition B := nat.
End OneTypeNat.


