Set Implicit Arguments.

Module Type POtype.

  Parameter A : Set.
  Parameter LT : A -> A -> Prop.

  Parameter compareDec : forall a b, {LT a b} + {a = b} + {LT b a}.

  Parameter eqNotLT : forall a b, a = b -> LT a b -> False.
  Parameter LTNotEq : forall a b, LT a b -> a = b -> False.
  Parameter LTNotGT : forall a b, LT a b -> LT b a -> False.
  Parameter LTtrans : forall a b c, LT a b -> LT b c -> LT a c.

  (* while this is admissible from the above, this allows a separate
    computable definition to be used *)
  Parameter eqDec : forall (a b:A), {a = b} + {a <> b}.

End POtype.


Module Type OneType.
  Parameter B : Set.
End OneType.
