Require Import BakerLemma.
Require Import Baker.


Lemma bakerLoopNoFlip : forall toStart scan free alloc toEnd frStart frEnd,
  aligned8 toStart scan ->
  aligned8 scan free ->
  aligned8 free alloc ->
  aligned8 alloc toEnd ->
  aligned8 frStart frEnd -> 
  forall W M phi,
    set_eqv (W |_| M) (rangeObjs frStart frEnd) ->
    iso_set phi M (rangeObjs toStart scan |_| rangeObjs scan free) ->
    forall s,
    okFieldVal (rangeObjs toStart scan |_| rangeObjs scan free |_| rangeObjs alloc toEnd) 
    (rget s rroot) -> 
    s |||- 24 + rget s rgcInfo |-> alloc **
      20 + rget s rgcInfo |-> free **
      16 + rget s rgcInfo |-> scan **
      12 + rget s rgcInfo |-> toEnd **
      8 + rget s rgcInfo |-> toStart **
      4 + rget s rgcInfo |-> frEnd **
      rget s rgcInfo |-> frStart **
      mapHp M phi **
      objHp (W |_| M) W **
      objHp (rangeObjs toStart scan |_| rangeObjs scan free |_| rangeObjs alloc toEnd)
        (rangeObjs toStart scan |_| rangeObjs alloc toEnd) **
      objHp ((W |_| M) |_| rangeObjs toStart scan |_| rangeObjs scan free |_| rangeObjs alloc toEnd)
        (rangeObjs scan free) **
        (foralls x in rangeObjs free alloc, x |->__) ** top ->
   free <> alloc ->
   bakerLoopPre
     (rset (rset (rset (rset (rset (rset (rset (rset (rset s rfrStart frStart) rfrEnd frEnd)
       rtoStart toStart) rtoEnd toEnd) rscan scan) rfree free) ralloc alloc) 
     rcount 0) raSave (rget s ra)) /\
   (forall s',
    bakerLoopGuar
      (rset (rset (rset (rset (rset (rset (rset (rset (rset s rfrStart frStart) rfrEnd frEnd)
	rtoStart toStart) rtoEnd toEnd) rscan scan) rfree free) ralloc alloc) rcount 0) raSave 
      (rget s ra)) s' -> bakerAllocGuar s s').
Proof.
  intros toStart scan free alloc toEnd frStart frEnd.
  intros Al1 Al2 Al3 Al4 Al5 W M phi WMeq Iso0 s rootOk0 Hp0 Ne.

  set (cpObjs := rangeObjs toStart free).

  assert (rangeMerge1 : set_eqv (rangeObjs toStart scan |_| rangeObjs scan free) cpObjs).
    clear Hp0; subst cpObjs.
    assert (LE : scan <= free).
    destruct Al2; omega.
    rewrite (rangeObjsTransEqv Al1 LE); apply set_eqvRefl.

  assert (Iso : iso_set phi M cpObjs).
    rewrite <- rangeMerge1; assumption.

  set (toObjs := cpObjs |_| rangeObjs alloc toEnd).

  assert (rootOk : okFieldVal toObjs (rget s rroot)).
    subst toObjs; rewrite <- rangeMerge1; rewrite (set_eqvUnionAssoc (rangeObjs toStart scan)
      (rangeObjs scan free) (rangeObjs alloc toEnd)); assumption.

  clear Iso0 rootOk0.
  set (B := rangeObjs toStart scan |_| rangeObjs alloc toEnd).
  set (G := rangeObjs scan free).
  set (frObjs := W |_| M).
  set (F := rangeObjs free alloc).

  assert (Hp : s
    |||- 24 + rget s rgcInfo |-> alloc **
      20 + rget s rgcInfo |-> free **
      16 + rget s rgcInfo |-> scan **
      12 + rget s rgcInfo |-> toEnd **
      8 + rget s rgcInfo |-> toStart **
      4 + rget s rgcInfo |-> frEnd **
      rget s rgcInfo |-> frStart **
      mapHp M phi **
      objHp frObjs W **
      objHp toObjs B **
      objHp (frObjs |_| toObjs) G **
      (foralls x in F, x |->__) ** top).
  subst frObjs toObjs B cpObjs.
  apply (sconjImplR Hp0); clear Hp0; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite <- rangeMerge1.
  rewrite (set_eqvUnionAssoc (rangeObjs toStart scan) (rangeObjs scan free)
    (rangeObjs alloc toEnd)); assumption.
  apply (sconjImplL Hp); clear h Hp; intros h Hp.
  subst G; unfold hpredTrue; rewrite <- rangeMerge1.
  rewrite (set_eqvUnionAssoc (rangeObjs toStart scan) (rangeObjs scan free)
    (rangeObjs alloc toEnd)); assumption.

  assert (toEq : set_eqv (rangeObjs toStart toEnd) ((B |_| G) |_| F)).
  subst B.
  rewrite (set_eqvUnionSymm (rangeObjs toStart scan) (rangeObjs alloc toEnd)).
  rewrite (set_eqvUnionAssoc (rangeObjs alloc toEnd) (rangeObjs toStart scan) G).
  subst G; rewrite rangeMerge1.
  rewrite (set_eqvUnionAssoc (rangeObjs alloc toEnd) cpObjs F); subst cpObjs F.
  assert (X : aligned8 toStart free).
  eapply aligned8Trans; eauto.
  assert (LE : free <= alloc).
  destruct Al3; omega.
  rewrite (rangeObjsTransEqv X LE).
  rewrite (set_eqvUnionSymm (rangeObjs alloc toEnd) (rangeObjs toStart alloc)).
  assert (Le' : alloc <= toEnd).
  destruct Al4; omega.
  assert (AlX : aligned8 toStart alloc).
  eapply aligned8Trans; eauto.
  rewrite (rangeObjsTransEqv AlX Le'); apply set_eqvRefl.

  assert (spD : set_disj (setRange frStart frEnd) (setRange toStart toEnd)).
  eapply disjObjsDisjRange.
  instantiate (1 := heapOf s).
  sconjLift8 Hp; sconjLift9 Hp; hypReplace Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear Hp; intros h Hp.
  assert (X : h ||- (foralls z in W, z |->__) ** (foralls z in M, z |->__)).
  sconjMatch.
  exact (objHpIsObjs Hp).
  exact (mapHpIsObjs Hp).
  unfold hpredTrue; rewrite <- WMeq; apply fasMerge.
  assumption.
  apply (fasFasDisj' X); intros hh x Hp'; lle Hp'; lli; sconjMatch.
  hypReplace Hp (sconjAssocR Hp); sconjLift9 Hp; sconjLift9 Hp; sconjLift9 Hp.
  hypReplace Hp (sconjAssocR Hp); hypReplace Hp (sconjAssocR Hp).
  sconjMatch.
  unfold hpredTrue; setoid_replace (rangeObjs toStart toEnd) with ((B |_| G) |_| F).
  2:assumption.
  assert (Hp' : h ||- ((foralls x in B, x |->__) ** (foralls x in G, x |->__)) **
           (foralls x in F, x |->__)).
  sconjMatch; exact (objHpIsObjs Hp).
  clear Hp; rename Hp' into Hp.
  assert (HX : h ||- (foralls z in B |_| G, z |->__) ** (foralls z in F, z |->__)).
  sconjMatch.
  apply fasMerge; auto.
  apply (fasFasDisj' Hp); intros h' x Hp'; lle Hp'; lli; sconjMatch.
  clear Hp; apply fasMerge.
  assumption.
  apply (fasFasDisj' HX); intros h' x Hp'; lle Hp'; lli; sconjMatch.
  assumption.
  eapply aligned8Trans; eauto.
  eapply aligned8Trans; eauto.
  eapply aligned8Trans; eauto.

  clear Hp0.
  constructor.

  (* precondition *)
  unfold bakerLoopPre, bakerLoopStOk, scanFieldStOk, toSpace, fromSpace; stSimpl.
  exists phi; exists G; exists W; exists M; exists F.
  constructor.
  subst G; apply set_eqvRefl.

  constructor.
  destruct Al1; omega.
  constructor.
  assumption.
  constructor.
  assumption.
  constructor.
  eapply set_subsetTrans.
  rewrite WMeq; apply set_subsetRefl.
  apply objRangeSetRangeSubset.
  constructor.
  subst F; apply set_eqvRefl.
  constructor.

  intros x y Peq NSP.
  unfold notSpacePtrP in NSP.
  assert (set_In y (B |_| G)).
  destruct Iso as [_ [Iso _]]; hyr Iso (Iso _ _ Peq); clear Peq.
  assert (I' : set_In y (rangeObjs toStart scan |_| rangeObjs scan free)).
  rewrite rangeMerge1; assumption.
  clear Iso; destruct (set_union_elim I') as [I | I].
  subst B; apply set_union_intro1; apply set_union_intro1.
  assumption.
  sui2; assumption.

  destruct NSP as [yOdd | yNI].
  assert (Hp' : s |||- ((y |->_ ** top) ** top) ** top).
  destruct (set_union_elim H) as [I | I].
  hypReplace Hp (sconjAssocR Hp); sconjLift9 Hp.
  scm; hypReplace Hp (fasElim I (objHpIsObjs Hp)); scm.
  hypReplace Hp (sconjAssocR Hp); hypReplace Hp (sconjAssocR Hp); sconjLift9 Hp.
  sconjMatch; hypReplace Hp (fasElim I (objHpIsObjs Hp)); scm.
  apply (not_even_and_odd y).
  apply ptrPeven; lle Hp'; eapply contElim1L; eauto.
  assumption.
  apply yNI; apply objRangeSetRangeSubset; rewrite toEq.
  apply set_union_intro1; assumption.
  constructor.
  constructor.
  destruct Al1; destruct Al2; omega.
  destruct Al3; omega.
  constructor.
  destruct Al4; omega.
  constructor.
  assumption.

  sconjLift8 Hp; apply (sconjImplR Hp); clear Hp; intros h Hp.
  sconjLift8 Hp; apply (sconjImplR Hp); clear h Hp; intros h Hp.
  hypReplace Hp (sconjAssocR Hp);
  sconjLift9 Hp; apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift8 Hp; apply (sconjImpl Hp); clear h Hp; intros h Hp.
  apply (objHpWeaken Hp).
  intros x I; destruct (set_union_elim I).
  sui1; assumption.
  sui2.
  apply objRangeSetRangeSubset.
  rewrite toEq; sui1.
  subst toObjs; destruct (set_union_elim H) as [I' | I']; clear I H.
  assert (I : set_In x (rangeObjs toStart scan |_| rangeObjs scan free)).
  rewrite rangeMerge1; assumption.
  clear I'; destruct (set_union_elim I) as [I' | I']; clear I.
  apply set_union_intro1; subst B; apply set_union_intro1; assumption.
  apply set_union_intro2; assumption.
  apply set_union_intro1; subst B; apply set_union_intro2; assumption.
  unfold gcHpPtrMem; unfold gcHpPtrMem'.
  lli.
  instantiate (1 := alloc). instantiate (1 := free). instantiate (1 := scan).
  lle Hp; sconjLift2 Hp; sconjLift3 Hp; sconjMatch.

  (* finished with the precondition.  now we show the guarantee. *)
  unfold bakerLoopGuar, fromSpace, toSpace; stSimpl.
  intros s' [Guar [Req [RaEq [allocEq v0Eq]]]].
  constructor.
  intros vs A [x [x' [y [y' [z1 [z2 [z3 [rootEq [phi' [W' [M' Bok']]]]]]]]]]].
  destruct Bok' as [_ [_ [WMeq' [Iso' [_ [Hp' Vhp']]]]]].

  (* clean up *)
  assert (X := Hp').
  sconjLift6 X; lle X.
  sconjLift7 Hp; assert (X1 := contContEq Hp X).
  sconjLift7 Hp; sconjLift2 X; assert (X2 := contContEq Hp X).
  sconjLift7 Hp; sconjLift3 X; assert (X3 := contContEq Hp X).
  sconjLift7 Hp; sconjLift4 X; assert (X4 := contContEq Hp X).
  sconjLift7 Hp; sconjLift5 X; assert (X5 := contContEq Hp X).
  sconjLift7 Hp; sconjLift6 X; assert (X6 := contContEq Hp X).
  sconjLift7 Hp; sconjLift7 X; assert (X7 := contContEq Hp X).
  clear Hp X; subst x x' y y' z1 z2 z3.

  clear phi W M WMeq Iso frObjs.
  rename W' into W; rename M' into M; rename phi' into phi.
  set (frObjs := W |_| M).
  assert (Iso : iso_set phi M cpObjs).
  rewrite <- rangeMerge1; assumption.
  assert (WMeq : set_eqv frObjs (rangeObjs frStart frEnd)).
  subst frObjs; assumption.
  clear Iso' WMeq'.

  assert (Hp : s |||- mapHp M phi ** objHp frObjs W **
    objHp toObjs B ** objHp (frObjs |_| toObjs) G **
    (foralls x in F, x |->__) **
    rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::scan::free::alloc::nil) ** A).
  scm.
  subst toObjs; unfold hpredTrue; rewrite <- rangeMerge1.
  rewrite (set_eqvUnionAssoc (rangeObjs toStart scan) (rangeObjs scan free) 
    (rangeObjs alloc toEnd)); assumption.
  subst toObjs; unfold hpredTrue; rewrite <- rangeMerge1.
  rewrite (set_eqvUnionAssoc (rangeObjs toStart scan) (rangeObjs scan free) 
    (rangeObjs alloc toEnd)); assumption.
  clear Hp'.

  assert (Vhp : vs |||- (foralls x in B, objCopiedH x (heapOf s) x) **
              (foralls x in G |_| W, objRespMapH (map_union phi (Some (A:=nat))) (heapOf s) x)).
  scm.
  clear Vhp'.

  (* done cleanup.  use the guarantee. *)
  sconjLift3 Hp; destruct (sconjExtract Hp) as [hb [Hp' HpB]].
  clear Hp; rename Hp' into Hp; sconjLift3 Hp; sconjLift3 Hp.
  destruct (Guar phi G W M F 
    (Heap.heap_eqv hb ** rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::nil) ** A)) as 
  [phi' [B' [B'' [G' [G'' [W' [M' [F' X]]]]]]]]; clear Guar.
  subst G; apply set_eqvRefl.
  (* generally the same as the precondition *)
  unfold bakerLoopPre, bakerLoopStOk, scanFieldStOk, toSpace, fromSpace; stSimpl.
  constructor.
  destruct Al1; omega.
  constructor.
  assumption.
  constructor.
  assumption.
  constructor.
  apply set_subsetTrans with (rangeObjs frStart frEnd).
  subst frObjs; rewrite WMeq; apply set_subsetRefl.
  subst frObjs; apply objRangeSetRangeSubset.
  constructor.
  subst F; apply set_eqvRefl.
  constructor.
  intros x y Peq NSP.
  unfold notSpacePtrP in NSP.
  assert (set_In y (B |_| G)).
  destruct Iso as [_ [Iso _]]; hypReplace Iso (Iso _ _ Peq); clear Peq.
  assert (I' : set_In y (rangeObjs toStart scan |_| rangeObjs scan free)).
  rewrite rangeMerge1; assumption.
  clear Iso; destruct (set_union_elim I') as [I | I].
  subst B; apply set_union_intro1; apply set_union_intro1.
  assumption.
  apply set_union_intro2; assumption.

  destruct NSP as [yOdd | yNI].
  assert (Hp' : s |||- ((y |->_ ** top) ** top) ** top).
  destruct (set_union_elim H) as [I | I].
  sconjLift3 Hp.
  hypReplace Hp (sconjInsert Hp HpB);
  sconjMatch; hypReplace Hp (fasElim I (objHpIsObjs Hp)); sconjMatch.
  sconjLift4 Hp; sconjMatch; hypReplace Hp (fasElim I (objHpIsObjs Hp)); sconjMatch.
  apply (not_even_and_odd y).
  apply ptrPeven; lle Hp'; eapply contElim1L; eauto.
  assumption.
  apply yNI; apply objRangeSetRangeSubset; rewrite toEq.
  apply set_union_intro1; assumption.
  constructor.
  constructor.
  destruct Al1; destruct Al2; omega.
  destruct Al3; omega.
  constructor.
  destruct Al4; omega.
  constructor.
  assumption.

  apply (sconjImplR Hp); clear Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift3 Hp; apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp; apply (sconjImpl Hp); clear h Hp; intros h Hp.
  apply (objHpWeaken Hp).
  intros x I; destruct (set_union_elim I).
  apply set_union_intro1; assumption.
  sui2.
  apply objRangeSetRangeSubset.
  rewrite toEq; apply set_union_intro1.
  subst toObjs; destruct (set_union_elim H) as [I' | I']; clear I H.
  assert (I : set_In x (rangeObjs toStart scan |_| rangeObjs scan free)).
  rewrite rangeMerge1; assumption.
  clear I'; destruct (set_union_elim I) as [I' | I']; clear I.
  apply set_union_intro1; subst B; apply set_union_intro1; assumption.
  apply set_union_intro2; assumption.
  apply set_union_intro1; subst B; apply set_union_intro2; assumption.
  apply sconjGLift2'; apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjGLift2'; unfold gcHpPtrMem; unfold gcHpPtrMem'; lli.
  instantiate (1 := alloc); instantiate (2 := free); instantiate (3 := scan).
  lle Hp; scm.

  destruct X as [Weq [Feq [Iso' [Geq [BBeq' [alFr' [Wcopy' Bok]]]]]]].
  
  assert (Wcopy : forall x, set_In x W' -> s' |||- objCopied x s x ** top).
  exact Wcopy'.
  clear Wcopy'.

  generalize dependent Bok; 
    unfold bakerLoopStOk, scanFieldStOk, fromSpace, toSpace; 
    rewrite <- (Req rtoStart); [ | regNotInListSolver];
    rewrite <- (Req rtoEnd); [ | regNotInListSolver];
    rewrite <- (Req rfrStart); [ | regNotInListSolver];
    rewrite <- (Req rfrEnd); [ | regNotInListSolver];
    stSimpl.
  
  intros [LeSt' [AlSc' [_ [Wmmeq' [F'eq' [_ [Le2 [Le3 [AlF Hp'']]]]]]]]].

  assert (Hp' : s' |||- mapHp (M |_| M') (map_union phi phi') **
    objHp (W' |_| M |_| M') W' ** (foralls x in F', x |->__) **
    (foralls x in B', objRespToMap (map_union phi phi') 
      (rset (rset s rtoStart toStart) rtoEnd toEnd) x) **
    (foralls x in G', objCopied x s x) **
    (foralls x in B'', objIsToFwded phi phi' (rset (rset s rtoStart toStart) rtoEnd toEnd) x) **
    (foralls x in G'', objCopiedPhi phi' s x) **
    rget s' v0 |->, (1::1::nil) **
    gcHpPtrMem' (rget s rgcInfo) (rget s' rscan) (rget s' rfree) (rget s' ralloc) **
    Heap.heap_eqv hb **
    rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) ** A).
  scm.
  clear Hp''.


  sconjLift10 Hp'; sconjLift8 Hp'; sconjLift8 Hp'; sconjLift8 Hp';
    sconjLift8 Hp'; sconjLift7 Hp'.
  hypReplace Hp' (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp'))))).
  destruct (sconjExtract Hp') as [h' [Hp'2 Vhp']].
  clear Hp'; rename Hp'2 into Hp'; lle Vhp'.
  set (vh' := Heap.HeapMap.map_mapRange 
    (fun x => match map_union phi phi' x with Some y => y | _ => x end) h').
  exists (vh', rfileOf s').

  assert (MMdisj' : set_disj M M').
  apply set_disjSymm.
  apply set_unionDisjElimL with W'.
  rewrite <- Weq; apply set_disjSymm.
  unfold mapHp in Hp; unfold objHp in Hp; lle Hp; apply (fasFasDisj Hp).
  illeim.
  unfold okObjAt; unfold okFieldAt; illeim.

  set (alloc' := rget s' ralloc) in * .
  set (B0 := rangeObjs toStart scan).
  set (B1 := rangeObjs alloc toEnd).
  assert (BGeq : set_eqv cpObjs (B0 |_| G)).
  subst cpObjs B0 G; apply set_eqvSymm; assumption.
  assert (BBeq : set_eqv B (B0 |_| B1)).
  apply set_eqvRefl.
  assert (BGeqv : set_eqv toObjs (B |_| G)).
  rewrite BBeq; rewrite (set_eqvUnionSymm B0 B1);
    rewrite (set_eqvUnionAssoc B1 B0 G); 
      rewrite (set_eqvUnionSymm B1 (B0 |_| G)); 
	subst B0 G; rewrite rangeMerge1; apply set_eqvRefl.

  assert (D : set_disj B G).
  unfold objHp in Hp; sconjLift4 Hp; sconjLift4 Hp; hypReplace Hp (sconjInsert Hp HpB);
    apply (fasFasDisj Hp); unfold okObjAt; unfold okFieldAt; illeim.

  assert (D' : set_disj (B |_| G) F).
  assert (HpZ : s |||- (foralls x in B |_| G, x |->__) ** (foralls x in F, x |->__) ** top).
  sconjLift5 Hp; sconjLift5 Hp; sconjLift5 Hp; hypReplace Hp (sconjAssocR (sconjInsert Hp HpB)); scm.
  apply fasMerge; [scm | assumption]; exact (objHpIsObjs Hp).
  apply (fasFasDisj HpZ); illeim.

  assert (D'' : set_disj cpObjs F).
  apply set_unionDisjElimL with B1;
    subst toObjs B1; rewrite BGeqv; assumption.

  assert (DisjWM : set_disj W M).
  sconjLift2 Hp; unfold mapHp in Hp; unfold objHp in Hp; lle Hp;
    apply (fasFasDisj Hp).
  unfold okObjAt; unfold okFieldAt; illeim.
  illeim.

  assert (Iso0 : iso_set (map_union phi phi') (M |_| M') (cpObjs |_| (B'' |_| G''))).
  apply iso_union.
  assumption.
  assumption.
  assumption.
  apply set_disjSymm.
  apply set_unionDisjElimL with (set_add alloc' F').
  rewrite <- Feq; apply set_disjSymm.
  assumption.

  rename Iso into Iso1; rename Iso0 into Iso.

  assert (D3 : set_disj W' (M |_| M')).
  hypReplace Hp' (sconjInsert Hp' Vhp'); clear Vhp'; sconjLift2 Hp'; 
    unfold objHp in Hp'; unfold mapHp in Hp'; lle Hp';
      apply set_disjSymm; apply (fasFasDisj Hp').
  illeim.
  unfold okObjAt; unfold okFieldAt; illeim.

  constructor.

  (* first, show the heap respects the isomorphism *)
  rename Hp' into HH'.
  unfold bakerVirtGuar.
  replace (rget (vh', rfileOf s')) with (rget s'); [ | reflexivity].
  rewrite <- Req; [stSimpl | regNotInListSolver]; rewrite rootEq.
  intros objs h Vhp''.

  assert (Sub : set_subset objs (((B |_| G) |_| W') |_| M')).
  rewrite (set_eqvUnionAssoc (B |_| G) W' M');
    rewrite (set_eqvUnionSymm W' M'); rewrite <- Weq.
  eapply minObjHpSub.
  instantiate (1 := unit); instantiate (2 := heapOf vs).
  lli; unfold hpredTrue; rewrite (set_eqvUnionAssoc B G W).
  clear Vhp''; apply objHpMerge; scm.

  apply unitER; eapply objHpCopied.
  lli; eauto.
  sconjLift3 Hp; scm.
  eapply objHpWeaken.
  eapply heapEqvTrue.
  apply Heap.heap_eqvSymm; apply eqvPredEqv; apply Hp.
  eauto.
  rewrite BGeqv; intros x Ix; rewrite <- (set_eqvUnionAssoc B G W);
    apply set_union_intro1; assumption.

  eapply objRespMapObjHp.
  eauto.
  instantiate (1 := frObjs |_| toObjs).
  sconjLift2 Hp; sconjLift4 Hp; hypReplace Hp (sconjAssocR Hp); scm.
  apply objHpMerge; scm.
  eapply objHpWeaken; eauto.
  intros y Iy; apply set_union_intro1; assumption.
  unfold map_union; intros x y Ix Meq.
  destruct (set_union_elim Ix) as [I | I]; clear Ix.
  subst frObjs; destruct (set_union_elim I) as [I' | I']; clear I.
  destruct Iso1 as [Iso1 _]; destruct (Iso1 x) as [_ Q].
  destruct (phi x).
  elimtype False; apply (set_disj_elim DisjWM x).
  assumption.
  apply Q; discriminate.
  injection Meq; intro; subst y; apply set_union_intro2; apply set_union_intro2; assumption.
  destruct Iso1 as [Iso1 [Iso2 _]]; destruct (Iso1 x) as [Q _]; 
    hypReplace Iso2 (Iso2 x).
  hypReplace Q (Q I'); destruct (phi x).
  hypReplace Iso2 (Iso2 _ Meq); clear Meq Q.
  assert (X : set_In y (B0 |_| G)).
  rewrite <- BGeq; assumption.
  destruct (set_union_elim X) as [Iy | Iy]; clear X Iso2.
  apply set_union_intro1; rewrite BBeq; apply set_union_intro1; assumption.
  apply set_union_intro2; apply set_union_intro1; assumption.
  elimtype False; auto.
  replace (phi x) with (None (A := nat)) in Meq.
  injection Meq; clear Meq; intro; subst y.
  rewrite <- (set_eqvUnionAssoc B G W); apply set_union_intro1;
    rewrite <- BGeqv; assumption.
  destruct Iso1 as [Iso1 _]; destruct (Iso1 x) as [_ Q].
  destruct (phi x).
  elimtype False; apply (set_disj_elim spD x); 
    apply objRangeSetRangeSubset.
  rewrite <- WMeq; subst frObjs; apply set_union_intro2; apply Q; discriminate.
  rewrite toEq; rewrite <- BGeqv; apply set_union_intro1; assumption.
  reflexivity.
  destruct (aconjElim (sconjDistrib2 Vhp'')) as [X _]; apply X.
  simpl; intros v [Iv | FF]; [idtac | elimtype False; assumption].
  subst v.
  destruct rootOk; [left; assumption | right].
  apply set_union_intro1; rewrite <- BGeqv; assumption.
  (* finished showing the subset for objs! *)

  set (objs' := set_map 
    (fun x => match phi' x with
		| Some y => y
		| None => x
	      end) objs).
  set (phi2 := fun x => if set_mem x objs then
          (if set_mem x M' then phi' x else Some x) else None).
  exists objs'; exists phi2.

  assert (Sub' : set_subset objs' (W' |_| toObjs |_| B'' |_| G'')).
  subst objs'; intros a Ia.
  destruct (set_map_elim Ia) as [b [Aeq Ib]]; clear Ia; subst a.
  hypReplace Sub (Sub _ Ib); clear Ib.
  destruct (set_union_elim Sub) as [I' | I']; clear Sub.
  rename I' into I.
  destruct Iso as [Iso _]; destruct (Iso b) as [_ II]; destruct (map_union phi phi' b).
  elf.
  assert (II' : set_In b (M |_| M')).
  apply II; discriminate.
  clear a II; destruct (set_union_elim I) as [I' | I']; clear I.
  apply (set_disj_elim spD b).
  apply Wmmeq'; apply set_union_intro2; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; apply set_union_intro1; assumption.
  destruct (set_union_elim II') as [I | I]; clear II'.
  apply (set_disj_elim DisjWM b).
  rewrite Weq; apply set_union_intro2; assumption.
  assumption.
  apply (set_disj_elim D3 b).
  assumption.
  apply set_union_intro2; assumption.
  destruct (set_union_elim I) as [I' | I']; clear I.
  destruct Iso' as [Iso' [Iso2 _]]; destruct (Iso' b) as [Iso'' _]; clear Iso';
    hypReplace Iso2 (Iso2 b).
  destruct (phi' b).
  apply set_union_intro2; apply set_union_intro2; eauto.
  apply set_union_intro2; apply set_union_intro1; rewrite BGeqv; assumption.
  destruct Iso' as [Iso' _]; destruct (Iso' b) as [X Y]; clear Iso';
    destruct (phi' b).
  elf; apply (set_disj_elim D3 b).
  assumption.
  apply set_union_intro2; apply Y; discriminate.
  apply set_union_intro1; assumption.
  destruct Iso' as [Iso' [Iso2 _]]; destruct (Iso' b) as [X _]; clear Iso';
    hypReplace Iso2 (Iso2 b); destruct (phi' b).
  apply set_union_intro2; apply set_union_intro2; eapply Iso2; reflexivity.
  intuition.

  assert (Disj4 : set_disj ((B |_| G) |_| W') M').
  apply set_disj_intro; intros y I1 I2.
  destruct (set_union_elim I1) as [I' | I']; clear I1.
  apply (set_disj_elim spD y).
  apply Wmmeq'; apply set_union_intro2; apply set_union_intro2; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; apply set_union_intro1; assumption.
  apply (set_disj_elim D3 y).
  assumption.
  apply set_union_intro2; assumption.

  assert (Disj5 : set_disj ((B |_| G) |_| W') (B'' |_| G'')).
  apply set_disj_intro; intros x I I'.
  destruct (set_union_elim I) as [I1 | I1]; clear I.
  apply (set_disj_elim D' x).
  assumption.
  rewrite Feq; apply set_union_intro1; assumption.
  assert (Disj' : set_disj W' (B'' |_| G'')).
  apply set_disj_intro; intros y Iy Iy'.  
  apply (set_disj_elim spD y).
  apply Wmmeq'; apply set_union_intro1; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; apply set_union_intro2;
    rewrite Feq; apply set_union_intro1; assumption.
  apply (set_disj_elim Disj' x); assumption.
 
  (* show the isomorphism is okay *)
  assert (IsoOk : iso_set phi2 objs objs').

  clear Req.
  subst objs' phi2; constructor.

  intros x; constructor; intro I.
  rewrite (set_mem_true I).
  assert (I' := Sub _ I); clear I.
  destruct (set_union_elim I') as [I | I]; clear I'.
  rewrite set_mem_false.
  discriminate.
  intro I'; apply (set_disj_elim Disj4 x); assumption.
  rewrite (set_mem_true I); destruct Iso' as [Iso' _]; destruct (Iso' x) as [Q Q']; auto.
  assert (Q := set_memSound x objs).
  destruct (set_mem x objs); intuition.

  constructor.
  intros x y E.
  assert (Q := set_memSound x objs); destruct (set_mem x objs).
  2:discriminate E.
  eapply set_map_intro.
  2:eauto.
  assert (Qm := set_memSound x M'); destruct (set_mem x M').
  rewrite E; reflexivity.
  injection E; clear E; intro; subst y.
  destruct Iso' as [Iso' _]; destruct (Iso' x) as [_ X]; destruct (phi' x).
  elf; apply Qm; apply X; discriminate.
  auto.

  constructor.
  intros x x' y E E'.
  assert (X := set_memSound x objs).
  destruct (set_mem x objs).
  assert (X' := set_memSound x' objs).
  destruct (set_mem x' objs).
  hypReplace X (Sub _ X).
  hypReplace X' (Sub _ X').
  destruct (set_union_elim X) as [Ix | Ix]; clear X.
  rewrite set_mem_false in E.
  injection E; clear E; intro; subst x.
  destruct (set_union_elim X') as [Ix' | Ix']; clear X'.
  rewrite set_mem_false in E'.
  injection E'; clear E'; intro; subst x'; reflexivity.
  intro I; apply (set_disj_elim Disj4 x'); eauto.
  rewrite (set_mem_true Ix') in E'.
  elimtype False; apply (set_disj_elim Disj5 y).
  assumption.
  destruct Iso' as [_ [Iso' _]]; exact (Iso' x' y E').
  intro I.
  apply (set_disj_elim Disj4 x); assumption.
  rewrite (set_mem_true Ix) in E.
  destruct (set_union_elim X') as [Ix' | Ix']; clear X'.
  rewrite set_mem_false in E'.
  injection E'; clear E'; intro; subst x'.
  elf; apply (set_disj_elim Disj5 y).
  assumption.
  destruct Iso' as [_ [Iso' _]]; eauto.
  intro I; apply (set_disj_elim Disj4 x'); assumption.
  rewrite (set_mem_true Ix') in E'.
  destruct Iso' as [_ [_ [Iso' _]]]; eauto.
  discriminate E'.
  discriminate E.

  intros y Iy; destruct (set_map_elim Iy) as [b [Aeq Ib]]; subst y.
  exists b; rewrite (set_mem_true Ib).
  hypReplace Ib (Sub _ Ib); destruct (set_union_elim Ib) as [Ib' | Ib']; clear Ib.
  rewrite set_mem_false.
  destruct Iso' as [Iso' _]; destruct (Iso' b) as [_ X].
  destruct (phi' b).
  elf; apply (set_disj_elim Disj4 b).
  assumption.
  apply X; discriminate.
  reflexivity.
  intro; apply (set_disj_elim Disj4 b); assumption.
  rewrite (set_mem_true Ib').
  destruct Iso' as [Iso' _]; destruct (Iso' b) as [Iso1' _]; destruct (phi' b).
  reflexivity.
  elf; intuition.
  
  constructor.
  assumption.

  (* show the root is mapped okay *)
  constructor.
  unfold mapX.
  assert (IO := isOddOk (rget s rroot)).
  destruct (isOdd (rget s rroot)).
  reflexivity.
  assert (rootOk' : okFieldVal objs (rget s rroot)).
  destruct (aconjElim (sconjDistrib2 Vhp'')) as [X _].
  assert (Y : vs |||- (!(okFieldVal objs (rget s rroot)) ** top) ** top).
  scm; lli; eapply minObjHpRootOk; eauto; left; reflexivity.
  lle Y; assumption.
  destruct rootOk' as [rok | rok].
  elf; apply (not_even_and_odd (rget s rroot)); assumption.
  subst phi2; cbv beta; rewrite (set_mem_true rok).
  rewrite set_mem_false.
  reflexivity.
  intro I.
  destruct rootOk as [rootOk | rootOk].
  apply (not_even_and_odd (rget s rroot)); assumption.
  apply (set_disj_elim spD (rget s rroot)).
  apply Wmmeq'; apply set_union_intro2; apply set_union_intro2; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; apply set_union_intro1;
    rewrite <- BGeqv; assumption.

  (* show that vh' respects the mapping *)
  clear Req.
  subst vh' objs' phi2.

  assert (BGBeq : set_eqv toObjs ((B0 |_| G) |_| B1)).
  rewrite (set_eqvUnionSymm B0 G); rewrite (set_eqvUnionAssoc G B0 B1);
    rewrite <- BBeq; rewrite (set_eqvUnionSymm G B); rewrite <- BGeqv; apply set_eqvRefl.

  eapply noFlipRespectsMap.
  instantiate (1 := G').
  instantiate (1 := B').
  instantiate (1 := B0).
  instantiate (1 := M).
  rewrite <- Geq; rewrite <- BGeq; assumption.
  apply Iso'.
  rewrite <- Geq; rewrite <- BGeq; assumption.
  3:eauto.
  2:instantiate (1 := W'); instantiate (3 := B1).
  21:instantiate (1 := toEnd); instantiate (2 := toStart); 
    instantiate (3 := (set_add (rget s' ralloc) F')).
  instantiate (1 := s); sconjMatch; unfold hpredTrue.
  rewrite <- Weq; assumption.
  rewrite <- BBeq; rewrite <- Geq; rewrite <- BGBeq; rewrite <- hpredTrueEq.
  eapply heapEqvTrue.
  apply Heap.heap_eqvSymm; apply eqvPredEqv; apply Hp.
  assumption.
  rewrite <- Geq; rewrite <- Weq; rewrite <- BGBeq; assumption.
  clear Vhp''; scm; unfold hpredTrue.
  rewrite <- Weq; rewrite <- Geq; assumption.
  apply (sconjImplS Vhp'); clear Vhp'; intros hh Subh Hp'.
  unfold objHp in Hp'; eapply fasImplIS.
  apply Hp'.
  unfold okObjAt; unfold okFieldAt; clear Hp'; intros x hh' I Sub1 Hp'; lle Hp'.
  assert (SubSub : Heap.subHeap hh' (heapOf s')).
  eapply Heap.subHeapTrans.
  eauto.
  eapply Heap.subHeapTrans.
  eauto.
  eapply sconjEqSubHeap; eauto.
  clear Subh Sub1 hh H3 H4.
  hypReplace Wcopy (Wcopy _ I).
  unfold objCopied in Wcopy |- *; unfold fieldCopied in Wcopy |- *; lle Wcopy.
  assert (X1 := subHeapContEq SubSub Wcopy Hp').
  sconjLift2 Wcopy; sconjLift2of2 Hp'.
  assert (X2 := subHeapContEq SubSub Wcopy Hp').
  sconjLift2of2 Hp'; subst x2 x3.
  lli; eauto.
  scm.
  eapply heapEqvTrue.
  apply Heap.heap_eqvSymm; apply eqvPredEqv; apply Hp0.
  clear hh Subh h0 Hp0.
  sconjLift3 Hp; unfold objHp in HpB; eapply fasImplIS.
  apply HpB.
  unfold okObjAt; unfold okFieldAt; intros x hx Ix SubX HpX; lle HpX; clear H3 H4.
  assert (SubX' : Heap.subHeap hx (heapOf s)).
  eapply Heap.subHeapTrans; eauto.
  eapply sconjEqSubHeap; eauto.
  assert (HpX' := subHeapImpl HpX SubX'); lle HpX'.
  unfold objCopied; unfold fieldCopied; lli.
  2:eauto.
  scm.
  sconjLift2 HpX'; scm.
  rewrite <- BBeq; rewrite <- Geq; assumption.
  rewrite <- Geq; rewrite <- BGBeq; assumption.
  eapply set_unionDisjElimR; apply Disj4.
  apply set_disjSymm; eapply set_unionDisjElimR; apply Disj5.
  assumption.

  intros x Ix.
  assert (HX : s' |||- (x |->_ ** top) ** top).
  sconjLift2 HH'; scm.
  hypReplace Hp0 (mapHpElim1 Ix Hp0); lleim.
  lle HX; eapply contElim1L; eauto.
  intros x Ix; assert (HpX : h' ||- (x |->_ ** top) ** top).
  destruct (set_union_elim Ix) as [Ix' | Ix']; clear Ix.
  sconjLift6of6 Vhp'; hypReplace Vhp' (sconjInsert Vhp' HpB); scm.
  assert (Ix : set_In x B).
  rewrite BBeq; apply set_union_intro1; assumption.
  hypReplace Hp0 (objHpElim Ix Hp0); 
    unfold okObjAt in Hp0; unfold okFieldAt in Hp0; lleim.
  destruct (set_union_elim Ix') as [Ix | Ix]; 
    [sconjLift2 Vhp' | sconjLift3 Vhp']; clear Ix'; scm; hypReplace Hp0 (fasElim Ix Hp0).
  unfold objRespToMap in Hp0; unfold fieldRespToMap in Hp0; unfold fieldRespMap in Hp0; lleim.
  cbv beta in Hp0; unfold objCopied in Hp0; unfold fieldCopied in Hp0; lleim.
  lle HpX; eapply contElim1L; eauto.

  (* now we prove a bunch of disjointedness conditions *)
  rewrite <- Weq; rewrite <- Geq.
  rewrite <- BGeq.
  apply set_unionDisjElimL with (s2 := rangeObjs alloc toEnd).
  apply set_unionDisjElimL with (s2 := F).
  subst frObjs; rewrite WMeq; subst toObjs; rewrite BGeqv; subst F; rewrite <- toEq.
  apply set_disj_intro; intros x Ix Ix'.
  apply (set_disj_elim spD x); apply objRangeSetRangeSubset; assumption.
  apply set_disjSymm; apply set_unionDisjElimL with (s2 := G'); rewrite <- Geq.
  apply set_unionDisjElimR with (s1 := B);
    apply set_unionDisjElimL with (s2 := W'); assumption.
  rewrite <- Weq; subst frObjs; rewrite WMeq.
  apply set_disj_intro; intros x Ix Ix'; apply (set_disj_elim spD x).
  apply objRangeSetRangeSubset; assumption.
  assumption.
  apply set_unionDisjElimL with (s2 := set_add alloc' F'); rewrite <- Feq.
  unfold mapHp in Hp; sconjLift5 Hp; lle Hp; apply (fasFasDisj Hp); illeim.
  apply set_unionDisjElimL with (s2 := set_add alloc' F'); rewrite <- Feq.
  apply set_disjSymm; apply set_unionDisjElimL with (s2 := W'); rewrite <- Weq.
  unfold objHp in Hp; sconjLift5 Hp; sconjLift3 Hp; apply (fasFasDisj Hp); 
    unfold okObjAt; unfold okFieldAt; illeim.
  apply set_disjSymm; apply set_unionDisjElimR with (s1 := B'); rewrite <- Geq;
    apply set_unionDisjElimR with (s1 := B); 
      apply set_unionDisjElimL with (s2 := W'); assumption.
   apply set_disjSymm; apply set_unionDisjElimL with (s2 := G); 
     apply set_unionDisjElimL with (s2 := W'); rewrite <- BBeq; assumption.
   rewrite <- Weq; assumption.
   rewrite <- Weq; rewrite <- Geq; rewrite <- BGBeq.
   subst frObjs; rewrite WMeq; apply set_unionDisjElimL with (s2 := F); 
     rewrite BGeqv; rewrite <- toEq.
  apply set_disj_intro; intros x Ix Ix'; apply (set_disj_elim spD x);
    apply objRangeSetRangeSubset; assumption.
  rewrite <- BBeq; rewrite <- Geq; assumption.
  rewrite <- BBeq; rewrite <- Geq; subst alloc'; rewrite <- Feq;
    rewrite <- toEq; apply set_eqvRefl.
  (* done showing that the virtual heap respects the mapping *)

  (* show that the final state is well-formed *)
  exists frStart; exists frEnd; exists toStart; exists toEnd;
    exists (rget s' rscan); exists (rget s' rfree); exists alloc'.
  intros x vs'; subst x vs'.
  replace (rget (vh', rfileOf s')) with (rget s') by reflexivity.
  constructor.
  reflexivity.
  rewrite v0Eq; rewrite <- (Req rgcInfo); [stSimpl | regNotInListSolver].
  rewrite <- (Req rroot); [stSimpl | regNotInListSolver].
  constructor.
  constructor.
  apply rangeObjsIntro with 0; destruct Al4; omega.
  constructor.
  assert (EE : Heap.get h' alloc' = None).
  assert (X : Heap.get h' alloc' = None \/ exists v, Heap.get h' alloc' = Some v).
  destruct (Heap.get h' alloc'); [right | left].
  econstructor; reflexivity.
  reflexivity.
  destruct X as [X | [v X]].
  assumption.
  hyr Hp' (sconjInsert Hp' (contIntro2 _ _ X)).
  rewrite v0Eq in Hp'; lle Hp'; sconjLift4 Hp'; lle Hp'.
  assert (Q := Heap.HeapMap.map_mapRangeGetEq h' (div4 alloc')
    (fun x : POnat.OneTypeNat.B =>
            match map_union phi phi' x with
            | Some y => y
            | None => x
            end)).
  unfold Heap.get in EE |- * .
  destruct (isPtr alloc').
  rewrite EE in Q.
  assumption.
  reflexivity.
  (* show second field is fresh *)
  assert (EE : Heap.get h' (4 + alloc') = None).
  assert (X : Heap.get h' (4 + alloc') = None \/ exists v, Heap.get h' (4 + alloc') = Some v).
  destruct (Heap.get h' (4 + alloc')); [right | left].
  econstructor; reflexivity.
  reflexivity.
  destruct X as [X | [v X]].
  assumption.
  hyr Hp' (sconjInsert Hp' (contIntro2 _ _ X)).
  rewrite v0Eq in Hp'; lle Hp'; sconjLift5 Hp'; lle Hp'.
  assert (Q := Heap.HeapMap.map_mapRangeGetEq h' (div4 (4 + alloc'))
    (fun x : POnat.OneTypeNat.B =>
            match map_union phi phi' x with
            | Some y => y
            | None => x
            end)).
  unfold Heap.get in EE |- * .
  destruct (isPtr (4 + alloc')).
  rewrite EE in Q.
  assumption.
  reflexivity.

  (* show final state is bakerStOk' *)
  exists (map_union phi phi'); exists W'; exists (M |_| M').
  destruct BBeq' as [BBeq' SCle].

  assert (Al6 : aligned8 toStart (rget s' rscan)).
  apply aligned8LE_R with (rget s' rfree).
  eapply aligned8Trans; eauto.
  eapply aligned8Trans; eauto.
  assumption.
  assumption.

  constructor.
  simpl; intuition.
  destruct Al4 as [k X]; exists (S k); omega.
  constructor.
  assumption.
  assert (WMeqv : set_eqv (W' |_| M |_| M') (W |_| M)).
  rewrite <- (set_eqvUnionAssoc W' M M'); rewrite (set_eqvUnionSymm W' M);
    rewrite (set_eqvUnionAssoc M W' M'); rewrite (set_eqvUnionSymm W' M');
      rewrite <- Weq; rewrite (set_eqvUnionSymm W M); apply set_eqvRefl.
  constructor.
  rewrite WMeqv; assumption.
  intros B3 B1' G3 toObjs'.
  assert (B3eq : set_eqv B3 (B0 |_| B' |_| B'')).
  subst B3; clear toObjs' B1' G3.
  rewrite <- (rangeObjsTransEqv Al1 SCle); rewrite <- BBeq'; apply set_eqvRefl.
  assert (B1'eq : set_eqv B1' (set_add alloc' B1)).
  subst B1 B1'; rewrite allocEq.
  apply set_eqvSymm.
  replace (alloc' + 8) with (8 + alloc'); [apply rangeObjsStartAdd | intuition].
  replace (8 + alloc') with (alloc' + 8); [rewrite <- allocEq; assumption | omega].
  assert (G3eq : set_eqv G3 ((set_diff G (B' |_| B'')) |_| G'')).
  clear WMeqv D3 B3 toObjs' B3eq.
  subst G G3; eapply grayObjExtract.
  instantiate (1 := alloc); instantiate (2 := set_add (rget s' ralloc) F'); subst F;
    apply set_eqvSymm; assumption.
  rewrite F'eq'; replace (rget s' ralloc) with alloc'; [idtac | reflexivity];
    replace alloc' with (alloc - 8); [idtac | omega].
  apply set_eqvSymm; apply rangeObjsEndSplit.
  eapply aligned8Trans; eauto.
  rewrite allocEq; exists 1; omega.
  destruct AlF; omega.
  assumption.
  eapply aligned8LE_L; eauto.
  assumption.
  assumption.
  eapply aligned8Trans; eauto.
  rewrite allocEq; exists 1; omega.
  assumption.
  sconjLift2 Vhp'; sconjLift4 Vhp'; hypReplace Vhp' (sconjAssocR Vhp').
  assert (X : h' ||- (foralls x in B' |_| B'', x |->_ ** top) **
    top ** top ** (foralls x in G'', x |->_ ** top) ** top).
  scm.
  sconjLift2of2 Hp0.
  assert (X : h ||- (foralls x in B', x |->_ ** top) **
    (foralls x in B'', x |->_ ** top)).
  eapply sconjImpl.
  apply Hp0.
  unfold objRespToMap, fieldRespToMap, fieldRespMap;  intros; eapply fasImpl.
  apply H.
  cbv beta; illeim.
  unfold objIsToFwded, objIsFwded, fieldIsFwded; intros; eapply fasImpl.
  apply H.
  cbv beta; illeim.
  apply fasMerge.
  scm.
  apply (fasFasDisj' X); auto.
  unfold objCopiedPhi, objCopied, fieldCopied in Hp0; eapply fasImpl.
  apply Hp0.
  cbv beta; illeim.
  lle X; sconjLift2 X; apply (fasFasDisj X); auto.
  assert (X : h' ||- top ** top ** top ** top ** (foralls x in G'', x |->_ ** top) ** top).
  scm.
  unfold objCopiedPhi, objCopied, fieldCopied in Hp0; eapply fasImpl.
  apply Hp0.
  cbv beta; illeim.
  assert (Y : s' |||- Heap.heap_eqv h' ** top ** (foralls x in F', x |->_ ** top) ** 
    (rget s' ralloc |->_ ** top) ** top).
  scm.
  eapply fasImpl.
  eauto.
  cbv beta; illeim.
  hpunfoldIn Hp0; simpl in Hp0; subst alloc'; rewrite <- v0Eq; lli; scm.
  lle X; hypReplace Y (sconjInsert Y X); lle Y.
  assert (Y' : s' |||- fasd (set_add (rget s' ralloc) F') ** fasd G'' ** top).
  sconjLift3 Y; sconjLift3 Y; hyr Y (sconjAssocR Y); scm.
  apply fasIntro.
  apply sconjComm; scm; hyr Hp0 (unitIR Hp0); lli; scm.
  intro I; assert (Y : h ||- ((rget s' ralloc |->_ ** top) ** top) ** rget s' ralloc |-> x).
  scm; hyr Hp0 (fasElim I Hp0); scm; lleim.
  lle Y.
  apply set_disjSymm; apply (fasFasDisj Y'); auto.

  assert (BG3eq : set_eqv (B3 |_| G3) (cpObjs |_| B'' |_| G'')).
  rewrite B3eq; rewrite G3eq.
  rewrite (set_eqvUnionAssoc B0 (B' |_| B'') (set_diff G (B' |_| B'') |_| G'')).
  rewrite <- (set_eqvUnionAssoc (B' |_| B'') (set_diff G (B' |_| B'')) G'').
  rewrite (set_eqvUnionSymm (B' |_| B'') (set_diff G (B' |_| B''))).
  rewrite (set_diffAdd G (B' |_| B'')).
  rewrite (set_diffUnionDistrib B' B'' G).
  assert (Sub : set_subset B' G).
  intros x I; rewrite Geq; apply set_union_intro1; assumption.
  rewrite (set_diffSuperSet Sub).
  simpl; rewrite (set_eqvUnionAssoc G (set_diff B'' G) G'').
  rewrite <- (set_eqvUnionAssoc B0 G (set_diff B'' G |_| G''));
    rewrite <- BGeq.
  assert (Disj : set_disj B'' G).
  apply set_unionDisjElimL with (s2 := G''); 
    apply set_unionDisjElimL with (s2 := set_add alloc' F'); rewrite <- Feq.
  apply set_disjSymm; apply set_unionDisjElimR with (s1 := B); assumption.
  rewrite (set_diffDisj Disj).
  apply set_eqvRefl.
  constructor.
  rewrite BG3eq; assumption.
  constructor.
  subst toObjs';
    rewrite <- (set_eqvUnionAssoc B3 G3 B1'); rewrite BG3eq.
  destruct rootOk; [left | right].
  assumption.
  subst toObjs; destruct (set_union_elim H) as [I | I].
  sui1; sui1; assumption.
  sui2; rewrite B1'eq; right; assumption.

  (* show the heap is okay *)
  assert (GBBdisj : set_disj G' (B' |_| B'')).
  assert (HX : h' ||- top ** (foralls x in B', x |->_ ** top) **
    (foralls x in G', x |->_ ** top) ** (foralls x in B'', x |->_ ** top) **
    top).
  scm.
  unfold objRespToMap in Hp0; unfold fieldRespToMap in Hp0; unfold fieldRespMap in Hp0; 
    eapply fasImpl.
  apply Hp0.
  cbv beta; illeim.
  unfold objCopied, fieldCopied in Hp0; apply (fasImpl Hp0).
  cbv beta; illeim.
  unfold objIsToFwded, objIsFwded, fieldIsFwded in Hp0; eapply fasImpl.
  apply Hp0.
  cbv beta; illeim.
  lle HX; sconjLift3 HX; sconjLift2 HX; hypReplace HX (sconjAssocR HX); sconjLift2 HX;
  assert (HX' : h' ||- (foralls x in G', x |->_ ** top) **
    (foralls x in B' |_| B'', x |->_ ** top) ** top).
  scm.
  apply fasMerge; [assumption | apply (fasFasDisj' Hp0); auto].
  apply (fasFasDisj HX'); auto.

  assert (G'eq : set_eqv G' (set_diff G (B' |_| B''))).
  rewrite Geq; rewrite (set_diffUnionDistrib B' G' (B' |_| B''));
    rewrite (setUnionDiffDiff B' B' B''); rewrite (set_diffSelf B'); simpl;
      rewrite (set_diffDisj GBBdisj); apply set_eqvRefl.

  assert (BBBeq : set_eqv (B3 |_| B1')
    ((set_add alloc' empty_set) |_| B |_| B' |_| B'')).
  replace (rangeObjs alloc' toEnd) with B1'; [idtac | reflexivity];
    rewrite B3eq; rewrite (set_eqvUnionSymm (B0 |_| B' |_| B'') B1').
  rewrite <- (set_eqvUnionAssoc B1' B0 (B' |_| B''));
    rewrite (set_eqvUnionSymm B1' B0).
  rewrite B1'eq; replace (set_add alloc' B1) with ((set_add alloc' empty_set) |_| B1); 
    [idtac | reflexivity].
  rewrite (set_eqvUnionSymm (set_add alloc' empty_set) B1);
    rewrite <- (set_eqvUnionAssoc B0 B1 (set_add alloc' empty_set));
      replace (B0 |_| B1) with B; [idtac | reflexivity].
  rewrite (set_eqvUnionSymm B (set_add alloc' empty_set)); apply set_eqvRefl.

  assert (toObjs'Eq : set_eqv toObjs' ((set_add alloc' empty_set) |_| toObjs |_| B'' |_| G'')).
  subst toObjs';
    rewrite <- (set_eqvUnionAssoc B3 G3 B1'); rewrite BG3eq;
      replace (rangeObjs alloc toEnd) with B1; [idtac | reflexivity];
	rewrite (set_eqvUnionSymm (cpObjs |_| B'' |_| G'') B1');
	  rewrite <- (set_eqvUnionAssoc B1' cpObjs (B'' |_| G''));
	    rewrite (set_eqvUnionSymm B1' cpObjs).
  rewrite B1'eq; replace (set_add alloc' B1) with ((set_add alloc' empty_set) |_| B1); 
    [idtac | reflexivity].
  rewrite (set_eqvUnionSymm (set_add alloc' empty_set) B1).
  rewrite <- (set_eqvUnionAssoc cpObjs B1 (set_add alloc' empty_set));
    replace (cpObjs |_| B1) with toObjs; [idtac | reflexivity].
  rewrite (set_eqvUnionSymm toObjs (set_add alloc' empty_set)); apply set_eqvRefl.

  rename Hp into HpX.
  assert (Vhp'' : h' ||- objHp (W' |_| M |_| M') W' **
    objHp toObjs' (B |_| B' |_| B'') **
    objHp ((W' |_| M |_| M') |_| toObjs') (set_diff G (B' |_| B'') |_| G'')).
  apply (sconjImplR Vhp'); clear Vhp'; intros h Hp.
  sconjLift5of5 Hp; hypReplace Hp (sconjInsert Hp HpB); clear HpB.
  sconjLift4 Hp; sconjLift3 Hp; sconjLift3 Hp;
    hypReplace Hp (sconjAssocR (sconjAssocR Hp)).
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  lle Hp; unfold hpredTrue; rewrite toObjs'Eq; apply objHpMerge; scm.
  apply objHpWeaken with (S := toObjs).
  assumption.
  intros x Ix; sui2; sui1; assumption.
  apply objHpMerge; apply sconjComm; sconjLift2of2 Hp; scm.
  unfold objHp; apply (fasImplI Hp); clear h Hp.
  unfold objIsToFwded, objIsFwded, fieldIsFwded; stSimpl;
    intros x h Ix Hp; lle Hp.
  assert (HH : s |||- (okObjAt frObjs x0 ** top) ** top).
  sconjLift2 HpX; scm.
  assert (set_In x0 W).
  rewrite Weq; sui1.
  destruct Iso' as [Iso' _]; destruct (Iso' x0) as [IA IB];
    apply IB; rewrite H1; discriminate.
  hypReplace Hp0 (objHpElim H Hp0); scm.
  unfold okObjAt, okFieldAt in HH; lle HH.
  destruct H6 as [v0 [Hp0 Meq0]]; destruct H7 as [v1 [Hp1 Meq1]].
  assert (X1 := contContEq Hp0 HH); sconjLift2 HH; 
    assert (X2 := contContEq Hp1 HH); subst x3 x4; clear Hp0 Hp1 HH.
  unfold okObjAt; unfold okFieldAt; lli.
  2:apply Hp.
  (* first field *)
  clear x2 v1 Meq1 Hp H9 H1 x0 x Ix;
    rename H4 into okF; rename x1 into v0'.
  unfold mapX in Meq0; assert (IO := isOddOk v0); destruct (isOdd v0).
  left; injection Meq0; intro; subst v0'; assumption.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  assert (Meq : map_union (spaceIdMap toStart toEnd) (map_union phi phi') v0 = Some v0').
  rewrite <- Meq0; unfold map_union.
  destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0.
  unfold map_union at 1 in Meq.
  destruct okF as [okF | okF].
  elf; apply (not_even_and_odd v0); assumption.
  rewrite set_mem_false in X.
  rewrite X in Meq.
  destruct Iso as [_ [Iso _]]; hypReplace Iso (Iso _ _ Meq).
  subst toObjs; right; destruct (set_union_elim Iso) as [I | I].
  sui2; sui1; sui1; assumption.
  sui2; sui2; assumption.
  clear X Meq IO; intro I; apply (set_disj_elim spD v0).
  apply objRangeSetRangeSubset; rewrite <- WMeq; assumption.
  assumption.
  (* second field *)
  clear x1 v0 Meq0 Hp H4 H1 x1 x Ix H;
    rename H9 into okF; rename x2 into v0'.
  rename v1 into v0; rename Meq1 into Meq0.
  unfold mapX in Meq0; assert (IO := isOddOk v0); destruct (isOdd v0).
  left; injection Meq0; intro; subst v0'; assumption.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  assert (Meq : map_union (spaceIdMap toStart toEnd) (map_union phi phi') v0 = Some v0').
  rewrite <- Meq0; unfold map_union.
  destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0.
  unfold map_union at 1 in Meq.
  destruct okF as [okF | okF].
  elf; apply (not_even_and_odd v0); assumption.
  rewrite set_mem_false in X.
  rewrite X in Meq.
  destruct Iso as [_ [Iso _]]; hypReplace Iso (Iso _ _ Meq).
  subst toObjs; right; destruct (set_union_elim Iso) as [I | I].
  sui2; sui1; sui1; assumption.
  sui2; sui2; assumption.
  clear X Meq IO; intro I; apply (set_disj_elim spD v0).
  apply objRangeSetRangeSubset; rewrite <- WMeq; assumption.
  assumption.
  (* now for B' *)
  unfold objHp; apply (fasImplI Hp); clear h Hp.
  unfold objRespToMap, fieldRespToMap, fieldRespMap; stSimpl;
    intros x h Ix Hp; lle Hp.
  assert (HH : s |||- (okObjAt (frObjs |_| toObjs) x ** top) ** top).
  sconjLift4 HpX; scm.
  assert (I : set_In x G).
  rewrite Geq; sui1; assumption.
  hypReplace Hp0 (objHpElim I Hp0); scm.
  unfold okObjAt, okFieldAt in HH; lle HH.
  destruct H3 as [v0 [Hp0 Meq0]]; destruct H4 as [v1 [Hp1 Meq1]].
  assert (X1 := contContEq Hp0 HH); sconjLift2 HH; 
    assert (X2 := contContEq Hp1 HH); subst x2 x3; clear Hp0 Hp1 HH.
  unfold okObjAt; unfold okFieldAt; lli.
  2:apply Hp.
  (* first field *)
  clear x h Ix Hp; clear x1 v1 Meq1 H8;
    rename H5 into okF; rename x0 into v0'.
  unfold mapX in Meq0; assert (IO := isOddOk v0); destruct (isOdd v0).
  left; injection Meq0; intro; subst v0'; assumption.
  destruct okF as [okF | okF].
  elf; apply (not_even_and_odd v0); assumption.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  assert (Meq : map_union (spaceIdMap toStart toEnd) (map_union phi phi') v0 = Some v0').
  rewrite <- Meq0; unfold map_unionnn; unfold map_union.
  destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0.
  unfold map_union at 1 in Meq.
  destruct (set_union_elim okF) as [I | I]; clear okF.
  rewrite set_mem_false in X.
  rewrite X in Meq.
  destruct Iso as [_ [Iso _]]; hypReplace Iso (Iso _ _ Meq).
  subst toObjs; right; destruct (set_union_elim Iso) as [I' | I'].
  sui2; sui1; sui1; assumption.
  sui2; sui2; assumption.
  clear X Meq IO; intro I'; apply (set_disj_elim spD v0).
  apply objRangeSetRangeSubset; rewrite <- WMeq; assumption.
  assumption.
  rewrite set_mem_true in X.
  rewrite X in Meq; clear X.
  injection Meq; clear Meq; intro; subst v0'; right;
    sui2; sui1; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; 
    sui1; rewrite <- BGeqv; assumption.
  (* second field *)
  clear x h Ix H Hp; clear x0 v0 Meq0 H5;
    rename H8 into okF; rename x1 into v0'.
  rename v1 into v0; rename Meq1 into Meq0.
  unfold mapX in Meq0; assert (IO := isOddOk v0); destruct (isOdd v0).
  left; injection Meq0; intro; subst v0'; assumption.
  destruct okF as [okF | okF].
  elf; apply (not_even_and_odd v0); assumption.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  assert (Meq : map_union (spaceIdMap toStart toEnd) (map_union phi phi') v0 = Some v0').
  rewrite <- Meq0; unfold map_unionnn; unfold map_union.
  destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0.
  unfold map_union at 1 in Meq.
  destruct (set_union_elim okF) as [I | I]; clear okF.
  rewrite set_mem_false in X.
  rewrite X in Meq.
  destruct Iso as [_ [Iso _]]; hypReplace Iso (Iso _ _ Meq).
  subst toObjs; right; destruct (set_union_elim Iso) as [I' | I'].
  sui2; sui1; sui1; assumption.
  sui2; sui2; assumption.
  clear X Meq IO; intro I'; apply (set_disj_elim spD v0).
  apply objRangeSetRangeSubset; rewrite <- WMeq; assumption.
  assumption.
  rewrite set_mem_true in X.
  rewrite X in Meq; clear X.
  injection Meq; clear Meq; intro; subst v0'; right;
    sui2; sui1; assumption.
  apply objRangeSetRangeSubset; rewrite toEq; 
    sui1; rewrite <- BGeqv; assumption.

  (* now for the gray objects *)
  unfold hpredTrue; rewrite <- G'eq; rewrite WMeqv; rewrite toObjs'Eq; 
    replace (W |_| M) with frObjs; [idtac | reflexivity].
  rewrite (set_eqvUnionSymm (set_add alloc' empty_set) (toObjs |_| B'' |_| G'')).
  rewrite <- (set_eqvUnionAssoc frObjs (toObjs |_| (B'' |_| G'')) (set_add alloc' empty_set)).
    rewrite <- (set_eqvUnionAssoc frObjs toObjs (B'' |_| G'')).
  apply objHpMerge; scm.
  (* G' *)
  apply objHpWeaken with (S := frObjs |_| toObjs).
  unfold objHp; apply (fasImplI Hp).
  unfold objCopied; unfold fieldCopied; clear h Hp; cbv beta; intros x h I Hp; lle Hp.
  assert (HpX' : s |||- top ** top ** top ** (okObjAt (frObjs |_| toObjs) x ** top) ** top).
  clear H3 H4; scm.
  assert (Ix : set_In x G).
  rewrite Geq; sui2; assumption.
  hypReplace Hp0 (objHpElim Ix Hp0); scm.
  unfold okObjAt in HpX'; unfold okFieldAt in HpX'; lle HpX'.
  assert (X1 := contContEq H3 HpX'); 
    sconjLift2 HpX'; assert (X2 := contContEq H4 HpX'); subst x3 x2; clear H3 H4 HpX'.
  unfold okObjAt; unfold okFieldAt; lli; eauto.
  intros x Ix; sui1; sui1; assumption.
  (* G'' *)
  apply objHpWeaken with (S := frObjs).
  unfold objHp; apply (fasImplI Hp); clear h Hp.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied;
    intros x h I Hp; lle Hp.
  assert (HX : s |||- top ** (okObjAt frObjs x0 ** top) ** top).
  clear H6 H7; scm.
  assert (Ix : set_In x0 W).
  rewrite Weq; sui1; destruct Iso' as [Iso' _]; destruct (Iso' x0) as [_ Q];
    apply Q; rewrite H1; discriminate.
  hypReplace Hp0 (objHpElim Ix Hp0); scm.
  unfold okObjAt in HX; unfold okFieldAt in HX; lle HX.
  assert (X1 := contContEq HX H6); sconjLift2 HX; assert (X2 := contContEq HX H7); 
    clear H6 H7 HX; subst x3 x4.
  unfold okObjAt; unfold okFieldAt; lli.
  2:eauto.
  assumption.
  assumption.
  intros x Ix; sui1; sui1; 
    sui1; assumption.
  (* done showing the virtual heap is well-typed *)

  clear Vhp Vhp'; rename Vhp'' into Vhp.
  constructor.
  hyr Hp' (sconjInsert Hp' Vhp); clear Vhp; lle Hp'; sconjLift4 Hp'.
  apply (sconjImplR Hp'); clear Hp'; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift5 Hp; sconjLift5 Hp; hyr Hp (sconjAssocR (sconjAssocR Hp)).
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite BBBeq.
  simpl; apply objHpIntro; scm.
  rewrite v0Eq in Hp; hpunfold; lli; scm; left; constructor; constructor.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite G3eq; assumption.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite <- F'eq'; assumption.
  sconjLift5 Hp; sconjLift5 Hp; sconjLift5 Hp; sconjLift5 Hp.
  unfold gcHpPtrMem' in Hp; lle Hp; lli; assumption.

  (* now show that the virtual heap is represented in the full heap properly *)
  clear HpB HpX Req; subst vh'; sconjLift2 Vhp.

  assert (Meven : forall x, set_In x (M |_| M') -> even x).
  intros y Iy; sconjLift2 Hp'; assert (HX : s' |||- (y |->_ ** top) ** top).
  scm.
  hyr Hp (mapHpElim1 Iy Hp); lleim.
  apply ptrPeven; lle HX; eapply contElim1L; eauto.

  assert (W'even : forall x, set_In x W' -> even x).
  intros y Iy; sconjLift2 Vhp; assert (HX : h' ||- (y |->_ ** top) ** top).
  scm.
  hyr Hp (objHpElim Iy Hp); unfold okObjAt in Hp; unfold okFieldAt in Hp; lleim.
  apply ptrPeven; lle HX; eapply contElim1L; eauto.

  assert (NIM : forall x, odd x \/ set_In x toObjs' -> ~set_In x (M |_| M')).
  intros y Iy Iy'.
  destruct Iy as [Iy | Iy].
  apply (not_even_and_odd y); auto.
  apply (set_disj_elim spD y); apply objRangeSetRangeSubset.
  rewrite <- WMeq; subst frObjs; set_InElim.
  sui2; assumption.
  rewrite Weq; sui1; sui1; assumption.
  rewrite toEq; assert (I' : set_In y ((set_add alloc' empty_set) |_| (B |_| G) |_| B'' |_| G'')).
  rewrite <- BGeqv; rewrite <- toObjs'Eq; assumption.
  clear Iy Iy'; rewrite Feq; set_InElim.
  sui2; sui2; left; subst y; reflexivity.
  elf; exact H0.
  sui1; sui1; assumption.
  sui1; sui2; assumption.
  sui2; sui1; sui1; assumption.
  sui2; sui1; sui2; assumption.

  assert (Vhp' : Heap.uset (Heap.uset h' alloc' 1) (4 + alloc') 1 ||- 
    4 + alloc' |-> 1 ** alloc' |-> 1 ** objHp toObjs' (B |_| B' |_| B'') **
            objHp (W' |_| M |_| M') W' **
            objHp ((W' |_| M |_| M') |_| toObjs')
              (set_diff G (B' |_| B'') |_| G'')).
  assert (HH : Heap.uset h' alloc' 1 ||- alloc' |-> 1 **
    objHp toObjs' (B |_| B' |_| B'') ** objHp (W' |_| M |_| M') W' **
    objHp ((W' |_| M |_| M') |_| toObjs') (set_diff G (B' |_| B'') |_| G'')).
  apply heapAddOk.
  assumption.
  sconjLift4 Hp'; hpunfoldIn Hp'; lle Hp'.
  rewrite v0Eq in Hp'; eapply contElim1L; eauto.
  intro Z; lle Z.
  clear Vhp; hyr Hp' (sconjInsert Hp' Z);
    sconjLift4 Hp'; sconjLift2 Hp'; 
    rewrite v0Eq in Hp'; hpunfoldIn Hp'; linLogElim Hp'.
  apply heapAddOk.
  assumption.
  sconjLift4 Hp'; hpunfoldIn Hp'; lle Hp'.
  rewrite v0Eq in Hp'; sconjLift2 Hp'; eapply contElim1L; eauto.
  intro Z; lle Z.
  rewrite v0Eq in Hp'; sconjLift4 Hp'; hpunfoldIn Hp'; linLogElim Hp'.
  hyr Hp' (contUpdateSt Hp' 1).
  sconjLift3 Hp'; sconjLift2 Hp'; hyr Hp' (heapEqvAdd Hp').
  clear Vhp; hyr Hp' (sconjInsert Hp' Z);
    sconjLift4 Hp'; sconjLift2 Hp'; lle Hp'; sconjLift3 Hp'; lle Hp'.

  clear Vhp; rename Vhp' into Vhp.
  replace (Heap.uset (Heap.uset h' alloc' 1) (4 + alloc') 1) with
    (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1)) in Vhp
    by reflexivity.

  (* the heap is not quite in the form we need for using our
     map_mapRange lemmas, so first we must fix that *)

  set (mphi := 
    (fun x => match map_union phi phi' x with | Some y => y | None => x end)) in * .

  assert (Mphi1 : mphi 1 = 1).
  subst mphi; cbv beta.
  destruct Iso as [Iso _]; destruct (Iso 1) as [_ Q].
  destruct (map_union phi phi' 1).
  elf; apply (not_even_and_odd 1).
  apply Meven; apply Q; discriminate.
  constructor; constructor.
  reflexivity.

  eapply heapEqvTrue.
  instantiate (1 := Heap.HeapMap.map_mapRange mphi 
    (Heap.uset (Heap.uset h' alloc' 1) (4 + alloc') 1)).
  apply Heap.heap_eqvTrans with
    (Heap.uset (Heap.uset (Heap.HeapMap.map_mapRange mphi h') alloc' 1) (4 + alloc') 1).
  apply Heap.heap_eqvRefl.
  apply Heap.heap_eqvTrans with
    (Heap.uset (Heap.uset (Heap.HeapMap.map_mapRange mphi h') alloc' (mphi 1)) (4 + alloc') (mphi 1)).
  rewrite Mphi1.
  apply Heap.heap_eqvRefl.
  apply Heap.heap_eqvRefl.

  (* now we can use the lemmas *)
  hyr Vhp (sconjAssocR (sconjAssocR Vhp)).
  apply (sconjMapRangeImplS Vhp); clear Vhp; intros h Sub Hp.
  rename h into h0; unfold hpredTrue; rewrite BBBeq; apply fasMerge.
  apply (sconjMapRangeImplS Hp); clear Hp; intros h Sub0 Hp.

  (* new object *)
  apply fasIntro.
  hyr Hp (unitIR Hp); 
    apply (sconjMapRangeImpl Hp); clear h Sub Sub0 Hp; intros h Hp.
  sconjLift2of2 Hp; hpunfold; apply (sconjMapRangeImpl Hp); clear h Hp; intros h Hp.
  lli.
  2:apply (contMapRangeImpl Hp).
  rewrite Mphi1; lle Hp'; sconjLift4 Hp'; rewrite v0Eq in Hp'; scm.
  lli.
  2:apply (contMapRangeImpl Hp).
  rewrite Mphi1; lle Hp'; sconjLift5 Hp'; rewrite v0Eq in Hp'; scm.
  apply fasIntroE; apply unitMapRangeImpl; auto.
  intro I; exact I.

  (* now for the black objects *)
  unfold objHp in Hp; rename h into h0';
    apply (fasMapRangeImplIS Hp); clear Hp; intros h x Sub' _ Hp.
  rewrite v0Eq in Hp'.
  assert (Sub'' : Heap.subHeap h (heapOf s')).
  assert (Sub'' : Heap.subHeap h 
    (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1))).
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  assert (SubX : Heap.subHeap h' (heapOf s')).
  eapply sconjEqSubHeap; eauto.
  intros l v E; hyr E (Sub'' _ _ E).
  replace (Heap.get (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1)) l)
    with (hget (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1) l) in E.
  rewrite <- E; clear Sub''.
  2:reflexivity.
  assert (PP : ptrP l).
  unfold hget in E; unfold Heap.get in E.
  assert (IP := isPtrOk l); destruct (isPtr l).
  assumption.
  discriminate E.
  assert (PPal : ptrP alloc').
  lle Hp'; sconjLift4 Hp'; apply (contElim1L Hp').
  assert (PPal4 : ptrP (4 + alloc')).
  lle Hp'; sconjLift5 Hp'; apply (contElim1L Hp').
  lle Hp'; compare l (4 + alloc'); intro NE.
  subst l; sconjLift5 Hp'; rewrite (contGetEqL Hp').
  rewrite (hgetEq PP); reflexivity.
  rewrite hgetNeq.
  sconjLift4 Hp'; compare l alloc'; intro NE'.
  subst l; rewrite (contGetEqL Hp'); rewrite (hgetEq PP); reflexivity.
  rewrite (hgetNeq PP _ PPal4 NE) in E; rewrite (hgetNeq PP _ PPal NE') in E.
  rewrite (hgetNeq PP _ PPal NE'); rewrite E; hyr SubX (SubX _ _ E); rewrite SubX; auto.
  assumption.
  assumption.
  assumption.
  (* showed the subheap thing *)

  clear h0 h0' h' Sub Sub' Sub0 Hp'; subst mphi.
  unfold okObjAt, okFieldAt in Hp; lle Hp.
  assert (Hp' := subHeapImpl Hp Sub''); lle Hp'.
  unfold objCopiedH, fieldCopiedH; lli.
  2:apply (sconjMapRangeImpl Hp); intros h' Hp''; apply (contMapRangeImpl Hp'').
  cbv beta; destruct Iso as [Iso _]; destruct (Iso x0) as [_ Iso0];
    destruct (map_union phi phi' x0).
  elf; apply (NIM x0 H3); apply Iso0; discriminate.
  scm.
  cbv beta; destruct Iso as [Iso _]; destruct (Iso x1) as [_ Iso0];
    destruct (map_union phi phi' x1).
  elf; apply (NIM x1 H4); apply Iso0; discriminate.
  sconjLift2 Hp'; scm.

  assert (HH : h0 ||- fasd (set_add alloc' empty_set) ** fasd (B |_| B' |_| B'')).
  scm.
  sconjLift2of2 Hp; hyr Hp (unitIR Hp); apply fasIntro; scm; lli; scm.
  hyr Hp (objHpIsObjs Hp); llMatch; lleim.
  apply (fasFasDisj' HH); auto.

  (* done dealing with the black objects.  now for the gray and white ones. *)
  rewrite v0Eq in Hp'.
  unfold hpredTrue; rewrite G3eq; sconjLift2of2 Hp; apply fasMerge.
  unfold objRespMapH, fieldRespMapH;
    unfold objHp in Hp; rename h into h0; apply (sconjMapRangeImplS Hp); 
      clear Hp; intros h1 Sub' Hp;
	apply (fasMapRangeImplIS Hp); clear Hp; intros h x Sub'' _ Hp.

  assert (Sub3 : Heap.subHeap h (heapOf s')).
  assert (Sub3 : Heap.subHeap h 
    (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1))).
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  assert (SubX : Heap.subHeap h' (heapOf s')).
  eapply sconjEqSubHeap; eauto.
  intros l v E; hyr E (Sub3 _ _ E).
  replace (Heap.get (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1)) l)
    with (hget (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1) l) in E.
  rewrite <- E; clear Sub'' Sub3.
  2:reflexivity.
  assert (PP : ptrP l).
  unfold hget in E; unfold Heap.get in E.
  assert (IP := isPtrOk l); destruct (isPtr l).
  assumption.
  discriminate E.
  assert (PPal : ptrP alloc').
  lle Hp'; sconjLift4 Hp'; apply (contElim1L Hp').
  assert (PPal4 : ptrP (4 + alloc')).
  lle Hp'; sconjLift5 Hp'; apply (contElim1L Hp').
  lle Hp'; compare l (4 + alloc'); intro NE.
  subst l; sconjLift5 Hp'; rewrite (contGetEqL Hp').
  rewrite (hgetEq PP); reflexivity.
  rewrite hgetNeq.
  sconjLift4 Hp'; compare l alloc'; intro NE'.
  subst l; rewrite (contGetEqL Hp'); rewrite (hgetEq PP); reflexivity.
  rewrite (hgetNeq PP _ PPal4 NE) in E; rewrite (hgetNeq PP _ PPal NE') in E.
  rewrite (hgetNeq PP _ PPal NE'); rewrite E; hyr SubX (SubX _ _ E); rewrite SubX; auto.
  assumption.
  assumption.
  assumption.

  subst mphi; clear h0 Sub h1 Sub' Sub''.
  unfold okObjAt in Hp; unfold okFieldAt in Hp; lle Hp.
  assert (HpX := subHeapImpl Hp Sub3); lle HpX.
  lli.
  2:apply (sconjMapRangeImpl Hp); intros h'' Hp''; apply (contMapRangeImpl Hp'').
  (* first field *)
  exists x0; constructor.
  scm.
  clear h Sub3 Hp; clear x1 H4 HpX; rename H3 into okF.
  assert (DD : (odd x0 \/ set_In x0 toObjs') \/ set_In x0 W' \/ set_In x0 (M |_| M')).
  destruct okF as [okF | okF].
  left; left; assumption.
  destruct (set_union_elim okF) as [I | I]; [right | auto]; clear okF;
    destruct (set_union_elim I); auto.
  unfold mapX; unfold map_union at 1; clear okF; destruct DD as [DD | [DD | DD]].
  hyr NIM (NIM _ DD); clear DD.
  destruct Iso as [Iso _]; destruct (Iso x0) as [_ X];
    destruct (map_union phi phi' x0); clear Iso.
  elf; apply NIM; apply X; discriminate.
  destruct (isOdd x0); reflexivity.
  destruct Iso as [Iso _]; destruct (Iso x0) as [_ X];
    destruct (map_union phi phi' x0); clear Iso.
  rewrite isOddFalse; auto.
  destruct (isOdd x0); reflexivity.
  rewrite isOddFalse.
  destruct (map_union phi phi' x0); reflexivity.
  auto.
  (* second field *)
  exists x1; constructor.
  sconjLift2 HpX; scm.
  clear h Sub3 Hp; clear x0 H3 HpX; rename H4 into okF; rename x1 into x0.
  assert (DD : (odd x0 \/ set_In x0 toObjs') \/ set_In x0 W' \/ set_In x0 (M |_| M')).
  destruct okF as [okF | okF].
  left; left; assumption.
  destruct (set_union_elim okF) as [I | I]; [right | auto]; clear okF;
    destruct (set_union_elim I); auto.
  unfold mapX; unfold map_union at 1; clear okF; destruct DD as [DD | [DD | DD]].
  hyr NIM (NIM _ DD); clear DD.
  destruct Iso as [Iso _]; destruct (Iso x0) as [_ X];
    destruct (map_union phi phi' x0); clear Iso.
  elf; apply NIM; apply X; discriminate.
  destruct (isOdd x0); reflexivity.
  destruct Iso as [Iso _]; destruct (Iso x0) as [_ X];
    destruct (map_union phi phi' x0); clear Iso.
  rewrite isOddFalse; auto.
  destruct (isOdd x0); reflexivity.
  rewrite isOddFalse.
  destruct (map_union phi phi' x0); reflexivity.
  auto.

  (* now for the last set of objects *)
  assert (Sub3 : Heap.subHeap h (heapOf s')).
  assert (Sub3 : Heap.subHeap h 
    (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1))).
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  assert (SubX : Heap.subHeap h' (heapOf s')).
  eapply sconjEqSubHeap; eauto.
  intros l v E; hyr E (Sub3 _ _ E).
  replace (Heap.get (heapOf (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1)) l)
    with (hget (uhset (uhset (h', rfileOf s') alloc' 1) (4 + alloc') 1) l) in E.
  rewrite <- E; clear Sub'' Sub3.
  2:reflexivity.
  assert (PP : ptrP l).
  unfold hget in E; unfold Heap.get in E.
  assert (IP := isPtrOk l); destruct (isPtr l).
  assumption.
  discriminate E.
  assert (PPal : ptrP alloc').
  lle Hp'; sconjLift4 Hp'; apply (contElim1L Hp').
  assert (PPal4 : ptrP (4 + alloc')).
  lle Hp'; sconjLift5 Hp'; apply (contElim1L Hp').
  lle Hp'; compare l (4 + alloc'); intro NE.
  subst l; sconjLift5 Hp'; rewrite (contGetEqL Hp').
  rewrite (hgetEq PP); reflexivity.
  rewrite hgetNeq.
  sconjLift4 Hp'; compare l alloc'; intro NE'.
  subst l; rewrite (contGetEqL Hp'); rewrite (hgetEq PP); reflexivity.
  rewrite (hgetNeq PP _ PPal4 NE) in E; rewrite (hgetNeq PP _ PPal NE') in E.
  rewrite (hgetNeq PP _ PPal NE'); rewrite E; hyr SubX (SubX _ _ E); rewrite SubX; auto.
  assumption.
  assumption.
  assumption.

  subst mphi; clear h0 Sub h1 Sub' Sub''.
  unfold okObjAt, okFieldAt in Hp; lle Hp.
  assert (HpX := subHeapImpl Hp Sub3); lle HpX; clear Sub3.
  lli.
  2:apply (sconjMapRangeImpl Hp); intros h'' Hp''; apply (contMapRangeImpl Hp'').
  (* first field *)
  exists x0; constructor.
  scm.
  unfold mapX; unfold map_union at 1.
  destruct Iso as [Iso _]; destruct (Iso x0) as [_ Iso3].
  clear h x Hp HpX; clear x1 H4; destruct H3 as [okF | okF].
  rewrite (isOddTrue okF); destruct (map_union phi phi' x0).
  elf; apply (NIM x0).
  left; assumption.
  apply Iso3; discriminate.
  reflexivity.
  destruct (set_union_elim okF) as [I | I]; clear okF.
  rewrite (isOddFalse (W'even _ I)).
  destruct (map_union phi phi' x0); reflexivity.
  rewrite (isOddFalse (Meven _ I)).
  destruct (map_union phi phi' x0); reflexivity.
  (* second field *)
  exists x1; constructor.
  sconjLift2 HpX; scm.
  unfold mapX; unfold map_union at 1.
  destruct Iso as [Iso _]; destruct (Iso x1) as [_ Iso3].
  clear h x H Hp HpX; clear x0 H3; rename x1 into x0; destruct H4 as [okF | okF].
  rewrite (isOddTrue okF); destruct (map_union phi phi' x0).
  elf; apply (NIM x0).
  left; assumption.
  apply Iso3; discriminate.
  reflexivity.
  destruct (set_union_elim okF) as [I | I]; clear okF.
  rewrite (isOddFalse (W'even _ I)).
  destruct (map_union phi phi' x0); reflexivity.
  rewrite (isOddFalse (Meven _ I)).
  destruct (map_union phi phi' x0); reflexivity.

  (* show disjointedness.  again. *)
  unfold objHp, okObjAt, okFieldAt in Hp; eapply fasFasDisj';
    eauto; cbv beta; illeim.

  (* show the registers are okay *)
  clear Hp Guar B G F spD toEq cpObjs rangeMerge1 toObjs rootOk Iso
    Al1 Al2 Al3 Al4 Al5 W M phi WMeq Ne frObjs.
  constructor.
  unfold calleeSavedOk; unfold calleeSaved.
  intros r E.
  destruct (regCompare r ra).
  subst r; auto.
  simpl in E.
  rewrite <- Req; clear Req.
  intuition; try (elf; assumption); subst r; stSimpl; try reflexivity.
  intuition; try (elf; assumption); subst r; try regNotInListSolver.
  auto.

Qed.


Lemma bakerAllocFlipVHeapCopyOk : forall frStart frEnd toStart toEnd M W B G F h h' vh phi A,
  set_eqv (rangeObjs frStart frEnd) (M |_| W) ->
  set_eqv (rangeObjs toStart toEnd) (B |_| G |_| F) ->
  set_disj (setRange frStart frEnd) (setRange toStart toEnd) -> 
  h ||- objHp (rangeObjs frStart frEnd) (rangeObjs frStart frEnd) ** top ->
  h' ||- Heap.heap_eqv vh ** A ->
  vh ||- objHp (W |_| M) W **
   (foralls x in B, objIsFwdedH (map_union (spaceIdMap toStart toEnd) phi) h x) **
   (foralls x in G, objCopiedPhi phi (h, fun _ => 0) x) ->
  iso_set phi M (B |_| G) ->
  Heap.HeapMap.map_mapRange
  (fun x => match mapX phi x with | Some y => y | None => x end) vh
  ||- (foralls x in B, objCopiedH x h' x) **
    (foralls x in G |_| W, objRespMapH (map_union phi (Some (A := nat))) h' x).
Proof.
  intros frStart frEnd toStart toEnd M W B G F h h' vh phi A
    frEq toEq ftD Hp Hp' Vhp Iso.

  assert (Vhp' : vh ||- 
    (foralls x in B, lexists v0, lexists v1, 
      !(h' ||- x |-> v0 ** top /\ h' ||- 4 + x |-> v1 ** top /\
	~set_In v0 M /\ ~set_In v1 M) **
      x |->, (v0::v1::nil)) **
    (foralls x in G |_| W, objCopiedH x h' x)).
  sconjLift2 Vhp.
  apply (sconjImplS Vhp); clear Vhp.

  (* show the B part of the new goal *)
  intros h'' Sub Hp''.
  eapply fasImplIS.
  apply Hp''.
  clear Hp''; cbv beta; intros x vh' _ Sub'' Vhp'.

  assert (Sub' : Heap.subHeap vh' h').
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply sconjEqSubHeap; eauto.

  clear Sub Sub'' h'' Hp'.
  unfold objIsFwdedH in Vhp'; lle Vhp'.
  destruct H1 as [x2 [v0 [v1 [_ [_ [Meq0 Meq1]]]]]].
  lli.
  2:eauto.
  simpl in Vhp'; constructor.
  assert (X : h' ||- (x |-> x0 ** top) ** top).
  eapply subHeapImpl; eauto; scm.
  lle X; exact X.
  constructor.
  assert (X : h' ||- (4 + x |-> x1 ** top) ** top).
  sconjLift2of2 Vhp'; eapply subHeapImpl; eauto; sconjMatch.
  lle X; exact X.
  clear x2 Vhp'.
  constructor; [clear x1 v1 Meq1 | clear x0 v0 Meq0].

  (* first field *)
  intro I; unfold mapX in Meq0.
  assert (X := isOddOk v0).
  destruct (isOdd v0).
  injection Meq0; clear Meq0; intro; subst x0.
  apply (not_even_and_odd v0).
  apply ptrPeven.
  assert (Hp' : h ||- ((v0 |->_ ** top) ** top) ** top).
  sconjMatch.
  assert (I0 : set_In v0 (rangeObjs frStart frEnd)).
  rewrite frEq; sui1; assumption.
  hyr Hp (objHpElim I0 Hp); clear I0; sconjMatch.
  unfold okObjAt in Hp; unfold okFieldAt in Hp; lle Hp; lli; sconjMatch.
  lle Hp'; eapply contElim1L; eauto.
  assumption.
  clear X; unfold map_union in Meq0.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  destruct (spaceIdMap toStart toEnd v0).
  injection Meq0; clear Meq0; intro; subst n.
  assert (Y := set_memSound v0 (setRange toStart toEnd)).
  destruct (set_mem v0 (setRange toStart toEnd)).
  injection X; clear X; intro; subst x0.
  apply (set_disj_elim ftD v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; sui1; assumption.
  assumption.
  discriminate X.
  assert (Y := set_memSound v0 (setRange toStart toEnd)).
  destruct (set_mem v0 (setRange toStart toEnd)); [discriminate X | clear X Y].
  apply (set_disj_elim ftD x0); apply objRangeSetRangeSubset.
  rewrite frEq; sui1; assumption.
  rewrite toEq; rewrite <- (set_eqvUnionAssoc B G F); sui1;
    destruct Iso as [_ [Iso _]]; eapply Iso; eauto.
  
  (* other field: same as first *)
  rename Meq1 into Meq0; rename x1 into x0; rename v1 into v0.
  intro I; unfold mapX in Meq0.
  assert (X := isOddOk v0).
  destruct (isOdd v0).
  injection Meq0; clear Meq0; intro; subst x0.
  apply (not_even_and_odd v0).
  apply ptrPeven.
  assert (Hp' : h ||- ((v0 |->_ ** top) ** top) ** top).
  sconjMatch.
  assert (I0 : set_In v0 (rangeObjs frStart frEnd)).
  rewrite frEq; sui1; assumption.
  hyr Hp (objHpElim I0 Hp); clear I0; sconjMatch.
  unfold okObjAt in Hp; unfold okFieldAt in Hp; lle Hp; lli; sconjMatch.
  lle Hp'; eapply contElim1L; eauto.
  assumption.
  clear X; unfold map_union in Meq0.
  assert (X := set_memSpaceIdMap toStart toEnd v0).
  destruct (spaceIdMap toStart toEnd v0).
  injection Meq0; clear Meq0; intro; subst n.
  assert (Y := set_memSound v0 (setRange toStart toEnd)).
  destruct (set_mem v0 (setRange toStart toEnd)).
  injection X; clear X; intro; subst x0.
  apply (set_disj_elim ftD v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; sui1; assumption.
  assumption.
  discriminate X.
  assert (Y := set_memSound v0 (setRange toStart toEnd)).
  destruct (set_mem v0 (setRange toStart toEnd)); [discriminate X | clear X Y].
  apply (set_disj_elim ftD x0); apply objRangeSetRangeSubset.
  rewrite frEq; sui1; assumption.
  rewrite toEq; rewrite <- (set_eqvUnionAssoc B G F); sui1;
    destruct Iso as [_ [Iso _]]; eapply Iso; eauto.
  
  (* handle the G and W objects *)
  unfold objHp.
  cbv beta; intros hx Sub' Hp''.
  sconjLift2of2 Hp''; apply fasMerge.
  apply (sconjImplS Hp''); clear Hp''; cbv beta; intros h'' Sub'' Hp''; eapply fasImplIS.
  apply Hp''.
  2:apply Hp''.
  clear Hp''.
  cbv beta; intros x hy _ Sub3; assert (Sub : Heap.subHeap hy h').
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply sconjEqSubHeap; eauto.
  clear Sub' Sub'' Sub3 h'' hx; rename hy into h''.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied;
    unfold objCopiedH; unfold fieldCopiedH; stSimpl.
  intro Hp''; lle Hp''; lli.
  2:eauto.
  assert (X : h' ||- (x |-> x1 ** top) ** top).
  eapply subHeapImpl; eauto; sconjMatch.
  lle X; exact X.
  assert (X : h' ||- (4 + x |-> x2 ** top) ** top).
  sconjLift2of2 Hp''; eapply subHeapImpl; eauto; sconjMatch.
  lle X; exact X.
  unfold okObjAt, okFieldAt.
  cbv beta; clear Hp''; intros x hy _ Sub3 Hp''.
  assert (Sub : Heap.subHeap hy h').
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply sconjEqSubHeap; eauto.
  clear Sub' Sub'' Sub3 h'' hx.
  unfold objCopiedH; unfold fieldCopiedH; lle Hp''; lli.
  2:eauto.
  assert (X : h' ||- (x |-> x0 ** top) ** top).
  eapply subHeapImpl; eauto; sconjMatch.
  lle X; exact X.
  assert (X : h' ||- (4 + x |-> x1 ** top) ** top).
  sconjLift2of2 Hp''; eapply subHeapImpl; eauto; sconjMatch.
  lle X; exact X.
  eapply fasFasDisj'; eauto.
  unfold objCopiedPhi, objCopied, fieldCopied; intros hh x HH; llei HH; scm.
  unfold okObjAt, okFieldAt; intros hh x HH; llei HH; scm.


  (* show it works *)
  clear Vhp Hp' h Hp; rename Vhp' into Vhp.
  eapply sconjMapRangeImpl; eauto.
  clear Vhp.
  intros h Hp; eapply fasMapRangeImpl.
  apply Hp.
  clear h Hp; cbv beta; intros h x Hp.
  lle Hp; simpl in Hp.
  destruct H1 as [Hp'0 [Hp'1 [NI0 NI1]]].
  unfold objCopiedH; unfold fieldCopiedH; lli; [eauto | idtac | eauto].
  eapply sconjMapRangeImpl; eauto.
  clear h Hp; intros h Hp.
  hyr Hp (contMapRangeImpl Hp (fun x2 =>
      match mapX phi x2 with Some y => y | None => x2 end)).
  simpl in Hp.
  unfold mapX at 2 in Hp.
  destruct (isOdd x0).
  assumption.
  replace (phi x0) with (None (A := nat)) in Hp.
  assumption.
  symmetry; destruct Iso as [Iso _]; destruct (Iso x0) as [_ X].
  destruct (phi x0).
  elimtype False; apply NI0; apply X; discriminate.
  reflexivity.
  clear h Hp; intros h Hp.
  clear x0 NI0 Hp'0; rename x1 into x0; rename NI1 into NI0.
  hyr Hp (contMapRangeImpl Hp (fun x2 =>
      match mapX phi x2 with Some y => y | None => x2 end)).
  simpl in Hp.
  unfold mapX at 2 in Hp.
  destruct (isOdd x0).
  assumption.
  replace (phi x0) with (None (A := nat)) in Hp.
  assumption.
  symmetry; destruct Iso as [Iso _]; destruct (Iso x0) as [_ X].
  destruct (phi x0).
  elimtype False; apply NI0; apply X; discriminate.
  reflexivity.

  (* show the GW portion works*)
  clear vh Vhp.
  intros h Hp.
  apply (fasMapRangeImpl Hp); clear h Hp.
  unfold objCopiedH; unfold fieldCopiedH;
    intros h x Hp; lle Hp.
  unfold objRespMapH; unfold fieldRespMapH.

  clear frEq toEq frStart frEnd toStart toEnd ftD Iso M W B G F.

  assert (X0 : exists v0,
    (h' ||- x |-> v0 ** top) /\
    exists q, mapX (map_union phi (Some (A:=nat))) v0 = Some q /\
      match mapX phi v0 with | Some y => y | None => v0 end = q).
  exists x0; constructor.
  assumption.
  unfold mapX.
  destruct (isOdd x0).
  econstructor; auto.
  unfold map_union; destruct (phi x0); econstructor; auto.

  assert (X1 : exists v0,
    (h' ||- 4 + x |-> v0 ** top) /\
    exists q, mapX (map_union phi (Some (A:=nat))) v0 = Some q /\
      match mapX phi v0 with | Some y => y | None => v0 end = q).
  exists x1; constructor.
  assumption.
  unfold mapX.
  destruct (isOdd x1).
  econstructor; auto.
  unfold map_union; destruct (phi x1); econstructor; auto.

  destruct X0 as [v0 [Hp0 [q0 [Meq0 Zeq0]]]].
  destruct X1 as [v1 [Hp1 [q1 [Meq1 Zeq1]]]].
  lli.
  instantiate (1 := q0); exists v0; auto.
  2:instantiate (1 := q1); exists v1; auto.
  assert (X := contContEq H3 Hp0); assert (X' := contContEq H4 Hp1); subst x0 x1.
  clear h' H3 H4 Hp0 Hp1.
  apply (sconjMapRangeImpl Hp); clear h Hp;
    intros h Hp;
      hyr Hp (contMapRangeImpl Hp (fun x2 =>
	match mapX phi x2 with Some y => y | None => x2 end));
      cbv beta in Hp.
  rewrite <- Zeq0; assumption.
  rewrite <- Zeq1; assumption.
  
Qed.


Lemma bakerAllocOk : iseqOkS Pbaker bakerAllocPre bakerAllocGuar bakerAlloc.
Proof.
  unfold bakerAlloc.
  iseqWeakSolver PbakerSimpl.

  exact scanFieldGuarPresRa.

  intros s [vh Hp].
  destruct Hp as [frStart [frEnd [toStart [toEnd [scan [free [alloc [rootEq H]]]]]]]].
  destruct H as [phi [W [M H]]].
  destruct H as [Als [Al5 [WMeq [iso [rootOk [Hp Vhp]]]]]].
  sconjLift6of6 Hp; lle Hp.
  replace (4 + (4 + rget s rgcInfo)) with (8 + rget s rgcInfo) in Hp by omega.
  replace (4 + (8 + rget s rgcInfo)) with (12 + rget s rgcInfo) in Hp by omega.
  replace (4 + (12 + rget s rgcInfo)) with (16 + rget s rgcInfo) in Hp by omega.
  replace (4 + (16 + rget s rgcInfo)) with (20 + rget s rgcInfo) in Hp by omega.
  replace (4 + (20 + rget s rgcInfo)) with (24 + rget s rgcInfo) in Hp by omega.
  assert (Hp0X := Hp).

  simpl in Als.
  destruct Als as [Al1 [Al2 [Al3 Al4]]].

  rewrite (lwStep Hp); try reflexivity.
  sconjLift2 Hp; rewrite (lwStep Hp); try reflexivity.
  sconjLift3 Hp; rewrite (lwStep Hp); try reflexivity.
  sconjLift4 Hp; rewrite (lwStep Hp); try reflexivity.
  sconjLift5 Hp; rewrite (lwStep Hp); try reflexivity.
  sconjLift6 Hp; rewrite (lwStep Hp); try reflexivity.
  sconjLift7 Hp; rewrite (lwStep Hp); try reflexivity.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  
  unfold doBtest; unfold negb; unfold Bool.negb.
  compare free alloc; intro FAeq.

  2:rewrite (beq_false FAeq).

  (* no free space: flip before collecting *)
  subst alloc; rewrite beq_true.
  Focus 1.

  rewrite sltuStep; stSimpl.
  assert (LT : scan < free \/ free <= scan).
  omega.
  destruct LT as [LT | Le0].

  (* we haven't finished scanning, so we must abort *)
  rewrite (blt_true LT).
  rewrite beq_false; [idtac | discriminate].
  intuition.

  (* we're done scanning, so we can flip and continue*)
  rewrite (blt_false Le0).
  rewrite beq_true.

  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.

  sconjLift7 Hp.
  rewrite (swStep Hp); [stSimpl | reflexivity | stSimpl ; reflexivity].
  hyr Hp (contUpdateSt Hp toStart).
  sconjLift7 Hp.
  rewrite (swStep Hp); [stSimpl  | reflexivity | stSimpl ; reflexivity].
  hyr Hp (contUpdateSt Hp toEnd).
  sconjLift7 Hp.
  rewrite (swStep Hp); [stSimpl | reflexivity | stSimpl ; reflexivity].
  hyr Hp (contUpdateSt Hp frStart).
  sconjLift7 Hp.
  rewrite (swStep Hp); [stSimpl  | reflexivity | stSimpl ; reflexivity].
  hyr Hp (contUpdateSt Hp frEnd).
  stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  rewrite addiuStep0; stSimpl.
  sconjLift7 Hp.
  rewrite (swStep Hp); [stSimpl  | reflexivity | stSimpl ; reflexivity].
  hyr Hp (contUpdateSt Hp (rget s rroot)).
  rewrite addiuStep; stSimpl.

  (* perform the flip at the abstract level *)
  swapHyps frStart toStart.
  swapHyps frEnd toEnd.

  assert (E : scan = free).
  destruct Al2; omega.

  subst scan.
  clear Al3 Al2 Le0.

  assert (E : exists B, set_eqv B (rangeObjs frStart free)).
  econstructor; apply set_eqvRefl.
  destruct E as [B Beqv].

  assert (E : exists B', set_eqv B' (rangeObjs free frEnd)).
  econstructor; apply set_eqvRefl.
  destruct E as [B' B'eqv].

  assert (frObjsEq : set_eqv (set_union B (set_union (rangeObjs free free) B'))
    (set_union B B')).
  clear Hp.
  setoid_rewrite <- (set_eqvUnionAssoc B (rangeObjs free free) B').
  setoid_rewrite (set_eqvUnionSymm B (rangeObjs free free)).
  setoid_rewrite (set_eqvUnionAssoc (rangeObjs free free) B B').
  setoid_rewrite <- (set_eqvEmptyRangeObjs free).
  simpl.
  apply set_eqvRefl.

  assert (toObjsEq' : exists toObjs, toObjs = rangeObjs toStart toEnd).
  econstructor; reflexivity.

  destruct toObjsEq' as [toObjs toObjsEq'].

  assert (toObjsEq : set_eqv toObjs (set_union W M)).
  rewrite toObjsEq'; apply set_eqvSymm; assumption.
  assert (frObjsEq' : set_eqv (set_union B B') (rangeObjs frStart frEnd)).
  clear Hp.
  setoid_rewrite Beqv; setoid_rewrite B'eqv.
  apply rangeObjsTransEqv.
  assumption.
  destruct Al4; omega.

  assert (E : exists frObjs, frObjs = rangeObjs frStart frEnd).
  econstructor; reflexivity.

  destruct E as [frObjs frObjsEq''].

  assert (Hp' : Heap.uset
         (Heap.uset
            (Heap.uset
               (Heap.uset (Heap.uset (heapOf s) (rget s rgcInfo) frStart)
                  (4 + rget s rgcInfo) frEnd) (8 + rget s rgcInfo) toStart)
            (12 + rget s rgcInfo) toEnd) (16 + rget s rgcInfo) 
         (rget s rroot) ||- (foralls x in toObjs, x |->__) **
    objHp frObjs frObjs **
    rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::rget s rroot::free::free::nil) **
    top).
  hyr Hp (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR (sconjAssocR Hp)))))).
  sconjLift3 Hp; sconjLift3 Hp; hyr Hp (sconjAssocR Hp). sconjLift3 Hp; sconjLift2 Hp.
  scm.
  assert (Hp' : h ||- (foralls x in M, x |->__) ** (foralls x in W, x |->__)).
  scm.
  unfold mapHp in Hp; lle Hp. apply (fasImpl Hp).
  simpl; intros x h' Hp'; llei Hp'; eauto.
  unfold objHp in Hp. apply (fasImpl Hp).
  simpl; unfold okObjAt; unfold okFieldAt; intros x h' Hp'; llei Hp'; eauto.
  unfold hpredTrue.
  setoid_rewrite toObjsEq.
  apply fasMerge'.
  apply sconjComm; assumption.
  intros; scm.
  unfold hpredTrue in Hp.
  rewrite <- Beqv in Hp; rewrite <- B'eqv in Hp.
  rewrite frObjsEq in Hp; rewrite frObjsEq' in Hp; rewrite <- frObjsEq'' in Hp.
  assumption.
  lle Hp. sconjLift7of7 Hp; sconjLift2 Hp; sconjLift3 Hp;
    sconjLift4 Hp; sconjLift5 Hp; sconjLift6 Hp.
  assumption.

  clear Hp; rename Hp' into Hp.

  assert (AlFr : aligned8 frStart frEnd).
  destruct Al4; destruct Al1; subst; exists (x0 + x); omega.

  assert (rootOk' : okFieldVal frObjs (rget s rroot)).
  clear Hp.
  rewrite frObjsEq''; setoid_rewrite <- frObjsEq';
    setoid_rewrite <- frObjsEq; setoid_rewrite Beqv; setoid_rewrite B'eqv; assumption.

  rename phi into phiX.
  clear iso WMeq B'eqv Beqv frObjsEq frObjsEq' B B' toObjsEq Al4 Al1 rootOk Vhp.
  rename Al5 into AlTo.
  rename toObjsEq' into toObjsEq.
  rename frObjsEq'' into frObjsEq.
  rename rootOk' into rootOk.

  (* prove that it is okay to enter the loop once we've flipped *)

  assert (exists s', s' = Heap.uset
    (Heap.uset (Heap.uset (Heap.uset (Heap.uset (heapOf s) (rget s rgcInfo) frStart)
      (4 + rget s rgcInfo) frEnd) (8 + rget s rgcInfo) toStart)
    (12 + rget s rgcInfo) toEnd) (16 + rget s rgcInfo) (rget s rroot)).
  econstructor; reflexivity.

  destruct H as [h0 Seq]; rewrite <- Seq in Hp.

  apply callChain.

  unfold scanFieldPre; unfold scanFieldStOk; 
    unfold fromSpace; unfold toSpace; stSimpl.
  
  assert (Eeqv : set_eqv (set_union (rangeObjs frStart frEnd) empty_set)
    (rangeObjs frStart frEnd)).
  setoid_rewrite (set_eqvUnionSymm (rangeObjs frStart frEnd) empty_set); 
  apply set_eqvRefl.

  assert (Hp0Ok : h0 ||- 16 + rget s rgcInfo |-> rget s rroot ** top).
  sconjLift3of3 Hp; lle Hp; sconjLift5 Hp; scm.

  assert (stOk : 
    set_disj (setRange frStart frEnd) (setRange toStart toEnd) /\
    set_subset (set_union frObjs empty_set) (setRange frStart frEnd) /\
    set_eqv toObjs (rangeObjs toStart toEnd) /\
    toStart <= toEnd /\
    h0 ||- mapHp empty_set (fun n:nat => None (A:=nat)) **
      objHp (set_union frObjs empty_set) frObjs **
      (foralls x in toObjs, x |->__) **
      okFieldAt (set_union (set_union frObjs empty_set) (setRange toStart toEnd))
      (16 + rget s rgcInfo) ** rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::nil) **
	20 + rget s rgcInfo |->__ ** top).
  Focus 1.
  constructor.
  sconjLift2 Hp.
  eapply disjObjsDisjRange.
  instantiate (1 := h0); sconjMatch.
  rewrite <- frObjsEq.
  unfold objHp in Hp.
  eapply fasImpl.
  apply Hp.
  simpl; unfold okObjAt; unfold okFieldAt; 
    intros x h' Hp'; llei Hp'; eauto.
  rewrite <- toObjsEq; assumption.
  assumption.
  assumption.

  constructor.
  rewrite frObjsEq.
  setoid_rewrite Eeqv; clear Eeqv.
  eapply set_subsetTrans.
  apply objRangeAddrSetSubset.
  apply addrRangeSetRangeSubset.
 
  constructor.
  rewrite toObjsEq; apply set_eqvRefl.

  constructor.
  destruct AlTo; omega.

  (* now to prove the heap is okay *)
  assert (Hp' : h0 ||- unit ** objHp frObjs frObjs ** (foralls x in toObjs, x |->__) **
    okFieldAt (set_union frObjs (setRange toStart toEnd)) (16 + rget s rgcInfo) ** 
    rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) **
      20 + rget s rgcInfo |->__ ** top).
  lli.
  instantiate (1 := free).
  instantiate (1 := free).
  sconjLift2 Hp.
  apply (sconjImplR Hp); clear Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  lle Hp.
  sconjLift5 Hp; scm.
  unfold okFieldAt; lli.
  2:apply Hp.
  destruct rootOk; [left | right].
  assumption.
  sui1; assumption.

  clear Hp.
  subst h0.
  scm.
  apply mapHpIntroE; assumption.
  unfold hpredTrue.
  setoid_rewrite (set_eqvUnionSymm frObjs empty_set); assumption.
  unfold hpredTrue.
  setoid_rewrite (set_eqvUnionSymm frObjs empty_set); assumption.

  clear Hp.
  constructor.
  exists (fun n:nat => None (A:=nat)); stSimpl.
  exists (rangeObjs frStart frEnd).
  exists empty_set.
  exists toObjs.
  intuition.
  rewrite <- frObjsEq; assumption.
  discriminate H3.
  subst h0; sconjMatch.
  rewrite <- frObjsEq; assumption.
  rewrite <- frObjsEq; assumption.

  unfold scanFieldGuar; unfold scanFieldStOk; 
    unfold fromSpace; unfold toSpace; stSimpl.

  intros s' [G Req].
  assert (Guar0 := G).

  hyr G (G (fun n:nat => None (A:=nat))
    (rangeObjs frStart frEnd) empty_set toObjs
    (rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) **
      20 + rget s rgcInfo |->__ ** top)).

  rename W into Wx; rename M into Mx.
  destruct G as [M Guar].
  intuition.
  rewrite <- frObjsEq; assumption.
  discriminate H3.
  clear Hp0Ok; subst h0; scm.
  rewrite <- frObjsEq; assumption.
  rewrite <- frObjsEq; assumption.

  generalize dependent Guar.
  repeat (rewrite <- Req; [stSimpl | regNotInListSolver]).
  rewrite <- (Req rfrStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req rfrEnd); [stSimpl | regNotInListSolver].
  rewrite <- (Req rtoStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req rtoEnd); [stSimpl | regNotInListSolver].
  rewrite <- (Req ralloc); [stSimpl | regNotInListSolver].
  intro.
  destruct Guar as [W [F [G [phi [frEq [toEq [iso [AlFr0 [Wcopy
    [Disj [Sub [F'eq [Nsp [[Le1 Le2] [Le3 [AlFr' Hp]]]]]]]]]]]]]]]].

  Focus 1.

  replace (set_union empty_set M) with M in Hp by reflexivity.

  assert (Hp' : s' |||- mapHp M phi ** objHp (set_union W M) W **
    (foralls x in F, x |->__) ** 
    fieldRespMapH (map_unionnn (toSpaceIdMap 
      (rset (rset s rtoEnd toEnd) rtoStart toStart)) phi) h0 (16 + rget s rgcInfo) **
    (foralls x in G, objCopiedPhi phi (h0, rfileOf s) x) **
    rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) **
            20 + rget s rgcInfo |->__ ** top).
  scm.
  generalize dependent Hp; unfold fieldRespToMap; unfold fieldRespMap; stSimpl.
  intro; unfold fieldRespMapH; llei Hp.
  2:apply Hp.
  destruct H1 as [v0 [Hp0 Meq]].
  exists v0; constructor.
  subst h0; assumption.
  generalize dependent Meq; unfold spaceIdMap; stSimpl.
  unfold map_union; auto.
  apply (fasImpl Hp).
  cbv beta.
  intro x.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied; stSimpl.
  subst h0; auto.

  unfold restoreRootPre.
  unfold restoreRootGuar.

  unfold fieldRespMapH in Hp'.
  lle Hp'.

  assert (HpX : s' |||- 16 + rget s rgcInfo |-> x ** top).
  sconjLift4 Hp'; scm.

  rewrite <- Req; [stSimpl | regNotInListSolver].
  constructor.
  exists x.
  constructor.
  assumption.
  unfold bakerStLoaded; stSimpl.
  repeat (rewrite <- Req; [stSimpl | regNotInListSolver]).
  rewrite <- (Req ralloc); [stSimpl | regNotInListSolver].
  unfold bakerStOk'.
  rename vh into vs.

  assert (Hp1 := Hp').
  sconjLift2 Hp1; sconjLift5 Hp1; apply sconjAssocR in Hp1.
  destruct (sconjExtract Hp1) as [h' [Hp'' Vhp]]; clear Hp1.
  exists (Heap.HeapMap.map_mapRange (fun x => match mapX phi x with Some y => y | _ => x end) h', 
    fun _ : rnum => x).
  exists x; exists x0; exists x1.
  constructor.
  reflexivity.
  exists phi; exists W; exists M.

  constructor.
  simpl; intuition.
  apply aligned8Refl.
  apply aligned8Refl.

  constructor.
  assumption.
  simpl in Sub.
  constructor.
  rewrite frEq.
  apply set_eqvUnionSymm.

  assert (Geqv : set_eqv (rangeObjs toStart (rget s' rfree)) G).
  apply set_eqvSymm; eapply rangeSplit.
  instantiate (1 := toEnd).
  setoid_rewrite <- F'eq.
  sconjLift3 Hp'; sconjLift5 Hp'; apply (fasFasDisj Hp').
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros h z HH; llei HH; scm.
  intros; scm.
  destruct AlFr'; omega.
  setoid_rewrite <- F'eq.
  setoid_rewrite <- toEq; rewrite toObjsEq; apply set_eqvRefl.
  assumption.

  constructor.
  setoid_rewrite <- (set_eqvEmptyRangeObjs toStart); simpl.
  setoid_rewrite Geqv.
  assumption.

  destruct H9 as [v0 [Hp0 Meq0]].
  constructor.
  setoid_rewrite <- (set_eqvEmptyRangeObjs toStart).
  setoid_rewrite <- (set_eqvEmptyRangeObjs toEnd).
  setoid_rewrite Geqv.
  setoid_rewrite (set_eqvUnionSymm G empty_set); simpl.

  assert (Q := contContEq Hp0 Hp0Ok).

  subst v0.
  generalize dependent Meq0.
  unfold spaceIdMap; stSimpl.
  unfold mapX.

  assert (IO := isOddOk (rget s rroot)).
  destruct rootOk; destruct (isOdd (rget s rroot)).
  injection 1; intros; left; subst x; assumption.
  elimtype False; eapply not_even_and_odd; eauto.
  injection 1; intros; subst x.
  left; assumption.
  unfold map_unionnn; unfold map_union.
  assert (II : phi (rget s rroot) = Some x -> okFieldVal G x).
  intro Eq; right.
  destruct iso as [_ [iso _]].
  eauto.
  rewrite frObjsEq in H; destruct (rangeObjsElim H) as [H1 [k H2]].
  assert (D : (rget s rroot) < toEnd \/ (rget s rroot) >= toEnd).
  omega.
  assert (D' : toStart < (S (rget s rroot)) \/ toStart >= (S (rget s rroot))).
  omega.
  destruct D as [D | D]; [rewrite (blt_true D) | rewrite (blt_false D)].
  destruct D' as [D' | D']; [rewrite (blt_true D') | rewrite (blt_false D')].
  elimtype False; apply (set_disj_elim Disj (rget s rroot)); apply setRangeIntro.
  omega.
  omega.
  assumption.
  assumption.

  constructor.
  apply (sconjImplR Hp'); clear Hp Hp'; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  hyr Hp (unitIL Hp).
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue.
  setoid_rewrite <- (set_eqvEmptyRangeObjs toStart).
  setoid_rewrite <- (set_eqvEmptyRangeObjs toEnd).
  simpl.
  apply objHpIntroE; assumption.
  sconjLift3 Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; setoid_rewrite Geqv; unfold objHp.
  rewrite <- hpredTrueEq; eapply fasImpl.
  apply Hp.
  unfold objCopiedPhi; simpl; clear h Hp; intros x2 h Hp; lle Hp.
  assert (Ix3 : set_In x3 frObjs).
  rewrite frObjsEq; setoid_rewrite frEq; sui1.
  destruct iso.
  destruct (H x3) as [_ X].
  apply X; rewrite H1; discriminate.

  assert (h0 ||- (okObjAt frObjs x3 ** top) ** top).
  destruct stOk as [_ [_ [_ [_ HpY]]]].
  clear Hp0Ok Hp0.
  sconjLift2 HpY; scm.
  hyr Hp0 (objHpElim Ix3 Hp0).
  scm.
  replace frObjs with (set_union empty_set frObjs).
  unfold okObjAt in Hp0 |- *; unfold okFieldAt in Hp0 |- *; llei Hp0.
  2:eauto.
  setoid_rewrite (set_eqvUnionSymm empty_set frObjs); assumption.
  setoid_rewrite (set_eqvUnionSymm empty_set frObjs); assumption.
  reflexivity.
  unfold okObjAt in H; unfold okFieldAt in H; lle H.
  unfold objCopied in Hp; unfold fieldCopied in Hp; lle Hp.
  simpl in H6; simpl in H7.
  assert (Q := contContEq H H6); subst x6.
  sconjLift2 H; assert (Q := contContEq H H7); subst x7.
  assert (EE : set_subset
    frObjs
    (set_union (set_union W M)
      (set_union (rangeObjs toStart toStart)
        (set_union G (rangeObjs toEnd toEnd))))).
  setoid_rewrite <- (set_eqvEmptyRangeObjs toStart).
  setoid_rewrite <- (set_eqvEmptyRangeObjs toEnd).
  rewrite (set_eqvUnionSymm G empty_set); simpl.
  rewrite frObjsEq.
  setoid_rewrite frEq; rewrite (set_eqvUnionSymm M W).
  intros q Iq; sui1; assumption.
  unfold okObjAt; unfold okFieldAt; lli.
  2:eauto.
  destruct H5; [left | right].
  assumption.
  eauto.
  destruct H8; [left | right].
  assumption.
  eauto.

  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite <- F'eq; assumption.
  apply unitER; lli; sconjStepX.

  (* show the virtual heap is okay *)
  stSimpl.
  clear Hp Wcopy Req stOk Seq.

  assert (Vhp' : h' ||- (foralls x in G |_| W, x |->__)).
  apply fasMerge.
  scm.
  apply (fasImpl Hp).
  simpl; unfold objCopiedPhi.
  unfold objCopied; unfold fieldCopied; intros zz hh X; llei X; scm.
  unfold objHp in Hp; apply (fasImpl Hp).
  unfold okObjAt; unfold okFieldAt; simpl; intros zz hh X; llei X; scm.
  (* set_disj G W *)
  apply set_disj_intro; intros z IG IW.
  apply (set_disj_elim Disj z).
  apply objRangeSetRangeSubset.
  rewrite frEq; sui2; assumption.
  apply objRangeSetRangeSubset.
  assert (IG' : set_In z (rangeObjs toStart (rget s' rfree))).
  rewrite Geqv; assumption.
  destruct (rangeObjsElim IG') as [lt [k ZZ]]; eapply rangeObjsIntro.
  2:eauto.
  omega.

  assert (Vhp'' := heap_eqvCopy Hp'' _ Vhp').
  clear Vhp Vhp' Hp' Hp''; rename Vhp'' into Vhp.

  assert (HH : 
    Heap.HeapMap.map_mapRange (fun x2 => match mapX phi x2 with Some y => y | _ => x2 end) h'
   ||- unit ** foralls x2 in rangeObjs toStart (rget s' rfree) |_| W,
        objRespMapH (map_union phi (fun x3 : POnat.POnat.A => Some x3)) (heapOf s') x2).
  lli.
  unfold hpredTrue; rewrite Geqv; rewrite <- hpredTrueEq.

  apply (fasMapRangeImpl Vhp).
  unfold objCopiedH, fieldCopiedH.
  simpl; intros h x2 Hp; lle Hp.
  unfold objRespMapH, fieldRespMapH.

  apply (sconjMapRangeImpl Hp).

  intros h1 Hp1; lli.
  2:apply (contMapRangeImpl Hp1).
  exists x3; constructor.
  assumption.
  unfold map_union; unfold mapX.
  destruct (isOdd x3); try reflexivity; destruct (phi x3); reflexivity.
  intros h1 Hp1; lli.
  2:apply (contMapRangeImpl Hp1).
  exists x4; constructor.
  assumption.
  unfold map_union; unfold mapX.
  destruct (isOdd x4); try reflexivity; destruct (phi x4); reflexivity.

  scm.
  unfold hpredTrue; setoid_replace (rangeObjs toStart toStart |_| rangeObjs toEnd toEnd) with
    empty_set.
  apply fasIntroE; assumption.
  rewrite <- (set_eqvEmptyRangeObjs toStart).
  rewrite <- (set_eqvEmptyRangeObjs toEnd).
  simpl; apply set_eqvRefl.


  (* show the guarantee holds *)
  intros s'' Guar.
  rename vh into vs0.
  constructor.
  intros vs A Hp1.

  (* cleanup *)
  clear vs0 rootEq Eeqv.
  destruct stOk as [frToDisj [frSub [toEqv [toStEndLt Hp0]]]].
  destruct Hp1 as [frStart' [frEnd' [toStart' [toEnd' [scan' [free' [alloc' Hp1]]]]]]].
  rename phi into phi0; rename W into W0; rename M into M0.
  destruct Hp1 as [rootEq [phi [W [M X]]]].
  destruct X as [AlS [_ [WMeqv [Iso [rootOk' [Hp00 VHp]]]]]].

  sconjLift6of6 Hp00; linLogElim Hp00.
  replace (4 + (4 + rget s rgcInfo)) with (8 + rget s rgcInfo) in Hp00; [idtac | omega].
  replace (4 + (8 + rget s rgcInfo)) with (12 + rget s rgcInfo) in Hp00; [idtac | omega].
  replace (4 + (12 + rget s rgcInfo)) with (16 + rget s rgcInfo) in Hp00; [idtac | omega].
  replace (4 + (16 + rget s rgcInfo)) with (20 + rget s rgcInfo) in Hp00; [idtac | omega].
  replace (4 + (20 + rget s rgcInfo)) with (24 + rget s rgcInfo) in Hp00; [idtac | omega].

  assert (X1 := contContEq Hp0X Hp00).
  assert (Q := Hp00).
  sconjLift2 Q; sconjLift2 Hp0X; assert (X2 := contContEq Q Hp0X).
  sconjLift3 Q; sconjLift3 Hp0X; assert (X3 := contContEq Q Hp0X).
  sconjLift4 Q; sconjLift4 Hp0X; assert (X4 := contContEq Q Hp0X).
  sconjLift5 Q; sconjLift5 Hp0X; assert (X5 := contContEq Q Hp0X).
  sconjLift6 Q; sconjLift6 Hp0X; assert (X6 := contContEq Q Hp0X).
  sconjLift7 Q; sconjLift7 Hp0X; assert (X7 := contContEq Q Hp0X).

  subst frStart' frEnd' toStart' toEnd' scan' free' alloc'.
  clear Q Hp0X phi0 iso Nsp Hp H9 Hp'.
  clear M0 W0 frEq Wcopy Sub.
  clear G toEq Wx Mx.

  assert (Vhp : vs |||- (foralls x in rangeObjs frStart frEnd, objCopiedH x (heapOf s) x) ** top).
  sconjMatch.
  simpl in AlS; destruct AlS as [Al1 [_ [_ Al2]]].
  assert (LE : free <= frEnd).
  destruct Al2; omega.
  unfold hpredTrue; rewrite <- (rangeObjsTransEqv Al1 LE).
  assumption.

  clear VHp.

  assert (HpOrig : s |||- top ** top ** top ** top ** top ** top ** top ** top ** top ** top ** 
    objHp (rangeObjs frStart frEnd) (rangeObjs frStart frEnd) ** top ** top).
  sconjMatch.
  simpl in AlS; destruct AlS as [Al1 [_ [_ Al2]]].
  assert (LE : free <= frEnd).
  destruct Al2; omega.
  unfold hpredTrue; rewrite <- (rangeObjsTransEqv Al1 LE).
  apply (objHpWeaken Hp).
  rewrite <- (set_eqvEmptyRangeObjs free); simpl; apply set_subsetRefl.

  lle HpOrig.
  hyr Hp00 (contUpdateSt Hp00 frStart).
  sconjLift2 Hp00; hyr Hp00 (contUpdateSt Hp00 frEnd).
  sconjLift3 Hp00; hyr Hp00 (contUpdateSt Hp00 toStart).
  sconjLift4 Hp00; hyr Hp00 (contUpdateSt Hp00 toEnd).
  sconjLift5 Hp00; hyr Hp00 (contUpdateSt Hp00 (rget s rroot)).
  rename Hp00 into Hp.

  apply sconjAssocR in Hp; apply sconjAssocR in Hp; apply sconjAssocR in Hp.
  apply sconjAssocR in Hp; apply sconjAssocR in Hp; apply sconjAssocR in Hp.
  sconjLift3 Hp; sconjLift4 Hp; apply sconjAssocR in Hp.

  assert (Hp1 : h0 ||- 
    (foralls x in rangeObjs toStart toEnd, x |->__) **
    rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::rget s rroot::free::free::nil) ** 
      A ** 
      objHp (rangeObjs frStart frEnd) (rangeObjs frStart frEnd) ** unit ** unit).
  subst h0.
  clear Req Guar0 Hp0 Hp0Ok.
  scm.
  assert (Hp2 : h ||- (foralls x in W, x |->__) ** (foralls x in M, x |->__)).
  scm; [eapply objHpIsObjs | eapply mapHpIsObjs]; eauto.
  unfold hpredTrue; rewrite <- WMeqv; apply fasMerge; scm.
  eapply fasFasDisj.
  instantiate (1 := unit); instantiate (4 := h).
  lli; apply Hp2.
  cbv beta; intros hh zz HH; lle HH; lli; sconjMatch.
  cbv beta; intros hh zz HH; lle HH; lli; sconjMatch.
  apply unitER; lli; lle Hp.
  sconjLift2 Hp; sconjLift3 Hp; sconjLift4 Hp; sconjLift5 Hp; scm.
  lli; assumption.

  simpl in AlS; destruct AlS as [Al1 [_ [_ Al2]]].
  assert (LE : free <= frEnd).
  destruct Al2; omega.
  unfold hpredTrue; rewrite <- (rangeObjsTransEqv Al1 LE).
  apply (objHpWeaken Hp).
  setoid_rewrite <- (set_eqvEmptyRangeObjs free); simpl; intros y I; assumption.
  unfold hpredTrue in Hp; rewrite <- (set_eqvEmptyRangeObjs free) in Hp.
  apply (objHpElimE Hp).
  unfold hpredTrue in Hp; rewrite <- (set_eqvEmptyRangeObjs free) in Hp.
  apply (fasElimE Hp).

  (* step forward through the loop *)
  clear W M phi WMeqv Hp Iso.
  rename Hp1 into Hp.
  destruct (Guar0 (fun x : nat => None) (rangeObjs frStart frEnd) empty_set 
    (rangeObjs toStart toEnd) 
    (rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::nil) **
      20 + rget s rgcInfo |->, (free :: free :: nil) ** A))
  as [M' [W' [F' [G [phi' X]]]]]; clear Guar0.

  (* show the loop guar can be used *)
  constructor.
  assumption.
  constructor.
  rewrite (set_eqvUnionSymm (rangeObjs frStart frEnd) empty_set); simpl.
  apply objRangeSetRangeSubset.
  constructor.
  apply set_eqvRefl.
  constructor.
  discriminate 2.
  constructor.
  intuition.
  constructor.
  auto.
  constructor.
  assumption.

  cut (h0 ||- mapHp empty_set (fun _ : nat => None) **
        objHp (rangeObjs frStart frEnd |_| empty_set)
          (rangeObjs frStart frEnd) **
        (foralls x2 in rangeObjs toStart toEnd, x2 |->__) **
        okFieldAt
          ((rangeObjs frStart frEnd |_| empty_set) |_| setRange toStart toEnd)
          (16 + rget s rgcInfo) **
        rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) **
        20 + rget s rgcInfo |->, (free :: free :: nil) ** A).
  intros Hp00; subst h0; apply Hp00.
  sconjLift5 Hp; apply (sconjImpl Hp); clear Hp; intros h Hp.
  eapply mapHpIntroE; eauto.
  sconjLift4 Hp; apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite (set_eqvUnionSymm (rangeObjs frStart frEnd) empty_set).
  simpl; assumption.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  lle Hp.
  sconjLift5 Hp; apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold okFieldAt; lli; [idtac | eauto].
  destruct rootOk' as [rootOk' | rootOk']; [left | right].
  assumption.
  sui1; sui1.
  simpl in AlS; destruct AlS as [Al1 [_ [_ Al2]]].
  assert (LE : free <= frEnd).
  destruct Al2; omega.
  unfold hpredTrue; rewrite <- (rangeObjsTransEqv Al1 LE).
  destruct (set_union_elim rootOk') as [I | I];
    [sui1 | sui2].
  assumption.
  destruct (set_union_elim I) as [I' | I'].
  assert (X : set_In (rget s rroot) empty_set).
  rewrite (set_eqvEmptyRangeObjs free); assumption.
  elf; exact X.
  assumption.
  lli; scm.

  (* clean up results of loop *)
  rename F'eq into Feq.
  destruct X as 
    [frEq [toEq [Iso' [_ [Wcopy' [Disj' [Sub' [F'eq [NSP' [LT' [LE' [Al' Hp']]]]]]]]]]]].
  generalize dependent Hp'; unfold fieldRespToMap; unfold fieldRespMap; stSimpl.
  intro; lle Hp'.
  destruct (Guar x2) as [[vs' Bok''] [Guar'' [Req'' [RaEq'' [allocEq'' v0Eq'']]]]]; clear Guar.
  sconjLift4 Hp'; scm.
  clear vs' Bok''.

  (* okay, now ACTUALLY use loop.  before was just root scanning or something *)
  unfold map_union in Hp'.
  destruct (Guar'' phi' G W' M' F'
    (rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::nil) ** A)) as 
    [phi'' [B [B' [G' [G'' [W'' [M'' [F'' X]]]]]]]]; clear Guar''.
  stSimpl.

  (* set_eqv G (rangeObjs (rget s' rscan) (rget s' rfree)) *)
  eapply rangeSplit.
  3:instantiate (1 := rget s' ralloc).
  rewrite <- F'eq.
  sconjLift3 Hp'; sconjLift5 Hp'; apply (fasFasDisj Hp').
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros zz hh X; lle X; lli; scm.
  intros h x3 HH; lle HH; lli; scm.
  destruct Al'; omega.
  rewrite <- F'eq.
  rewrite <- Req; [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  apply set_eqvSymm; assumption.
  rewrite <- Req; [stSimpl | regNotInListSolver].
  assumption.

  (* bakerLoopStOk *)
  unfold bakerLoopStOk; unfold scanFieldStOk; stSimpl.
  unfold toSpace; unfold fromSpace.
  rewrite <- Req; [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  constructor.
  auto.
  constructor.
  assumption.
  rewrite <- Req; [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  constructor.
  assumption.
  constructor.
  intros z I.
  apply objRangeSetRangeSubset; rewrite frEq; 
    rewrite (set_eqvUnionSymm M' W'); assumption.
  constructor.
  assumption.
  unfold map_union in NSP'.
  rewrite <- Req in NSP'; [stSimpl | regNotInListSolver].
  rewrite <- Req in NSP'; [stSimpl | regNotInListSolver].
  constructor.
  assumption.
  rewrite <- (Req rtoEnd) in LE'; [idtac | regNotInListSolver];
    generalize dependent LE'; stSimpl; intro.
  constructor.
  destruct Al'; omega.
  constructor.
  assumption.
  constructor.
  assumption.
  rewrite <- Req; [stSimpl | regNotInListSolver].
  apply (sconjImplR Hp'); clear Hp' Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift2 Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold objHp; apply (fasImplI Hp); clear h Hp.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied; stSimpl.
  intros y h Iy HH; lle HH.
  assert (HH0 : h0 ||- x3 |-> x4 ** top).
  subst h0; assumption.
  assert (HH1 : h0 ||- 4 + x3 |-> x5 ** top).
  subst h0; assumption.
  clear H6 H7.
  assert (HH00 : h0 ||- (okObjAt frObjs x3 ** top) ** top).
  sconjLift2 Hp0; clear HH0 HH1 Hp0Ok; scm.
  assert (II : set_In x3 frObjs).
  destruct Iso' as [Iso' _]; destruct (Iso' x3) as [II1 II2].
  rewrite frObjsEq; rewrite frEq; sui1.
  apply II2; rewrite H1; discriminate.
  hyr Hp (objHpElim II Hp); sconjMatch.
  replace frObjs with (empty_set |_| frObjs); [idtac | reflexivity].
  unfold hpredTrue; rewrite (set_eqvUnionSymm empty_set frObjs); assumption.

  unfold okObjAt in HH00; unfold okFieldAt in HH00; lle HH00.
  assert (U := contContEq HH0 HH00).
  sconjLift2 HH00; assert (V := contContEq HH1 HH00); clear HH00.
  subst x6 x7.
  unfold okObjAt; unfold okFieldAt; lli.
  2:eauto.
  destruct H4 as [I | I]; [left | right].
  assumption.
  sui1; rewrite (set_eqvUnionSymm W' M');
    rewrite <- frEq; subst frObjs; assumption.
  destruct H7 as [I | I]; [left | right].
  assumption.
  sui1; rewrite (set_eqvUnionSymm W' M');
    rewrite <- frEq; subst frObjs; assumption.
  unfold gcHpPtrMem, gcHpPtrMem'; lli.
  instantiate (1 := free).
  instantiate (1 := free).
  instantiate (1 := x2).
  sconjStepX.

  (* finally have the final state.  do some clean up on this. *)
  generalize dependent X.
  unfold bakerLoopStOk, scanFieldStOk; stSimpl; unfold fromSpace, toSpace.
  rewrite <- (Req'' rtoStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req'' rtoEnd); [stSimpl | regNotInListSolver].
  rewrite <- (Req'' rfrStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req'' rfrEnd); [stSimpl | regNotInListSolver].
  generalize dependent RaEq''; generalize dependent allocEq''; stSimpl;
    intro; intro.
  rewrite v0Eq''.
  rewrite <- (Req rtoStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req rtoEnd); [stSimpl | regNotInListSolver].
  rewrite <- (Req rfrStart); [stSimpl | regNotInListSolver].
  rewrite <- (Req rfrEnd); [stSimpl | regNotInListSolver].
  intro.
  destruct X as [W'eq [F'eq' [Iso'' [Geq [BBeq [alFr'' [Wcopy'' X]]]]]]].
  destruct X as [LEscan'' [AlScFr'' [_ [Sub'' [F''eq [Nsp'' [LE'' [_ [Al'' Hp'']]]]]]]]].

  (* first, we want to express our predicates on the final state in terms of the
  initial state, so we can discard the intermediate state. *)
  assert (Hp''2 : s'' |||- mapHp (M' |_| M'') (map_union phi' phi'') **
    objHp (W'' |_| M' |_| M'') W'' ** (foralls x in F'', x |->__) **
    (foralls x in B, objIsToFwded (fun x => None) (map_union phi' phi'') (h0, rfileOf s') x) **
    (foralls x in G', objCopiedPhi phi' (h0, rfileOf s') x) **
    (foralls x in B', objIsToFwded phi' phi'' (h0, rfileOf s') x) **
    (foralls x in G'', objCopiedPhi phi'' (h0, rfileOf s') x) **
    rget s'' ralloc |->, (1::1::nil) **
    gcHpPtrMem' (rget s rgcInfo) (rget s'' rscan) (rget s'' rfree) (rget s'' ralloc) **
    rget s rgcInfo |->, (frStart::frEnd::toStart::toEnd::nil) ** A).
  clear Hp; scm.

  apply (fasImplI Hp); clear h Hp; intros y h I Hp.
  assert (I' : set_In y G).
  rewrite Geq; sui1; assumption.
  sconjLift5 Hp'; hyr Hp' (fasElimL I' Hp').
  cbv beta in Hp'; lle Hp'.
  
  unfold objIsToFwded; eapply copyMapFwded.
  instantiate (1 := top).
  instantiate (1 := s').
  clear HpX; scm.
  generalize dependent Hp1; unfold objCopiedPhi, objCopied, fieldCopied; stSimpl.
  intro HH; lle HH; lli; [idtac | subst h0; apply H6 | apply HH | subst h0; apply H7].
  unfold map_union; rewrite H1; reflexivity.
  clear Hp'; generalize dependent Hp; 
    unfold objRespToMap, objRespMap, fieldRespToMap, fieldRespMap, map_unionnn, map_union;
    unfold spaceIdMap; stSimpl.
  unfold mapX.
  intro Hp; lle Hp.
  destruct H3 as [v0 [HH0 Meq0]]; destruct H4 as [v1 [HH1 Meq1]].
  lli; [exists v0 | apply Hp | exists v1].
  constructor; [assumption | idtac].
  2:constructor; [assumption | idtac].
  replace (rget (h0, rfileOf s')) with (rget s') by reflexivity.
  2:replace (rget (h0, rfileOf s')) with (rget s') by reflexivity.
  destruct (isOdd v0); [assumption | 
    destruct (blt_nat v0 (rget s' rtoEnd)); 
      [destruct (blt_nat (rget s' rtoStart) (S v0)) | idtac]; assumption].
  destruct (isOdd v1); [assumption | 
    destruct (blt_nat v1 (rget s' rtoEnd)); 
      [destruct (blt_nat (rget s' rtoStart) (S v1)) | idtac]; assumption].

  (* dealing with G' *)
  apply (fasImplI Hp); clear h Hp; intros y h I Hp.
  assert (I' : set_In y G).
  rewrite Geq; sui2; assumption.
  sconjLift5 Hp'; hyr Hp' (fasElimL I' Hp').
  cbv beta in Hp'; lle Hp'.
  eapply objCopiedPhiCopied'.
  eauto.
  stSimpl.
  clear HpX; scm.
  generalize dependent Hp1; unfold objCopiedPhi, objCopied, fieldCopied; stSimpl.
  intro HH; lle HH; lli; [idtac | subst h0; apply H6 | apply HH | subst h0; apply H7].
  unfold map_union; rewrite H1; reflexivity.
  apply (fasImplI Hp); clear h Hp; intros y h I Hp.
  eapply (objCopiedFwded Hp); [eauto | idtac | reflexivity | reflexivity].
  intros z Iz.
  assert (Iz' : set_In z W').
  rewrite W'eq; sui1; assumption.
  subst h0; stSimpl; apply (Wcopy' _ Iz').

  (* dealing with G'' *)
  apply (fasImplI Hp); clear h Hp; intros y h I Hp.
  eapply objCopiedPhiCopied; eauto.
  intros z Iz.
  assert (Iz' : set_In z W').
  rewrite W'eq; sui1; assumption.
  subst h0; stSimpl; apply (Wcopy' _ Iz').

  (* dealing with gcHpPtrMem' *)
  generalize dependent Hp; unfold gcHpPtrMem';
    rewrite <- Req; [stSimpl; intro U; exact U | regNotInListSolver].

  assert (MMdisj' : set_disj M' M'').
  apply set_disjSymm.
  apply set_unionDisjElimL with W''.
  rewrite <- W'eq; apply set_disjSymm.
  simpl in Hp'; unfold mapHp in Hp'; unfold objHp in Hp'.
  lle Hp'; apply (fasFasDisj Hp').
  intros hh a HH; llei HH; scm.
  unfold okObjAt, okFieldAt; intros hh a HH; llei HH; scm.

  (* clean up a little more *)
  assert (Hp''3 : s''
    |||- mapHp (M' |_| M'') (map_union phi' phi'') **
      objHp (W'' |_| M' |_| M'') W'' **
      (foralls x in F'', x |->__) **
      (foralls x in B |_| B', 
	objIsToFwded (fun _ => None) (map_union phi' phi'') (h0, rfileOf s') x) **
      (foralls x in G' |_| G'', objCopiedPhi (map_union phi' phi'') (h0, rfileOf s') x) **
      rget s'' ralloc |->, (1 :: 1 :: nil) **
      gcHpPtrMem' (rget s rgcInfo) (rget s'' rscan) (rget s'' rfree) (rget s'' ralloc) **
      rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) ** A).
  apply (sconjImplR Hp''2); clear Hp Hp''2; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  sconjLift3 Hp; apply sconjAssocR in Hp.
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  sconjLift2of2 Hp; apply fasMerge; scm.
  apply (fasImplI Hp); clear h Hp; intros y h Iy Hp.
  eapply objIsToFwdedShift.
  unfold map_union; assumption.
  eauto.
  eauto.
  assumption.

  (* set_disj B B' *)
  unfold objIsToFwded in Hp; unfold objIsFwded in Hp; 
    unfold fieldIsFwded in Hp.
  eapply fasFasDisj.
  instantiate (1 := unit); instantiate (4 := h).
  lli; apply Hp.
  cbv beta; intros hh a HH; llei HH; scm.
  cbv beta; intros hh a HH; llei HH; scm.

  hyr Hp (sconjAssocR Hp).
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  eapply fasMerge.
  scm; apply (fasImplI Hp); clear h Hp; intros a h I Hp.
  apply (objCopiedPhiSubmap Hp).
  unfold map_union; intros b c E; rewrite E; reflexivity.
  eapply objCopiedPhiUnionPhi; eauto.
  (* set_disj G' G'' *)
  sconjLift7 Hp''; sconjLift6 Hp''; apply (fasFasDisj Hp'').
  unfold objCopied; unfold fieldCopied.
  intros hh y HH; lle HH; lli; sconjMatch.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y HH; lle HH; lli; sconjMatch.

  assumption.

  (* Finished cleaning up the heap.  Now cleanup the other hyps. *)

  assert (GF'disj : set_disj G F').
  sconjLift3 Hp'; sconjLift5 Hp'; apply (fasFasDisj Hp').
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y HH; llei HH; sconjMatch.
  intros hh y HH; llei HH; sconjMatch.

  clear HpX Hp' Hp'' Hp''2; rename Hp''3 into Hp'.

  assert (Wcopy : forall a, set_In a W'' -> s'' |||- objCopiedH a h0 a ** top).
  intros a Ia.
  assert (Wcopy1 : s' |||- objCopiedH a h0 a ** top).
  assert (Ia' : set_In a W').
  rewrite W'eq; sui2; assumption.
  clear Hp Hp'; hyr Wcopy' (Wcopy' _ Ia'); scm.
  unfold objCopied, fieldCopied, objCopiedH, fieldCopiedH in Hp; lle Hp.
idtac.
unfold objCopiedH, fieldCopiedH; lli; [subst h0; apply H3 | eauto | subst h0; apply H4].
  assert (Wcopy2 : s'' |||- objCopied a s' a ** top).
  clear Hp Hp'; hyr Wcopy'' (Wcopy'' _ Ia); scm.
  unfold objCopiedH, fieldCopiedH in Wcopy1 |- *; unfold objCopied, fieldCopied in Wcopy2.
  lle Wcopy1; llei Wcopy2; eauto.
  assert (X := contContEq Wcopy1 H4); 
    sconjLift2 Wcopy1; assert (X' := contContEq Wcopy1 H8); subst x5 x6; assumption.
  
  clear Wcopy' Wcopy''.

  assert (rootOk'' : exists v0, h0 ||- 16 + rget s rgcInfo |-> v0 ** top /\
    mapX (map_union (spaceIdMap toStart toEnd) phi') v0 = Some x2).
  destruct H9 as [v0 [HH Meq]]; exists v0; constructor.
  subst h0; assumption.
  assumption.

  clear H9; destruct rootOk'' as [root'' [rootHp'' MeqRoot'']].
  assert (X := contContEq rootHp'' Hp0Ok); clear rootHp''; subst root''.
  subst toObjs frObjs.
  clear Disj Disj' toStEndLt Le1 Le3 x0 x1 AlS rootOk' Sub' NSP' Nsp''.
  assert (RaEq : rget s'' ra = rget s ra).
  rewrite RaEq''; stSimpl; rewrite <- Req; [stSimpl | regNotInListSolver]; reflexivity.
  clear RaEq'' x.
  rename x2 into x.
  clear LT' Le2 toEqv frSub.

  (* finally, extract the new virtual heap *)
  sconjLift5 Hp'; sconjLift5 Hp'; apply sconjAssocR in Hp'.
  sconjLift3 Hp'; apply sconjAssocR in Hp'.
  destruct (sconjExtract Hp') as [vh'0 [Hp'A Vhp']].
  clear Hp'; rename Hp'A into Hp'.

  set (vs' := (Heap.HeapMap.map_mapRange 
    (fun x => match mapX (map_union phi' phi'') x with 
		| Some y => y
		| None => x
	      end) vh'0, 
    rfileOf s'')).
  exists vs'.
  (* oops I misnamed things before *)
  rename W' into W; rename W'' into W'; rename M' into M; rename M'' into M';
    rename phi' into phi; rename phi'' into phi';
      rename Iso' into Iso; rename Iso'' into Iso'.

  assert (Iso0 : iso_set (map_union phi phi') (M |_| M') (G |_| (B' |_| G''))).
  apply iso_union.
  assumption.
  assumption.
  assumption.
  apply set_disjSymm.
  apply set_unionDisjElimL with (set_add (rget s'' ralloc) F'').
  rewrite <- F'eq'; apply set_disjSymm; assumption.

  constructor.
  
  (* first we show the virtual guarantee holds *)
  intros objs h Vhp0.
  assert (Sub : set_subset objs ((M |_| M') |_| W')).
  rewrite (set_eqvUnionAssoc M M' W').
  rewrite <- W'eq; rewrite <- frEq.
  eapply minObjHpSub.
  instantiate (1 := top); instantiate (2 := heapOf vs).
  eapply objHpCopied.
  apply Vhp.
  apply HpOrig.
  destruct (aconjElim (sconjDistrib2 Vhp0)) as [X _]; apply X.
  simpl; intros v [I | I].
  subst v.
  rewrite rootEq; assumption.
  elf; assumption.

  set (objs' := set_map 
    (fun x => match map_union phi phi' x with
		| Some y => y
		| None => x
	      end) objs).
  exists objs'.
  set (phi2 := fun x => if set_mem x objs then
          (if set_mem x W' then Some x else (map_union phi phi') x) else None).
  exists phi2.

  assert (Sub' : set_subset objs' ((G |_| B' |_| G'') |_| W')).
  subst objs'; intros a Ia.
  destruct (set_map_elim Ia) as [b [Aeq Ib]]; clear Ia; subst a.
  destruct Iso0 as [I [I' _]]; hyr I' (I' b); destruct (I b) as [II _].
  destruct (map_union phi phi' b).
  sui1; apply I'; reflexivity.
  hyr Sub (Sub _ Ib); destruct (set_union_elim Sub).
  elimtype False; apply II; auto.
  sui2; assumption.

  assert (D : set_disj (M |_| M') W').
  unfold mapHp in Hp'; unfold objHp in Vhp';
    hyr Hp' (sconjInsert Hp' Vhp'); lle Hp'; sconjLift4 Hp'; apply (fasFasDisj Hp').
  intros hh y HpZ; lle HpZ; lli; sconjMatch.
  unfold okObjAt; unfold okFieldAt.
  intros hh y HpZ; lle HpZ; lli; sconjMatch.

  assert (D' : set_disj W' (G |_| B' |_| G'')).
  assert (HH : vh'0 ||- (foralls x in W', x |->__) ** 
    (foralls x in G |_| B' |_| G'', x |->__) ** unit).
  lli; scm.
  apply (objHpIsObjs Hp1).
  unfold hpredTrue; rewrite Geq.
  rewrite (set_eqvUnionAssoc B G' (B' |_| G'')).
  rewrite <- (set_eqvUnionAssoc G' B' G'').
  rewrite (set_eqvUnionSymm G' B').
  rewrite <- (set_eqvUnionAssoc B (B' |_| G') G'').
  rewrite <- (set_eqvUnionAssoc B B' G').
  rewrite (set_eqvUnionAssoc (B |_| B') G' G'').
  apply fasMerge.
  sconjMatch; apply (fasImplI Hp1).
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded.
  intros z hh _ HH; llei HH; scm.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y _ HH; llei HH; scm.
  eapply fasFasDisj.
  instantiate (4 := h1); instantiate (1 := unit).
  lli; sconjMatch.
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded.
  intros z hh HH; lle HH; lli; sconjMatch.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y HH; lle HH; lli; sconjMatch.
  eapply fasFasDisj.
  apply HH.
  cbv beta; intros hh z HH2; sconjMatch.
  cbv beta; intros hh z HH2; sconjMatch.

  assert (D'' : set_disj (M |_| M') (G |_| B' |_| G'')).
  assert (HH : s'' |||- ((foralls x in G |_| B' |_| G'', x |->__) ** top) **
    (foralls x in M |_| M', x |->__) ** top).
  hyr Hp' (sconjInsert Hp' Vhp').
  eapply sconjImpl.
  apply Hp'.
  clear Hp'; intros hh HH.
  sconjLift3of3 HH; sconjLift3of3 HH; hyr HH (sconjAssocR HH); sconjMatch.
  unfold hpredTrue; rewrite Geq.
  rewrite (set_eqvUnionAssoc B G' (B' |_| G'')).
  rewrite <- (set_eqvUnionAssoc G' B' G'').
  rewrite (set_eqvUnionSymm G' B').
  rewrite <- (set_eqvUnionAssoc B (B' |_| G') G'').
  rewrite <- (set_eqvUnionAssoc B B' G').
  rewrite (set_eqvUnionAssoc (B |_| B') G' G'').
  apply fasMerge.
  sconjMatch; apply (fasImplI Hp1).
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded.
  intros z hh _ HH; lle HH; lli; sconjMatch.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y _ HH; lle HH; lli; sconjMatch.
  eapply fasFasDisj.
  instantiate (4 := h1); instantiate (1 := unit).
  lli; sconjMatch.
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded.
  intros z hh HH; lle HH; lli; sconjMatch.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros hh y HH; lle HH; lli; sconjMatch.
  intros hh HH; sconjMatch.
  exact (mapHpIsObjs Hp1).
  lle HH; sconjLift2 HH; eapply fasFasDisj.
  apply HH.
  cbv beta; intros hh z HH2; sconjMatch.
  cbv beta; intros hh z HH2; sconjMatch.

  constructor.

  (* show the isomorphism holds *)
  clear Seq Hp0 Hp HpOrig.
  subst phi2 objs'.
  constructor.

  intros z; constructor; intro Iz.
  rewrite (set_mem_true Iz).
  assert (X := set_memSound z W'); destruct (set_mem z W').
  discriminate.
  hyr Sub (Sub _ Iz); destruct (set_union_elim Sub) as [Iz' | Iz'].
  destruct Iso0 as [Iso0 _]; destruct (Iso0 z) as [Y _]; apply Y; assumption.
  elimtype False; exact (X Iz').

  assert (Q := set_memSound z objs).
  destruct (set_mem z objs).
  assumption.
  elf; apply Iz; reflexivity.

  constructor.
  intros a b Peq.
  assert (Q := set_memSound a objs).
  destruct (set_mem a objs).
  eapply set_map_intro.
  2:apply Q.
  assert (IW := set_memSound a W').
  destruct (set_mem a W').
  injection Peq; clear Peq; intro; subst b.
  replace (map_union phi phi' a) with (None (A := nat)).
  reflexivity.
  symmetry.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 a) as [_ Z].
  destruct (map_union phi phi' a).
  2:reflexivity.
  elimtype False; apply (set_disj_elim D a).
  apply Z; discriminate.
  assumption.
  rewrite Peq; reflexivity.
  discriminate Peq.

  constructor.
  intros a a' b Peq Peq'.
  assert (Q := set_memSound a objs).
  destruct (set_mem a objs).
  2:discriminate Peq.
  assert (Q' := set_memSound a' objs).
  destruct (set_mem a' objs).
  2:discriminate Peq'.
  assert (Q1 := set_memSound a W'); assert (Q2 := set_memSound a' W').
  destruct (set_mem a W'); destruct (set_mem a' W').
  injection Peq; injection Peq'; intros; subst a a'; reflexivity.
  injection Peq; clear Peq; intro; subst b.
  assert (I'1 := Sub _ Q'); destruct (set_union_elim I'1) as [I' | I']; clear I'1.
  2:elimtype False; exact (Q2 I').
  elimtype False; apply (set_disj_elim D' a).
  assumption.
  destruct Iso0 as [_ [Iso0 _]]; eapply Iso0; eauto.
  injection Peq'; clear Peq'; intro; subst b.
  assert (I'1 := Sub _ Q); destruct (set_union_elim I'1) as [I | I]; clear I'1.
  2:elimtype False; exact (Q1 I).
  elimtype False; apply (set_disj_elim D' a').
  assumption.
  destruct Iso0 as [_ [Iso0 _]]; eapply Iso0; eauto.
  destruct Iso0 as [_ [_ [Iso0 _]]]; eapply Iso0; eauto.

  intros b Ib; destruct (set_map_elim Ib) as [a [Beq Ia]]; clear Ib.
  subst b; exists a.
  rewrite (set_mem_true Ia).
  hyr Ia (Sub _ Ia); destruct (set_union_elim Ia) as [Ia' | Ia']; clear Ia.
  rewrite set_mem_false.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 a) as [X _].
  destruct (map_union phi phi' a).
  reflexivity.
  elimtype False; apply X; auto.
  intro IW'; apply (set_disj_elim D a); assumption.
  rewrite (set_mem_true Ia').
  destruct Iso0 as [Iso0 _]; destruct (Iso0 a) as [_ X].
  destruct (map_union phi phi' a).
  elimtype False;  apply (set_disj_elim D a); auto.
  apply X; discriminate.
  reflexivity.
  (* done showing the isomorphism *)

  constructor.
  rewrite rootEq; replace (rget vs' rroot) with (rget s'' rroot).
  rewrite <- Req''; [stSimpl | regNotInListSolver].
  subst phi2; unfold mapX in MeqRoot'' |- * .
  assert (IO := isOddOk (rget s rroot)); destruct (isOdd (rget s rroot)).
  assumption.
  assert (I : set_In (rget s rroot) objs).
  destruct (aconjElim (sconjDistrib2 Vhp0)) as [X _].
  destruct (sconjElim X) as [ha [hb [J [HA _]]]].
  destruct (minObjHpRootOk HA (rget s rroot)).
  rewrite rootEq; left; reflexivity.
  elf; apply (not_even_and_odd (rget s rroot)); assumption.
  assumption.
  rewrite (set_mem_true I).
  unfold map_union in MeqRoot'' |- * .
  assert (X := set_memSpaceIdMap toStart toEnd (rget s rroot)).
  hyr I (Sub _ I); destruct (set_union_elim I) as [I' | I']; clear I.

  rewrite set_mem_false.
  assert (NI : ~set_In (rget s rroot) (setRange toStart toEnd)).
  intro I; apply (set_disj_elim frToDisj (rget s rroot)).
  apply Sub''; sui2; assumption.
  assumption.
  rewrite (set_mem_false NI) in X.
  rewrite X in MeqRoot''.
  rewrite MeqRoot''; reflexivity.
  intro I; apply (set_disj_elim D (rget s rroot)); assumption.

  elf.
  rewrite set_mem_false in X.
  rewrite X in MeqRoot''.
  apply (set_disj_elim D (rget s rroot)).
  destruct Iso0 as [Iso0 _]; destruct (Iso0 (rget s rroot)) as [_ Y]; apply Y.
  unfold map_union; rewrite MeqRoot''; discriminate.
  assumption.
  intro I; apply (set_disj_elim frToDisj (rget s rroot)).
  apply Sub''; sui1; assumption.
  assumption.
  
  subst vs'; reflexivity.
  (* done showing the root is okay *)

  (* show that all of the objects in objs' are fwded appropriately *)
  assert (Vhp'' : vh'0 ||- (foralls x in W', objCopiedH x (heapOf s) x) **
    (foralls x in B |_| B', objIsToFwded (fun _ : nat => None) (map_union phi phi')
      (heapOf s, rfileOf s') x) **
    (foralls x in G' |_| G'', objCopiedPhi (map_union phi phi') (heapOf s, rfileOf s') x)).

  assert (objCopy : forall a, 
    set_In a (rangeObjs frStart frEnd) \/ set_In a (rangeObjs toStart toEnd) ->
    h0 ||- objCopiedH a (heapOf s) a ** top).
  intros a Ia.

  assert (Hp00 : h0 ||- top ** (a |->__ ** top) ** top ** 16 + rget s rgcInfo |->_ **
    rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) ** top).
  clear Hp.
  destruct Ia as [Ia' | Ia'].
  scm.
  hyr Hp (objHpElim Ia' Hp); unfold okObjAt, okFieldAt in Hp; llei Hp.
  instantiate (1 := x1).
  instantiate (1 := x0).
  scm.
  unfold okFieldAt in Hp; lle Hp; lli.
  instantiate (1 := x0); scm.
  assert (Hp00 : h0 ||- top ** top ** (a |->__ ** top) ** 16 + rget s rgcInfo |->_ **
    rget s rgcInfo |->, (frStart :: frEnd :: toStart :: toEnd :: nil) ** top).
  scm.
  hyr Hp (fasElim Ia' Hp); scm.
  unfold okFieldAt in Hp; lle Hp.
  exists x0; scm.
  lle Hp00; lli.
  instantiate (1 := x2); instantiate (2 := x1); instantiate (3 := x0).
  scm.
  lle Hp00.

  assert (NeqPrep : (ptrP a /\ ptrP (4 + a)) /\
    forall k, k = 0 \/ k = 4 \/ k = 8 \/ k = 12 \/ k = 16 ->
    a <> k + rget s rgcInfo /\ 4 + a <> k + rget s rgcInfo).
  constructor.
  constructor.
  apply (contElim1L Hp00).
  sconjLift2 Hp00; apply (contElim1L Hp00).
  intros k [Keq | [Keq | [Keq | [Keq | Keq]]]]; subst k;
    constructor; intro X; rewrite X in Hp00.
  sconjLift4 Hp00; simpl in Hp00; lle Hp00.
  simpl in Hp00; sconjLift2 Hp00; sconjLift4 Hp00; lle Hp00.
  sconjLift5 Hp00; lle Hp00.
  sconjLift2 Hp00; sconjLift5 Hp00; lle Hp00.
  sconjLift6 Hp00; simpl in Hp00; lle Hp00.
  sconjLift2 Hp00; simpl in Hp00; sconjLift6 Hp00; lle Hp00.
  sconjLift7 Hp00; simpl in Hp00; lle Hp00.
  sconjLift2 Hp00; simpl in Hp00; sconjLift7 Hp00; lle Hp00.
  sconjLift3 Hp00; simpl in Hp00; lle Hp00.
  sconjLift2 Hp00; simpl in Hp00; sconjLift3 Hp00; lle Hp00.

  destruct NeqPrep as [[ptrA ptrA4] NeA].
  unfold objCopiedH; unfold fieldCopiedH; lli.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  subst h0; apply (sconjImplR Hp00).
  intros hh _; lli.
  destruct (NeA 16); auto.
  sconjLift3 Hp00; apply (contElim1L Hp00).
  destruct (NeA 12); auto.
  sconjLift7 Hp00; apply (contElim1L Hp00).
  destruct (NeA 8); auto.
  sconjLift6 Hp00; apply (contElim1L Hp00).
  destruct (NeA 4); auto.
  sconjLift5 Hp00; apply (contElim1L Hp00).
  destruct (NeA 0); auto.
  sconjLift4 Hp00; apply (contElim1L Hp00).

  instantiate (1 := x1). scm.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  eapply contUnUpdateNeqTop.
  subst h0; sconjLift2 Hp00.
  apply (sconjImplR Hp00).
  intros hh _; lli.
  destruct (NeA 16); auto.
  sconjLift3 Hp00; apply (contElim1L Hp00).
  destruct (NeA 12); auto.
  sconjLift7 Hp00; apply (contElim1L Hp00).
  destruct (NeA 8); auto.
  sconjLift6 Hp00; apply (contElim1L Hp00).
  destruct (NeA 4); auto.
  sconjLift5 Hp00; apply (contElim1L Hp00).
  destruct (NeA 0); auto.
  sconjLift4 Hp00; apply (contElim1L Hp00).


  apply (sconjImplS Vhp'); clear Vhp'; intros hh S HH.
  unfold objHp in HH; eapply fasImplIS.
  apply HH.
  cbv beta; intros a hh' I' S' HH'.
  assert (S2 : Heap.subHeap hh' (heapOf s'')).
  eapply Heap.subHeapTrans; eauto.
  eapply Heap.subHeapTrans; eauto.
  eapply sconjEqSubHeap; eauto.
  clear S S'.
  hyr Wcopy (Wcopy _ I').
  assert (HHH : h0 ||- objCopiedH a (heapOf s) a ** top).
  apply objCopy; left; rewrite frEq; sui2; rewrite W'eq; sui2; assumption.
  unfold okObjAt, okFieldAt in HH'; lle HH';
    unfold objCopiedH, fieldCopiedH in Wcopy, HHH |- * .
  lle Wcopy; lle HHH.
  assert (X := contContEq H5 HHH); sconjLift2 HHH; assert (Y := contContEq H8 HHH);
    subst x4 x5; clear H5 H8 HHH.
  lli; eauto.
  assert (X := subHeapContEq S2 Wcopy HH').
  sconjLift2 Wcopy; sconjLift2of2 HH'; assert (X' := subHeapContEq S2 Wcopy HH').
  sconjLift2of2 HH'; subst x2 x3; assumption.
  sconjMatch.

  apply (fasImplI Hp1).
  unfold objIsToFwded, objIsFwded, fieldIsFwded.
  intros a hh' Ia HH; lle HH.
  destruct H6 as [v0 [HH0 Meq0]].
  destruct H7 as [v1 [HH1 Meq1]].

  rename x0 into x3.
  assert (HHH : h0 ||- objCopiedH x3 (heapOf s) x3 ** top).
  apply objCopy; left; rewrite frEq.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x3) as [_ Q].
  rewrite H1 in Q.
  assert (II : set_In x3 (M |_| M')).
  apply Q; discriminate.
  destruct (set_union_elim II); [sui1 | sui2].
  assumption.
  rewrite W'eq; sui1; assumption.
  unfold objCopiedH in HHH; unfold fieldCopiedH in HHH; lle HHH.
  lli.
  3:apply HH.
  eauto.
  exists x0; constructor.
  stSimpl; assumption.
  rewrite <- Meq0; clear Meq1.
  simpl in HH0; assert (Q := contContEq HH0 HHH).
  subst x0; reflexivity.
  exists x4; constructor.
  stSimpl; assumption.
  rewrite <- Meq1; clear Meq0.
  simpl in HH1; sconjLift2 HHH; assert (R := contContEq HH1 HHH).
  subst x4; reflexivity.

  apply (fasImplI Hp1); clear Hp1.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros a hh' Ia HH; lle HH.
  simpl in H6; simpl in H7.
  assert (HHH : h0 ||- objCopiedH x0 (heapOf s) x0 ** top).
  apply objCopy; left; rewrite frEq.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ Q].
  rewrite H1 in Q.
  assert (II : set_In x0 (M |_| M')).
  apply Q; discriminate.
  destruct (set_union_elim II); [sui1 | sui2].
  assumption.
  rewrite W'eq; sui1; assumption.
  unfold objCopiedH in HHH; unfold fieldCopiedH in HHH; lle HHH.
  lli.
  3:apply HH.
  eauto.
  assert (Q := contContEq H6 HHH).
  subst x3; assumption.
  sconjLift2 HHH; assert (R := contContEq H7 HHH).
  subst x4; assumption.

  (* now split out the part of each color that deals with objs' *)
  clear Vhp'; rename Vhp'' into Vhp'.
  assert (Vhp'' : vh'0
         ||- ((foralls x in set_inter W' objs', objCopiedH x (heapOf s) x) ** top) **
             ((foralls x in set_inter (B |_| B') objs',
              objIsToFwded (fun _ : nat => None) (map_union phi phi')
                (heapOf s, rfileOf s') x) ** top) **
             ((foralls x in set_inter (G' |_| G'') objs',
              objCopiedPhi (map_union phi phi') (heapOf s, rfileOf s') x) ** top)).
  sconjMatch.
  assert (HH : h1 ||- (foralls x in set_inter W' objs', objCopiedH x (heapOf s) x) **
    (foralls x in set_diff W' objs', objCopiedH x (heapOf s) x)).
  apply fasSplit.
  unfold hpredTrue; rewrite <- (set_inter_split W' objs'); assumption.
  apply interDiffDisj.
  sconjMatch.
  assert (HH : h1 ||- (foralls x in set_inter (B |_| B') objs', 
    objIsToFwded (fun _  => None) (map_union phi phi') (heapOf s, rfileOf s') x) **
    (foralls x in set_diff (B |_| B') objs', 
      objIsToFwded (fun _  => None) (map_union phi phi') (heapOf s, rfileOf s') x)).
  apply fasSplit.
  unfold hpredTrue; rewrite <- (set_inter_split (B |_| B') objs'); assumption.
  apply interDiffDisj.
  sconjMatch.
  assert (HH : h1 ||- (foralls x in set_inter (G' |_| G'') objs', 
    objCopiedPhi (map_union phi phi') (heapOf s, rfileOf s') x) **
    (foralls x in set_diff (G' |_| G'') objs', 
      objCopiedPhi (map_union phi phi') (heapOf s, rfileOf s') x)).
  apply fasSplit.
  unfold hpredTrue; rewrite <- (set_inter_split (G' |_| G'') objs'); assumption.
  apply interDiffDisj.
  sconjMatch.
  clear Vhp'; rename Vhp'' into Vhp'.
  lle Vhp'.
  hyr Vhp' (sconjAssocR Vhp'); hyr Vhp' (sconjAssocR Vhp').
  subst vs'; stSimpl.
  apply (sconjMapRangeImpl Vhp'); clear Vhp'; intros hh HH.
  lle HH.
  unfold hpredTrue; rewrite <- (subsetInterEq Sub').
  rewrite (set_eqvUnionSymm (G |_| B' |_| G'') W').
  rewrite Geq.
  rewrite (set_eqvUnionAssoc B G' (B' |_| G'')).
  rewrite <- (set_eqvUnionAssoc G' B' G'').
  rewrite (set_eqvUnionSymm G' B').
  rewrite <- (set_eqvUnionAssoc B (B' |_| G') G'').
  rewrite <- (set_eqvUnionAssoc B B' G').
  rewrite (set_eqvUnionAssoc (B |_| B') G' G'').
  rewrite (set_unionInterDistrib2 objs' W' ((B |_| B') |_| G' |_| G'')).
  rewrite (set_unionInterDistrib2 objs' (B |_| B') (G' |_| G'')).
  rewrite (set_interSymm objs' W').
  rewrite (set_interSymm objs' (B |_| B')).
  rewrite (set_interSymm objs' (G' |_| G'')).
  apply fasMerge.
  subst phi2.
  apply (sconjMapRangeImpl HH); clear hh HH; intros hh HH.
  apply (fasMapRangeImplI HH); clear hh HH; intros hh a Ia HH.
  destruct (set_inter_elim Ia) as [IW' Io]; clear Ia.
  subst objs'.
  destruct (set_map_elim Io) as [b [Beq Ib]]; clear Io.

  assert (ME : map_union phi phi' b = None).
  destruct Iso0 as [_ [Iso0 _]]; hyr Iso0 (Iso0 b).
  destruct (map_union phi phi' b).
  subst a0; elf; apply (set_disj_elim D' a); auto.
  reflexivity.
  rewrite ME in Beq.
  subst b.
  clear HpOrig Hp Seq Hp0Ok Hp0 Req rootOk Req'' Hp'.
  unfold objCopiedH, fieldCopiedH in HH; lle HH.
  unfold objIsFwdedH; lli.
  2:simpl; apply (sconjMapRangeImpl HH); intros hh' HH'; apply (contMapRangeImpl HH').
  clear hh HH.
  (* still working on the case for W' *)
  exists a; exists x0; exists x1.
  rewrite (set_mem_true Ib).
  rewrite (set_mem_true IW').
  constructor.
  reflexivity.

  assert (HZ : h ||- objHp objs objs).
  assert (X := heapEqvImplL Vhp0).
  exact (minObjHpElim1 X).
  hyr HZ (objHpElim Ib HZ); 
    unfold okObjAt in HZ; unfold okFieldAt in HZ; lle HZ.
  assert (XH : vs |||- (a |-> x2 ** 4 + a |-> x3 ** top)).
  destruct (aconjElim (sconjDistrib2 Vhp0)) as [_ X2]; 
    hyr X2 (sconjInsert X2 HZ).
  lle X2; sconjMatch.
  assert (XH' : vs |||- (objCopiedH a (heapOf s) a ** top) ** top).
  clear XH Vhp0; sconjMatch.
  assert (II : set_In a (rangeObjs frStart frEnd)).
  rewrite frEq; sui2; rewrite W'eq; sui2; assumption.
  hyr Hp (fasElim II Hp); scm.
  unfold objCopiedH in XH'; unfold fieldCopiedH in XH'; lle XH'.
  assert (E1 := contContEq XH XH').
  sconjLift2 XH; sconjLift2 XH'; assert (E2 := contContEq XH XH').
  subst x4 x5; clear XH XH'.
  assert (X := contContEq H3 H6); assert (Y := contContEq H4 H10);
    subst x2 x3; clear H3 H4 H6 H10.
  constructor.
  lli; sconjMatch.
  clear a IW' Ib ME HZ.
  unfold mapX; constructor.
  assert (IO := isOddOk x0); destruct (isOdd x0).
  reflexivity.
  destruct H5; clear H8.
  elf; apply (not_even_and_odd x0); assumption.
  rewrite (set_mem_true H); clear IO.
  assert (I := Sub _ H); clear H.
  destruct (set_union_elim I) as [I' | I']; clear I.
  rewrite set_mem_false.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [II _]; clear Iso0.
  destruct (map_union phi phi' x0).
  reflexivity.
  elimtype False; apply II; auto.
  intro I; apply (set_disj_elim D x0); assumption.
  rewrite (set_mem_true I').
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ II]; clear Iso0.
  destruct (map_union phi phi' x0).
  elf; apply (set_disj_elim D x0).
  apply II; discriminate.
  assumption.
  reflexivity.
  (* second field, almost same as above *)
  assert (IO := isOddOk x1); destruct (isOdd x1).
  reflexivity.
  destruct H8; clear H5.
  elimtype False; apply (not_even_and_odd x1); assumption.
  rewrite (set_mem_true H); clear IO.
  assert (I := Sub _ H); clear H.
  destruct (set_union_elim I) as [I' | I']; clear I.
  rewrite set_mem_false.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x1) as [II _]; clear Iso0.
  destruct (map_union phi phi' x1).
  reflexivity.
  elimtype False; apply II; auto.
  intro I; apply (set_disj_elim D x1); assumption.
  rewrite (set_mem_true I').
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x1) as [_ II]; clear Iso0.
  destruct (map_union phi phi' x1).
  elimtype False; apply (set_disj_elim D x1).
  apply II; discriminate.
  assumption.
  reflexivity.
  apply fasMerge.
  apply (sconjMapRangeImpl HH); clear hh HH; intros hh HH;
    apply (fasMapRangeImplI HH); clear hh HH; intros hh a Ia HH.

  (* now the black objects *)
  unfold objIsToFwded, objIsFwded, fieldIsFwded in HH; lle HH.
  unfold objIsFwdedH; lli.
  2:simpl; apply (sconjMapRangeImpl HH); intros hh' HH'; apply (contMapRangeImpl HH').
  clear hh HH.
  replace (rget (heapOf s, rfileOf s')) with (rget s') in H7; [ | reflexivity].
  replace (rget (heapOf s, rfileOf s')) with (rget s') in H6; [ | reflexivity].
  destruct H6 as [v0 [HpV0 Meq0]]; destruct H7 as [v1 [HpV1 Meq1]].
  exists x0; exists v0; exists v1.
  assert (I3 : set_In x0 (M |_| M')).
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ X]; apply X.
  rewrite H1; discriminate.
  destruct (set_inter_elim Ia) as [Ia1 Ia2]; clear Ia.
  subst objs'.
  destruct (set_map_elim Ia2) as [b [Beq Ib]]; clear Ia2.
  destruct Iso0 as [Iso0 [Iso0'' [Iso0' _]]]; destruct (Iso0 b) as [X _].
  destruct (set_union_elim (Sub _ Ib)) as [Ib' | Ib'].
  assert (Iso0'b := Iso0' x0 b); destruct (map_union phi phi' b).
  subst a0; hyr Iso0'b (Iso0'b _ H1).
  assert (x0 = b).
  apply Iso0'b; reflexivity.
  subst x0; clear Iso0'b Iso0' X.
  rewrite (set_mem_true Ib).
  rewrite set_mem_false.
  constructor.  assumption.
  assert (HZ : h ||- objHp objs objs).
  assert (X := heapEqvImplL Vhp0).
  exact (minObjHpElim1 X).
  hyr HZ (objHpElim Ib HZ); 
    unfold okObjAt in HZ; unfold okFieldAt in HZ; lle HZ.
  assert (XH : vs |||- (b |-> x0 ** 4 + b |-> x3 ** top)).
  destruct (aconjElim (sconjDistrib2 Vhp0)) as [_ X2]; 
    hyr X2 (sconjInsert X2 HZ).
  lle X2; sconjMatch.
  assert (XH' : vs |||- (objCopiedH b (heapOf s) b ** top) ** top).
  clear XH Vhp0; sconjMatch.
  assert (II : set_In b (rangeObjs frStart frEnd)).
  rewrite frEq; destruct (set_union_elim Ib') as [II | II]; clear Ib'.
  sui1; assumption.
  sui2; rewrite W'eq; sui1; assumption.
  hyr Hp1 (fasElim II Hp1); sconjMatch.
  unfold objCopiedH in XH'; unfold fieldCopiedH in XH'; lle XH'.
  assert (E1 := contContEq XH XH').
  sconjLift2 XH; sconjLift2 XH'; assert (E2 := contContEq XH XH').
  subst x4 x5; clear XH XH'.
  assert (X := contContEq HpV0 H5); assert (Y := contContEq HpV1 H9);
    subst x0 x3; clear HpV0 HpV1 H5 H9.
  constructor.
  lli; sconjMatch.
  clear a b Ia1 Ib Ib' H1 I3 HZ.
  unfold mapX in Meq0, Meq1 |- * ; constructor; [clear x2 v1 Meq1 H7 | clear x1 v0 Meq0 H4].
  assert (IO := isOddOk v0); destruct (isOdd v0).
  injection Meq0; clear Meq0; intro; subst x1; rewrite (isOddTrue IO); reflexivity.
  destruct H4; [elimtype False; apply (not_even_and_odd v0); assumption | clear IO].
  rewrite (set_mem_true H).
  unfold map_union at 1 2 in Meq0.
  assert (stEq : rget s' rtoStart = toStart).
  rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver].
  assert (endEq : rget s' rtoEnd = toEnd).
  rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver].
  rewrite stEq in Meq0; rewrite endEq in Meq0; clear stEq endEq.
  assert (Meq0' : match spaceIdMap toStart toEnd v0 with
		    | Some b => Some b
		    | None => map_union phi phi' v0 
		  end = Some x1).
  rewrite <- Meq0; destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0; rename Meq0' into Meq0.
  destruct (set_union_elim (Sub _ H)) as [I | I]; clear H.
  replace (spaceIdMap toStart toEnd v0) with (None (A := nat)) in Meq0.
  rewrite set_mem_false.
  rewrite Meq0.
  destruct (isOdd x1).
  reflexivity.
  replace (map_union phi phi' x1) with (None (A := nat)).
  reflexivity.
  symmetry.
  destruct (Iso0 x1) as [_ Q]; destruct (map_union phi phi' x1).
  hyr Meq0 (Iso0'' _ _ Meq0).
  elimtype False; apply (set_disj_elim D'' x1).
  apply Q; discriminate.
  assumption.
  reflexivity.
  intro II; apply (set_disj_elim D v0); assumption.
  rewrite (spaceIdMapEq toStart toEnd v0).
  rewrite set_mem_false.
  reflexivity.
  intro I'.
  elimtype False; apply (set_disj_elim frToDisj v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; destruct (set_union_elim I) as [II | II]; clear I.
  sui1; assumption.
  sui2; rewrite W'eq; sui1; assumption.
  assumption.
  rewrite (set_mem_true I).
  replace (spaceIdMap toStart toEnd v0) with (None (A := nat)) in Meq0.
  elimtype False; apply (set_disj_elim D v0).
  destruct (Iso0 v0) as [_ Q]; apply Q; rewrite Meq0; discriminate.
  assumption.
  rewrite (spaceIdMapEq toStart toEnd v0).
  rewrite set_mem_false.
  reflexivity.
  intro I'.
  elimtype False; apply (set_disj_elim frToDisj v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; sui2; rewrite W'eq; sui2; assumption.
  assumption.

  (* second field... *)
  rename Meq1 into Meq0; rename v1 into v0; rename x2 into x4.
  rename H7 into H4.
  assert (IO := isOddOk v0); destruct (isOdd v0).
  injection Meq0; clear Meq0; intro; subst x4; rewrite (isOddTrue IO); reflexivity.
  destruct H4; [elimtype False; apply (not_even_and_odd v0); assumption | clear IO].
  rewrite (set_mem_true H).
  unfold map_union at 1 2 in Meq0.
  assert (stEq : rget s' rtoStart = toStart).
  rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver].
  assert (endEq : rget s' rtoEnd = toEnd).
  rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver].
  rewrite stEq in Meq0; rewrite endEq in Meq0; clear stEq endEq.
  assert (Meq0' : match spaceIdMap toStart toEnd v0 with
		    | Some b => Some b
		    | None => map_union phi phi' v0 
		  end = Some x4).
  rewrite <- Meq0; destruct (spaceIdMap toStart toEnd v0); reflexivity.
  clear Meq0; rename Meq0' into Meq0.
  destruct (set_union_elim (Sub _ H)) as [I | I]; clear H.
  replace (spaceIdMap toStart toEnd v0) with (None (A := nat)) in Meq0.
  rewrite set_mem_false.
  rewrite Meq0.
  destruct (isOdd x4).
  reflexivity.
  replace (map_union phi phi' x4) with (None (A := nat)).
  reflexivity.
  symmetry.
  destruct (Iso0 x4) as [_ Q]; destruct (map_union phi phi' x4).
  hyr Meq0 (Iso0'' _ _ Meq0).
  elimtype False; apply (set_disj_elim D'' x4).
  apply Q; discriminate.
  assumption.
  reflexivity.
  intro II; apply (set_disj_elim D v0); assumption.
  rewrite (spaceIdMapEq toStart toEnd v0).
  rewrite set_mem_false.
  reflexivity.
  intro I'.
  elimtype False; apply (set_disj_elim frToDisj v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; destruct (set_union_elim I) as [II | II]; clear I.
  sui1; assumption.
  sui2; rewrite W'eq; sui1; assumption.
  assumption.
  rewrite (set_mem_true I).
  replace (spaceIdMap toStart toEnd v0) with (None (A := nat)) in Meq0.
  elimtype False; apply (set_disj_elim D v0).
  destruct (Iso0 v0) as [_ Q]; apply Q; rewrite Meq0; discriminate.
  assumption.
  rewrite (spaceIdMapEq toStart toEnd v0).
  rewrite set_mem_false.
  reflexivity.
  intro I'.
  elimtype False; apply (set_disj_elim frToDisj v0).
  apply objRangeSetRangeSubset.
  rewrite frEq; sui2; rewrite W'eq; sui2; assumption.
  assumption.
  (* done second field *)

  intro IW'.
  apply (set_disj_elim D b); assumption.

  elimtype False; apply X; auto.

  clear X.
  destruct (Iso0 b) as [_ X].
  destruct (map_union phi phi' b).
  elimtype False; apply (set_disj_elim D b).
  apply X; discriminate.
  assumption.
  clear X; subst b.
  elimtype False; apply (set_disj_elim D' a).
  assumption.
  destruct (set_union_elim Ia1) as [I | I].
  sui1; rewrite Geq; sui1; assumption.
  sui2; sui1; assumption.

  (* now, the case for the gray objects *)
  destruct (set_inter_elim Ia) as [I I']; clear Ia.
  unfold objCopiedPhi in HH; unfold objCopied in HH; unfold fieldCopied in HH; lle HH.
  unfold objIsFwdedH; lli.
  2:simpl; apply (sconjMapRangeImpl HH); intros hh' HH'; apply (contMapRangeImpl HH').
  clear HH.
  exists x0; exists x1; exists x2.
  assert (I3 : set_In x0 (M |_| M')).
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ X]; apply X;
    rewrite H1; discriminate.
  destruct (set_map_elim I') as [b [Beq Ib]]; clear I'.
  assert (Beq' : b = x0).
  destruct Iso0 as [_ [Iso0' [Iso0 _]]]; eapply Iso0.
  2:eauto.
  destruct (map_union phi phi' b).
  subst a0; reflexivity.
  hyr Iso0' (Iso0' x0 a); rewrite H1 in Iso0'.
  assert (II : set_In a (G |_| B' |_| G'')).
  auto.
  clear Iso0'; elimtype False; subst b; 
    destruct (set_union_elim (Sub _ Ib)) as [I' | I']; clear Ib.
  elimtype False; apply (set_disj_elim D'' a); assumption.
  elimtype False; apply (set_disj_elim D' a); assumption.
  
  subst x0; clear Beq.
  rewrite (set_mem_true Ib).
  rewrite set_mem_false.
  constructor.
  assumption.
  assert (HZ : h ||- objHp objs objs).
  assert (X := heapEqvImplL Vhp0).
  exact (minObjHpElim1 X).
  hyr HZ (objHpElim Ib HZ); 
    unfold okObjAt in HZ; unfold okFieldAt in HZ; lle HZ.
  assert (XH : vs |||- (b |-> x0 ** 4 + b |-> x3 ** top)).
  destruct (aconjElim (sconjDistrib2 Vhp0)) as [_ X2]; 
    hyr X2 (sconjInsert X2 HZ).
  lle X2; sconjMatch.
  assert (XH' : vs |||- (objCopiedH b (heapOf s) b ** top) ** top).
  clear XH Vhp0; sconjMatch.
  assert (II : set_In b (rangeObjs frStart frEnd)).
  rewrite frEq; destruct (set_union_elim I3) as [II | II]; clear I I3.
  sui1; assumption.
  sui2; rewrite W'eq; sui1; assumption.
  hyr Hp1 (fasElim II Hp1); sconjMatch.
  unfold objCopiedH in XH'; unfold fieldCopiedH in XH'; lle XH'.
  assert (E1 := contContEq XH XH').
  sconjLift2 XH; sconjLift2 XH'; assert (E2 := contContEq XH XH').
  subst x4 x5; clear XH XH'.
  assert (X := contContEq H5 H6); assert (Y := contContEq H7 H11);
    subst x0 x3; clear H5 H7 H6 H11.
  constructor.
  lli; sconjMatch.
  clear a b I Ib H1 I3 HZ.
  unfold mapX; constructor.
  (* first field *)
  rename x1 into x0; rename H4 into H5; clear H9.
  assert (IO := isOddOk x0); destruct (isOdd x0).
  reflexivity.
  destruct H5.
  elimtype False; apply (not_even_and_odd x0); assumption.
  rewrite (set_mem_true H); clear IO.
  assert (I := Sub _ H); clear H.
  destruct (set_union_elim I) as [I' | I']; clear I.
  rewrite set_mem_false.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [II _]; clear Iso0.
  destruct (map_union phi phi' x0).
  reflexivity.
  elimtype False; apply II; auto.
  intro I; apply (set_disj_elim D x0); assumption.
  rewrite (set_mem_true I').
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ II]; clear Iso0.
  destruct (map_union phi phi' x0).
  elimtype False; apply (set_disj_elim D x0).
  apply II; discriminate.
  assumption.
  reflexivity.  
  (* second field *)
  rename x2 into x0; rename H9 into H5; clear H4.
  assert (IO := isOddOk x0); destruct (isOdd x0).
  reflexivity.
  destruct H5.
  elimtype False; apply (not_even_and_odd x0); assumption.
  rewrite (set_mem_true H); clear IO.
  assert (I := Sub _ H); clear H.
  destruct (set_union_elim I) as [I' | I']; clear I.
  rewrite set_mem_false.
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [II _]; clear Iso0.
  destruct (map_union phi phi' x0).
  reflexivity.
  elimtype False; apply II; auto.
  intro I; apply (set_disj_elim D x0); assumption.
  rewrite (set_mem_true I').
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ II]; clear Iso0.
  destruct (map_union phi phi' x0).
  elimtype False; apply (set_disj_elim D x0).
  apply II; discriminate.
  assumption.
  reflexivity.  
  (* done second field.  now do some misc cleanup *)
  intro II; apply (set_disj_elim D b); assumption.
  apply (fasFasDisj' HH); clear hh HH.
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded.
  intros hh z HH; llei HH.
  instantiate (1 := x1); scm.
  unfold objCopiedPhi, objCopied, fieldCopied.
  intros hh z HH; llei HH.
  instantiate (1 := x1); scm.
  eapply fasFasDisj'.
  instantiate (3 := hh); scm.
  instantiate (1 := (fun x => x |->_ ** top)).
  apply fasMerge; sconjMatch.
  eapply fasImpl.
  apply Hp1.
  unfold objIsToFwded, objIsFwded, fieldIsFwded; cbv beta; intros z hz Hz; llei Hz.
  instantiate (1 := x1); scm.
  eapply fasImpl.
  apply Hp1.
  unfold objCopiedPhi, objCopied, fieldCopied.
  intros z hz Hz; llei Hz.
  instantiate (1 := x1) ;scm.
  apply (fasFasDisj' Hp1).
    unfold objIsToFwded, objIsFwded, fieldIsFwded; cbv beta; intros z hz Hz; llei Hz.
    instantiate (1 := x1); scm.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  unfold objCopiedH; unfold fieldCopiedH.
  intros z hz Hz; lle Hz; lli.
  instantiate (1 := x0); scm.
  intros; assumption.
  lli.

  (* show the final heap is well-formed *)
  exists frStart; exists frEnd; exists toStart; exists toEnd.
  exists (rget s'' rscan); exists (rget s'' rfree); exists (rget s'' ralloc).
  replace (rget s' rtoEnd) with toEnd in LE'; 
    [ | rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver]].
  assert (allocEq' : rget s' ralloc = toEnd).
  rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver].
  rewrite allocEq' in F'eq; rewrite allocEq' in LE'; 
    rewrite allocEq' in Al'; rewrite allocEq' in allocEq''.
  stSimpl.
  set (al' := rget s'' ralloc) in * .
  constructor.
  subst vs'; reflexivity.
  rewrite <- (Req'' rgcInfo); [stSimpl | regNotInListSolver].
  rewrite <- (Req'' rroot); [stSimpl | regNotInListSolver].
  rewrite <- Req; [stSimpl | regNotInListSolver].
  constructor.

  rewrite v0Eq''.
  constructor.
  apply rangeObjsIntro with 0; omega.
  rename al' into alloc'.
  rename vh'0 into h'.
  constructor.
  assert (EE : Heap.get h' alloc' = None).
  assert (X : Heap.get h' alloc' = None \/ exists v, Heap.get h' alloc' = Some v).
  destruct (Heap.get h' alloc'); [right | left].
  econstructor; reflexivity.
  reflexivity.
  destruct X as [X | [v X]].
  assumption.
  hyr Hp' (sconjInsert Hp' (contIntro2 _ _ X)).
  lle Hp'; sconjLift4 Hp'; lle Hp'.
  assert (Q := Heap.HeapMap.map_mapRangeGetEq h' (div4 alloc')
    (fun x : POnat.OneTypeNat.B =>
            match mapX (map_union phi phi') x with
            | Some y => y
            | None => x
            end)).
  unfold Heap.get in EE |- * .
  destruct (isPtr alloc').
  rewrite EE in Q; subst vs'; stSimpl; exact Q.
  reflexivity.
  assert (EE : Heap.get h' (4 + alloc') = None).
  assert (X : Heap.get h' (4 + alloc') = None \/ exists v, Heap.get h' (4 + alloc') = Some v).
  destruct (Heap.get h' (4 + alloc')); [right | left].
  econstructor; reflexivity.
  reflexivity.
  destruct X as [X | [v X]].
  assumption.
  hyr Hp' (sconjInsert Hp' (contIntro2 _ _ X)).
  lle Hp'; sconjLift5 Hp'; lle Hp'.
  assert (Q := Heap.HeapMap.map_mapRangeGetEq h' (div4 (4 + alloc'))
    (fun x : POnat.OneTypeNat.B =>
            match mapX (map_union phi phi') x with
            | Some y => y
            | None => x
            end)).
  unfold Heap.get in EE |- * .
  destruct (isPtr (4 + alloc')).
  rewrite EE in Q; subst vs'; stSimpl; exact Q.
  assumption.

  exists (map_union phi phi'); exists W'; exists (M |_| M').
  constructor.
  simpl; intuition.
  destruct AlFr0 as [k1 X1]; destruct alFr'' as [k2 X2]; destruct AlScFr'' as [k3 X0].
  exists ((k1 + k2) - k3).
  replace (toStart + 8 * (k1 + k2 - k3)) with 
    (((toStart + 8 * k1) + 8 * k2) - 8 * k3); omega.
  rewrite allocEq''; exists 1; omega.
  constructor.
  assumption.

  assert (BGeq : set_eqv ((B |_| B') |_| G' |_| G'') (G |_| B' |_| G'')).
  rewrite (set_eqvUnionAssoc B B' (G' |_| G'')).
  rewrite <- (set_eqvUnionAssoc B' G' G'').
  rewrite (set_eqvUnionSymm B' G').
  rewrite (set_eqvUnionAssoc G' B' G'').
  rewrite <- (set_eqvUnionAssoc B G' (B' |_| G'')).
  rewrite <- Geq; apply set_eqvRefl.

  constructor.
  rewrite frEq; rewrite (set_eqvUnionSymm M M');
    rewrite <- (set_eqvUnionAssoc W' M' M); rewrite (set_eqvUnionSymm W' M');
      rewrite <- W'eq; rewrite (set_eqvUnionSymm M W); apply set_eqvRefl.
  destruct BBeq as [BBeq LE9].
  intros B0 B0' G0 toObjs0.

  assert (B0'eq : set_eqv B0' (set_add al' empty_set)).
  subst B0'; rewrite allocEq''.
  rewrite (set_eqvEmptyRangeObjs (8 + al')); apply set_eqvSymm.
  replace (al' + 8) with (8 + al'); [apply rangeObjsStartAdd | omega].
  apply aligned8Refl.

  assert (Beq : set_eqv B0 (B |_| B')).
  subst B0.
  clear B0' G0 toObjs0 B0'eq.
  rewrite BBeq; rewrite <- Req; [stSimpl | regNotInListSolver]; apply set_eqvRefl.

  assert (GGeq : set_eqv G0 (G' |_| G'')).
  assert (AL8 : aligned8 (rget s'' rfree) toEnd).
  apply aligned8LE_L with toStart.
  eapply aligned8Trans; eauto.
  eapply aligned8Trans; eauto.
  omega.
  assert (NE : rget s'' rfree <> toEnd).
  rewrite allocEq''; omega.
  subst G0 B0; clear toObjs0 Seq Req.
  apply set_eqvSymm; eapply rangeSplit'.
  instantiate (1 := toStart).
  rewrite Beq.
  (* set_disj (B |_| B') (G' |_| G'') *)
  sconjLift3of3 Vhp'; sconjLift3of3 Vhp'; apply (fasFasDisj Vhp').
  unfold objIsToFwded, objIsFwded, fieldIsFwded;
    cbv beta; intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  unfold objCopiedPhi, objCopied, fieldCopied.
  intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); sconjMatch.
  rewrite Beq.
  eapply rangeSplit.
  instantiate (1 := toEnd).
  rewrite (rangeObjsEndSplit AL8 NE).
  replace (toEnd - 8) with al'; [idtac | omega].
  2:omega.
  rewrite <- F''eq.
  2:rewrite (rangeObjsEndSplit AL8 NE).
  2:replace (toEnd - 8) with al'; [idtac | omega]; rewrite <- F''eq.
  (* set_disj ((B |_| B') |_| G' |_| G'') (set_add al' F'') *)
  hyr Hp' (sconjInsert Hp' Vhp'); lle Hp'; clear Vhp'.
  assert (HpX : s'' |||- (foralls x in set_add al' F'', x |->_ ** top) **
    (foralls x in ((B |_| B') |_| G' |_| G''), x |->_ ** top) ** top).
  sconjLift5 Hp'; sconjLift4 Hp'; sconjLift4 Hp'; hyr Hp' (sconjAssocR Hp').
  sconjLift2 Hp'; sconjLift6 Hp'; hyr Hp' (sconjAssocR Hp'); 
    sconjLift5 Hp'; hyr Hp' (sconjAssocR Hp'); scm.
  hyr Hp1 (sconjAssocR Hp1); apply fasIntro; llMatch.
  lli; scm.
  lleim.
  intro I; assert (HX : h ||- (al' |-> 1 ** top) ** ((al' |->_ ** top) ** top)).
  scm; hyr Hp1 (fasElim I Hp1); scm.
  lle HX.
  apply fasMerge; sconjMatch.
  eapply fasImpl.
  apply Hp1.
  unfold objIsToFwded, objIsFwded, fieldIsFwded;
    cbv beta; intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  eapply fasImpl.
  apply Hp1.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  apply (fasFasDisj' Hp1).
  unfold objIsToFwded; unfold objIsFwded; unfold fieldIsFwded;
    cbv beta; intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  unfold objCopiedPhi; unfold objCopied; unfold fieldCopied.
  intros z hz Hz; lle Hz; lli.
  instantiate (1 := x1); scm.
  apply set_disjSymm; apply (fasFasDisj HpX); auto.
  rewrite toEq; rewrite F'eq'; rewrite BGeq.
  rewrite <- (set_eqvUnionAssoc G (B' |_| G'') (set_add al' F'')); apply set_eqvRefl.
  eapply aligned8Trans; eauto.
  eapply aligned8LE_R.
  2:eauto.
  eapply aligned8Trans; eauto.
  omega.

  assert (toEq0 : set_eqv toObjs0 (B0 |_| G0 |_| (set_add al' empty_set))).
  subst toObjs0; rewrite B0'eq; apply set_eqvRefl.

  constructor.
  rewrite Beq; rewrite GGeq; rewrite BGeq; assumption.
  constructor.
  rewrite toEq0; rewrite Beq; rewrite GGeq.
  unfold mapX in MeqRoot''.
  assert (IO := isOddOk (rget s rroot)).
  destruct (isOdd (rget s rroot)); [left | right].
  injection MeqRoot''; intro; subst x; assumption.
  unfold map_union in MeqRoot''.
  assert (Z := set_memSpaceIdMap toStart toEnd (rget s rroot)).
  destruct rootOk.
  elf; apply (not_even_and_odd (rget s rroot)); assumption.
  rewrite set_mem_false in Z.
  rewrite Z in MeqRoot''.
  destruct Iso0 as [_ [Q _]]; unfold map_union in Q; hyr Q (Q (rget s rroot)).
  rewrite MeqRoot'' in Q; 
    rewrite <- (set_eqvUnionAssoc (B |_| B') (G' |_| G'') (set_add al' empty_set));
      rewrite BGeq; sui1; apply Q; reflexivity.
  intro; apply (set_disj_elim frToDisj (rget s rroot)).
  apply objRangeSetRangeSubset; assumption.
  assumption.
  
  (* showed the root was okay, now show the heap is okay *)
  constructor.
  hyr Hp' (sconjInsert Hp' Vhp'); clear Vhp' Req'' Hp.

  assert (MWdisj : set_disj (M |_| M') W').
  sconjLift2 Hp'; unfold mapHp in Hp'; lle Hp'; unfold objHp in Hp';
    apply (fasFasDisj Hp').
  intros hh z Hp; llei Hp.
  instantiate (1 := x0); scm.
  unfold okObjAt, okFieldAt; intros hh z Hp; lle Hp; lli.
  instantiate (1 := x0); scm.

  sconjLift2 Hp'; apply (sconjImplR Hp'); clear Hp'; intros h Hp.
  apply sconjAssocL in Hp.
  apply (sconjImplR Hp); clear h Hp; intros h Hp.
  apply sconjAssocL in Hp.
  sconjLift4 Hp; hyr Hp (sconjAssocR Hp); apply (sconjImpl Hp); clear h Hp; intros h Hp.
  sconjLift2of2 Hp; apply objHpMerge; scm.
  unfold hpredTrue; rewrite toEq0; rewrite Beq; rewrite GGeq; 
    simpl; rewrite <- hpredTrueEq.
  unfold objIsToFwded in Hp.
  replace (rget (h0, rfileOf s')) with (rget s') in Hp; [idtac | reflexivity].
  replace (rget s' rtoStart) with toStart in Hp; [idtac | rewrite <- Req;
    [reflexivity | regNotInListSolver]].
  replace (rget s' rtoEnd) with toEnd in Hp; [idtac | rewrite <- Req;
    [reflexivity | regNotInListSolver]].
  assert (Hp0' : (h0, rfileOf s') |||- 
    objHp (rangeObjs frStart frEnd) (rangeObjs frStart frEnd) ** top).
  clear Hp0Ok; sconjLift2 Hp0; scm.
  assert (EE : set_eqv (rangeObjs frStart frEnd) (rangeObjs frStart frEnd |_| empty_set)).
  rewrite (set_eqvUnionSymm (rangeObjs frStart frEnd) empty_set); simpl; apply set_eqvRefl.
  unfold hpredTrue in Hp0.
  setoid_replace (rangeObjs frStart frEnd |_| empty_set) with (rangeObjs frStart frEnd) in Hp0.
  assumption.
  apply set_eqvSymm; assumption.
  apply objHpWeaken with ((B |_| B') |_| (G' |_| G'')).
  eapply objHpFwded'.
  apply Hp0'.
  apply Hp.
  instantiate (1 := M |_| M').
  rewrite BGeq; auto.
  intros y Iy; rewrite frEq; rewrite W'eq.
  rewrite <- (set_eqvUnionAssoc M M' W'); sui1; assumption.
  intros y Iy; unfold map_union; rewrite spaceIdMapNone.
  reflexivity.
  intro Iy'; apply (set_disj_elim frToDisj y).
  apply objRangeSetRangeSubset; assumption.
  assumption.
  intros y Ix; rewrite <- (set_eqvUnionAssoc (B |_| B') (G' |_| G'') (set_add al' empty_set));
    sui1; assumption.

  (* show the new object is okay *)
  unfold hpredTrue; rewrite B0'eq; hyr Hp (unitIR Hp); apply objHpIntro; scm.
  simpl in Hp; hpunfold; lli.
  left; constructor; constructor.
  2:left; constructor; constructor.
  scm.

  apply (sconjImpl Hp); clear h Hp; intros h Hp.

  (* G' and G'' *)
  apply objHpWeaken with ((W' |_| M |_| M') |_| (B |_| B') |_| (G' |_| G'')).
  unfold hpredTrue; rewrite GGeq; rewrite <- hpredTrueEq.
  eapply objHpIso'.
  eauto.
  2:eauto.
  instantiate (1 := top); stSimpl.
  assert (Hp00 : h0 ||- (objHp (rangeObjs frStart frEnd) (M |_| M') ** 
    objHp (rangeObjs frStart frEnd) W') ** top).
  clear Hp0Ok; sconjLift2 Hp0; sconjMatch.
  apply objHpSplit.
  unfold hpredTrue; rewrite (set_eqvUnionEmptyUnit (rangeObjs frStart frEnd));
    rewrite (set_eqvUnionSymm empty_set (rangeObjs frStart frEnd)).
  rewrite (set_eqvUnionAssoc M M' W'); rewrite <- W'eq; rewrite <- frEq; assumption.
  assumption.
  clear Hp0 Hp0Ok; lle Hp00; scm.
  apply (objHpWeaken Hp0).
  rewrite frEq; rewrite W'eq.
  rewrite (set_eqvUnionSymm W' (M |_| M')).
  rewrite (set_eqvUnionAssoc M M' W').
  intros y Iy; sui1; assumption.
  rewrite <- BGeq.
  intros y Iy; sui2; assumption.
  intros y Iy; rewrite toEq0; destruct (set_union_elim Iy) as [Iz | Iz]; clear Iy.
  sui1; assumption.
  sui2; rewrite <- (set_eqvUnionAssoc B0 G0 (set_add al' empty_set));
    sui1; rewrite Beq; rewrite GGeq; assumption.
  (* F', rgcInfo and A *)
  apply (sconjImpl Hp); clear h Hp; intros h Hp.
  unfold hpredTrue; rewrite <- F''eq; assumption.
  unfold gcHpPtrMem' in Hp.
  sconjLift2 Hp; lleim.

  
(* finally, show the virtual heap is okay, using the technical lemma from above *)
  assert (vs' |||- (foralls x0 in (B |_| B'), objCopiedH x0 (heapOf s'') x0) **
        (foralls x0 in G0 |_| W',
         objRespMapH (map_union (map_union phi phi') (Some (A := nat))) (heapOf s'') x0)).
  subst vs'; stSimpl.
  sconjLift4 Hp.
  eapply bakerAllocFlipVHeapCopyOk.
  instantiate (1 := M |_| M').
  instantiate (1 := frEnd).
  instantiate (1 := frStart).
  rewrite (set_eqvUnionAssoc M M' W'); rewrite <- W'eq; eauto.
  instantiate (1 := set_add al' F'').
  instantiate (1 := toEnd).
  instantiate (1 := toStart).
  rewrite GGeq.
  rewrite <- (set_eqvUnionAssoc (B |_| B') (G' |_| G'') (set_add al' F'')); rewrite BGeq.
  rewrite (set_eqvUnionAssoc G (B' |_| G'') (set_add al' F'')); rewrite <- F'eq'; eauto.
  assumption.
  instantiate (1 := h0); sconjMatch.
  eauto.
  sconjMatch.
  eapply fasImpl.
  eauto.
  clear h Hp1; unfold objIsToFwded, objIsFwded, objIsFwdedH.
  unfold fieldIsFwded; stSimpl; intros y h HpY; llei HpY.
  2:simpl; eauto.
  destruct H6 as [v0 [Hp0' Meq0]]; destruct H7 as [v1 [Hp1 Meq1]].
  exists x0; exists v0; exists v1.
  constructor.
  unfold map_union at 1; rewrite (spaceIdMapEq toStart toEnd x0).
  rewrite set_mem_false.
  assumption.
  intro I; apply (set_disj_elim frToDisj x0).
  apply objRangeSetRangeSubset; rewrite frEq.
  assert (IM : set_In x0 (M |_| M')).
  destruct Iso0 as [Iso0 _]; destruct (Iso0 x0) as [_ Z]; apply Z; rewrite H1;
    discriminate.
  destruct (set_union_elim IM) as [I' | I'].
  sui1; assumption.
  rewrite W'eq; sui2; sui1; assumption.
  assumption.
  
  constructor.
  lli; apply contContCombine; auto.
  omega.
  constructor.
  clear v1 Hp1 Meq1 Hp1 HpY.
  unfold mapX in Meq0 |- *; destruct (isOdd v0).
  assumption.
  unfold map_union at 1 2 in Meq0.
  replace (rget (h0, rfileOf s')) with (rget s') in Meq0; [idtac | reflexivity].
  replace (rget s' rtoStart) with toStart in Meq0; 
    [ | rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver]].
  replace (rget s' rtoEnd) with toEnd in Meq0;
    [ | rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver]].
  unfold map_union; destruct (spaceIdMap toStart toEnd v0); assumption.
  unfold mapX in Meq1 |- *; destruct (isOdd v1).
  assumption.
  unfold map_union at 1 2 in Meq1.
  replace (rget (h0, rfileOf s')) with (rget s') in Meq1; [idtac | reflexivity].
  replace (rget s' rtoStart) with toStart in Meq1; 
    [idtac | rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver]].
  replace (rget s' rtoEnd) with toEnd in Meq1;
    [idtac | rewrite <- Req; [stSimpl; reflexivity | regNotInListSolver]].
  unfold map_union; destruct (spaceIdMap toStart toEnd v1); assumption.
  unfold hpredTrue; rewrite GGeq; apply Hp1.
  rewrite GGeq; rewrite BGeq; assumption.
  subst vs'; scm.
  set (mphi := fun x : POnat.OneTypeNat.B => 
    match mapX (map_union phi phi') x with | Some y => y
          | None => x end) in * .

  assert (H' : 
    Heap.uset (Heap.uset (Heap.HeapMap.map_mapRange mphi vh'0) al' 1) (4 + al') 1
    ||- 4 + al' |-> 1 ** al' |-> 1 ** 
    (foralls x0 in B |_| B', objCopiedH x0 (heapOf s'') x0) **
    (foralls x0 in G0 |_| W',
      objRespMapH (map_union (map_union phi phi') (Some (A:=nat))) (heapOf s'') x0)).
  sconjLift4 Hp'; lle Hp'.
  apply heapAddOk.
  apply heapAddOk.
  assumption.
  apply (contElim1L Hp').
  2:sconjLift2 Hp'; apply (contElim1L Hp').
  intro Q; lle Q; assert (Q' : vh'0 ||- al' |->_ ** top).
  assert (X := contGetEqL Q); clear Q.
  assert (exists z, Heap.get vh'0 al' = Some z).
  unfold Heap.get in X |- * .
  destruct (isPtr al').
  2:discriminate X.
  assert (Y := Heap.HeapMap.map_mapRangeGetEq vh'0 (div4 al') mphi).
  destruct (Heap.HeapMap.map_get vh'0 (div4 al')).
  econstructor; reflexivity.
  rewrite X in Y; discriminate Y.
  destruct H0 as [z H0eq].
  lli; instantiate (1 := z).
  apply contIntro2; eauto.
  sconjLift3 Hp'; hyr Hp' (sconjInsert Hp' Q'); lle Hp'.
  intro Q; lle Q; assert (Q' : vh'0 ||- 4 + al' |->_ ** top).
  assert (X := contGetEqL Q); clear Q.
  assert (exists z, Heap.get vh'0  (4 + al') = Some z).
  unfold Heap.get in X |- * .
  destruct (isPtr (4 + al')).
  2:discriminate X.
  unfold Heap.uset in X.
  rewrite Heap.HeapMap.MAD.getAddNeq in X.
  assert (Y := Heap.HeapMap.map_mapRangeGetEq vh'0 (div4 (4 + al')) mphi).
  destruct (Heap.HeapMap.map_get vh'0 (div4 (4 + al'))).
  econstructor; reflexivity.
  rewrite X in Y; discriminate Y.
  rewrite div4plus; omega.
  destruct H0 as [z H0eq].
  lli; instantiate (1 := z).
  apply contIntro2; eauto.
  sconjLift3 Hp'; hyr Hp' (sconjInsert Hp' Q'); sconjLift3 Hp'; lle Hp'.

  clear H.
  rewrite v0Eq''.
  replace (heapOf (uhset (uhset (Heap.HeapMap.map_mapRange mphi vh'0, rfileOf s'') al' 1)
     (4 + al') 1)) with
  (Heap.uset (Heap.uset (Heap.HeapMap.map_mapRange mphi vh'0) al' 1) (4 + al') 1);
  [idtac | reflexivity].
  sconjLift2 H'; hyr H' (sconjAssocR (sconjAssocR H')); scm.
  sconjLift2of2 Hp1; unfold hpredTrue; rewrite Beq; rewrite B0'eq; apply fasMerge.
  scm.
  hyr Hp1 (unitIR Hp1); apply fasIntro; scm.
  sconjLift4 Hp'; lle Hp'; hpunfold; lli.
  2:eauto.
  scm.
  sconjLift2 Hp'; scm.
  assert (HH : h ||- fasd (B |_| B') ** fasd (set_add al' empty_set)).
  llMatch.
  hpunfoldIn Hp1; lleim.
  hyr Hp1 (unitIR Hp1); apply fasIntro; scm; lli; scm.
  apply (fasFasDisj' HH); auto.

  (* show the registers are okay *)
  destruct (Guar _ HpX) as [_ [_ [Req' [raEq [allocEq v0Eq]]]]]; 
    clear Guar0 Guar Hp' HpX.
  generalize dependent raEq; generalize dependent allocEq; stSimpl; intro; intro.
  constructor.

  unfold calleeSavedOk; unfold calleeSaved.
  intros r E.
  destruct (regCompare r ra).
  subst r; rewrite raEq; rewrite <- Req; [stSimpl | regNotInListSolver]; reflexivity.
  simpl in E.
  rewrite <- Req'; clear Req'.
  intuition; try (elf; assumption); subst r; stSimpl; 
    try (rewrite <- Req; [stSimpl | regNotInListSolver]; try reflexivity).
  intuition; try (elf; assumption); subst r; try regNotInListSolver.
  rewrite raEq; rewrite <- Req; [stSimpl | regNotInListSolver]; reflexivity.

  (* the other case, where we don't need to flip before entering the loop *)
  eapply bakerLoopNoFlip.
  assumption.
  assumption.
  assumption.
  assumption.
  assumption.
  eauto.
  eauto.
  assumption.
  2:assumption.
  exact Hp.
Qed.
